#include	"CAN_LLP.h"
#include  "CAN_PeriphDefinitions.h"
#include  "NVIC.h"
#include  "IDMap.h"
#include  "PanelGlobalVars.h"
#include  "PanelDefinitions.h"
#include  "CAN.h"
/*======================================================================================*/
void	ClearCANRxMsg	(CAN_DATA_STRUCTURE *CAN_LLPx)
{
uint8_t	i;

	CAN_LLPx->RxMessage.StdId = 0;
    CAN_LLPx->RxMessage.ExtId = 0;
    CAN_LLPx->RxMessage.RTR = CAN_RTR_DATA;
    CAN_LLPx->RxMessage.IDE = CAN_ID_STD;
    CAN_LLPx->RxMessage.DLC = 0;
	for	(i=0; i<8;i++)
		CAN_LLPx->RxMessage.Data[i]=0;
}
/*======================================================================================*/
void	ClearCANTxMsg	(CAN_DATA_STRUCTURE *CAN_LLPx)
{ 
uint8_t	i;

	CAN_LLPx->TxMessage.StdId = 0;
    CAN_LLPx->TxMessage.ExtId = 0;
    CAN_LLPx->TxMessage.RTR = CAN_RTR_DATA;
    CAN_LLPx->TxMessage.IDE = CAN_ID_STD;
	CAN_LLPx->TxMessage.DLC = 0;
    for	(i=0; i<8;i++)
		CAN_LLPx->TxMessage.Data[i]=0;

}
/*======================================================================================*/ 
void	CANConfig	(void)
{
	NVIC_CAN_Configuration();
	Init_GPIO_CAN(GPIO_Remap2_CAN1,CAN_PIN_TX,CAN_PIN_RX,CAN_GPIO);
	Init_CAN(CAN_LLP_N,CAN_SPEED);
	CAN_ITConfig(CAN_LLP_N, CAN_IT_FMP0, ENABLE);
	CAN_ITConfig(CAN_LLP_N, CAN_IT_FF0,  ENABLE);
	CAN_ITConfig(CAN_LLP_N, CAN_IT_FOV0, ENABLE);
  	CAN_ITConfig(CAN_LLP_N, CAN_IT_TME,  ENABLE);
	ClearCANRxMsg(&CAN_LLP1);
	ClearCANTxMsg(&CAN_LLP1);
}
/*======================================================================================*/
void	CAN_LLP	(CAN_DATA_STRUCTURE *CAN_LLPx,CAN_TypeDef* CANx)   //   
{
	if (CAN_LLPx->CAN_RxRdy)							  //  
		{
		   CAN_LLPx->CAN_RxRdy=0;
		}
	if ((CAN_LLPx->CAN_RspRdy)&&(!CAN_LLPx->CAN_TxRdy))	 //    
		{
		 	CAN_Transmit(CAN_LLP_N,&(CAN_LLPx->TxMessage));
			CAN_LLPx->CAN_TxRdy=1; 
		}
}
/*======================================================================================*/
void	CAN_RemoteResponse	(CAN_DATA_STRUCTURE *CAN_LLPx)	   //      1 
{ // 
	ClearCANTxMsg(CAN_LLPx);
	CAN_LLPx->TxMessage.StdId=CAN_LLPx->RxMessage.StdId;
	CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
   	CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
	CAN_LLPx->TxMessage.DLC=2;
	CAN_LLPx->TxMessage.Data[0]=CAN_LLPx->RxMessage.StdId;
	CAN_LLPx->TxMessage.Data[1]=CAN_LLPx->RxMessage.StdId>>8;
	CAN_LLPx->CAN_RspRdy=1; 
}
/*======================================================================================*/
void	CAN_LLP_DataMaster	(CAN_DATA_STRUCTURE *CAN_LLPx,uint32_t	CAN_LLP_ID)
{ 
static	uint8_t	nPacket=1;

	  ClearCANTxMsg(CAN_LLPx);
	  CAN_LLPx->TxMessage.StdId=CAN_LLP_ID;
	  switch (CAN_LLP_ID)
			{
			case	GET_ALL_CAN:	{	
										CAN_LLPx->TxMessage.RTR=CAN_RTR_REMOTE;
   										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=0;
										CHALLENGE_FLAG=0;
									}	break;
			case	CONTROLS_CAN:	{
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
   										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=7;
										CAN_LLPx->TxMessage.Data[0]=Controls.Injects;
										CAN_LLPx->TxMessage.Data[1]=Controls.Injects>>8;
										CAN_LLPx->TxMessage.Data[2]=Controls.Injects>>16;
										CAN_LLPx->TxMessage.Data[3]=Controls.Injects>>24;
										CAN_LLPx->TxMessage.Data[4]=Controls.PumpSpeedManual;
										CAN_LLPx->TxMessage.Data[5]=Controls.PumpSpeedManual>>8;
										CAN_LLPx->TxMessage.Data[6]=Controls.TCMode|(Controls.BitumenBackValve<<2)|(Controls.HeatingManual<<3);
								   	}	break;
			case	RECEIPT_CAN:	 {
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
   										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=8;
										switch(CommandCode)
													{
														case 0x14:CAN_LLPx->TxMessage.Data[0]=0;break;
														case 0x15:CAN_LLPx->TxMessage.Data[0]=1;break;
														case 0x16:CAN_LLPx->TxMessage.Data[0]=2;break;
														case 0x17:CAN_LLPx->TxMessage.Data[0]=3;break;
													}
										CAN_LLPx->TxMessage.Data[1]=(SystemBoardConfig.Receipt.nReceipt<<4)|(SystemBoardConfig.Receipt.Material|(SystemBoardConfig.Receipt.Unit<<1));
										CAN_LLPx->TxMessage.Data[2]=SystemBoardConfig.Receipt.nFillingRate*100;
										CAN_LLPx->TxMessage.Data[3]=(uint16_t)(SystemBoardConfig.Receipt.nFillingRate*100)>>8;
										CAN_LLPx->TxMessage.Data[4]=SystemBoardConfig.Receipt.InjectConfig;
										CAN_LLPx->TxMessage.Data[5]=SystemBoardConfig.Receipt.InjectConfig>>8;
										CAN_LLPx->TxMessage.Data[6]=SystemBoardConfig.Receipt.InjectConfig>>16;
										CAN_LLPx->TxMessage.Data[7]=SystemBoardConfig.Receipt.InjectConfig>>24;			
									 }	break;				
			case	TC_PARAMS_CAN:{	
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=8;
										//CAN_LLPx->TxMessage.ExtId=Actuators.Injects.InjectWidth;
										CAN_LLPx->TxMessage.Data[0]=SystemBoardConfig.MinBitumTemp;
										CAN_LLPx->TxMessage.Data[1]=SystemBoardConfig.MaxBitumTemp;
										CAN_LLPx->TxMessage.Data[2]=SystemBoardConfig.MinBurnTemperature;
										CAN_LLPx->TxMessage.Data[3]=SystemBoardConfig.MaxBurnTemperature;
										CAN_LLPx->TxMessage.Data[4]=SystemBoardConfig.MinAutoSpeed;
										CAN_LLPx->TxMessage.Data[5]=SystemBoardConfig.MaxAutoSpeed;
										CAN_LLPx->TxMessage.Data[6]=SystemBoardConfig.MinBitumLevel;
										CAN_LLPx->TxMessage.Data[7]=SystemBoardConfig.MaxBitumLevel;
									}	break;
			case	ADC_CNG_CAN:  	{
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=8;
										CAN_LLPx->TxMessage.Data[0]=dADC1.ADCCalib.BaseValuePt[0];
										CAN_LLPx->TxMessage.Data[1]=dADC1.ADCCalib.BaseValuePt[0]>>8;
										CAN_LLPx->TxMessage.Data[2]=dADC1.ADCCalib.BaseValuePt[1];
										CAN_LLPx->TxMessage.Data[3]=dADC1.ADCCalib.BaseValuePt[1]>>8;
										CAN_LLPx->TxMessage.Data[4]=dADC1.ADCCalib.ConvValuePt[0];
										CAN_LLPx->TxMessage.Data[5]=dADC1.ADCCalib.ConvValuePt[1];
										CAN_LLPx->TxMessage.Data[6]=dADC1.ADCMode;
										CAN_LLPx->TxMessage.Data[7]=dADC1.ADCConfig;
									}	break;
			case	ADC_SET_CAN:	{
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=8;
										CAN_LLPx->TxMessage.ExtId=0;
										CAN_LLPx->TxMessage.Data[0]=dADC1.ADCBuffer[0];
										CAN_LLPx->TxMessage.Data[1]=dADC1.ADCBuffer[1];
										CAN_LLPx->TxMessage.Data[2]=dADC1.ADCBuffer[2];
										CAN_LLPx->TxMessage.Data[3]=dADC1.ADCBuffer[3];
										CAN_LLPx->TxMessage.Data[4]=dADC1.ADCBuffer[4];
										CAN_LLPx->TxMessage.Data[5]=dADC1.ADCBuffer[5];
										CAN_LLPx->TxMessage.Data[6]=dADC1.ADCBuffer[6];
										CAN_LLPx->TxMessage.Data[7]=dADC1.ADCBuffer[7];
									}	break;
			case	DAC1_CNG_CAN:	{
										CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
										CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
										CAN_LLPx->TxMessage.DLC=7;
										CAN_LLPx->TxMessage.ExtId=0;
										CAN_LLPx->TxMessage.Data[0]=dDAC1.DACCalib.BaseValuePt[0];
										CAN_LLPx->TxMessage.Data[1]=dDAC1.DACCalib.BaseValuePt[0]>>8;
										CAN_LLPx->TxMessage.Data[2]=dDAC1.DACCalib.BaseValuePt[1];
										CAN_LLPx->TxMessage.Data[3]=dDAC1.DACCalib.BaseValuePt[1]>>8;
										CAN_LLPx->TxMessage.Data[4]=dDAC1.DACCalib.ConvValuePt[0];
										CAN_LLPx->TxMessage.Data[5]=dDAC1.DACCalib.ConvValuePt[1];
										CAN_LLPx->TxMessage.Data[6]=dDAC1.DACConfig;
										} break;
			case	DAC2_CNG_CAN:	 {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=7;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=dDAC2.DACCalib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=dDAC2.DACCalib.BaseValuePt[0]>>8;
											CAN_LLPx->TxMessage.Data[2]=dDAC2.DACCalib.BaseValuePt[1];
											CAN_LLPx->TxMessage.Data[3]=dDAC2.DACCalib.BaseValuePt[1]>>8;
											CAN_LLPx->TxMessage.Data[4]=dDAC2.DACCalib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[5]=dDAC2.DACCalib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[6]=dDAC2.DACConfig;
										 }	break;	
			case	SPEED_SENSOR_CAN: {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=7;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[0]>>8;
											CAN_LLPx->TxMessage.Data[2]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[1];
											CAN_LLPx->TxMessage.Data[3]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[1]>>8;
											CAN_LLPx->TxMessage.Data[4]=Sensors.AutoSpeedSensor.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[5]=Sensors.AutoSpeedSensor.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[6]=Sensors.AutoSpeedSensor.Calib.Type;
											}	break;
			case	TEMP_SENSOR_CAN	:  {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=4;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.TempSensor.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.TempSensor.Calib.BaseValuePt[1];
											CAN_LLPx->TxMessage.Data[2]=Sensors.TempSensor.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.TempSensor.Calib.ConvValuePt[1];
											}	break;
			case	LEVEL1_SENSOR_CAN: {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=8;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.LevelSensor1.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.LevelSensor1.Calib.BaseValuePt[1];
										    CAN_LLPx->TxMessage.Data[2]=Sensors.LevelSensor1.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.LevelSensor1.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[4]=Sensors.LevelSensor1.Calib.ConvValuePt[2];
											CAN_LLPx->TxMessage.Data[5]=Sensors.LevelSensor1.Calib.ConvValuePt[2]>>8;
											CAN_LLPx->TxMessage.Data[6]=Sensors.LevelSensor1.Calib.ConvValuePt[3];
											CAN_LLPx->TxMessage.Data[7]=Sensors.LevelSensor1.Calib.ConvValuePt[3]>>8;

										}	break;
			case	LEVEL2_SENSOR_CAN: {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=8;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.LevelSensor2.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.LevelSensor2.Calib.BaseValuePt[1];
										    CAN_LLPx->TxMessage.Data[2]=Sensors.LevelSensor2.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.LevelSensor2.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[4]=Sensors.LevelSensor2.Calib.ConvValuePt[2];
											CAN_LLPx->TxMessage.Data[5]=Sensors.LevelSensor2.Calib.ConvValuePt[2]>>8;
											CAN_LLPx->TxMessage.Data[6]=Sensors.LevelSensor2.Calib.ConvValuePt[3];
											CAN_LLPx->TxMessage.Data[7]=Sensors.LevelSensor2.Calib.ConvValuePt[3]>>8;
										}	break;
			case  LEVEL3_SENSOR_CAN: {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=8;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.LevelSensor3.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.LevelSensor3.Calib.BaseValuePt[1];
										    CAN_LLPx->TxMessage.Data[2]=Sensors.LevelSensor3.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.LevelSensor3.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[4]=Sensors.LevelSensor3.Calib.ConvValuePt[2];
											CAN_LLPx->TxMessage.Data[5]=Sensors.LevelSensor3.Calib.ConvValuePt[2]>>8;
											CAN_LLPx->TxMessage.Data[6]=Sensors.LevelSensor3.Calib.ConvValuePt[3];
											CAN_LLPx->TxMessage.Data[7]=Sensors.LevelSensor3.Calib.ConvValuePt[3]>>8;
										}	break;
			case	LEVELS_SET_CAN:		{
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=3;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.LevelSensor1.CurrentValue;
											CAN_LLPx->TxMessage.Data[1]=Sensors.LevelSensor2.CurrentValue;
											CAN_LLPx->TxMessage.Data[2]=Sensors.LevelSensor3.CurrentValue;
									   	}	break;
			case	PRESSURE_SENSOR_CAN:{
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=6;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.PressureSensor.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.PressureSensor.Calib.BaseValuePt[1];
											CAN_LLPx->TxMessage.Data[2]=Sensors.PressureSensor.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.PressureSensor.Calib.ConvValuePt[0]>>8;
											CAN_LLPx->TxMessage.Data[4]=Sensors.PressureSensor.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[5]=Sensors.PressureSensor.Calib.ConvValuePt[1]>>8;
											}	break;
			case	PUMP_SPEED_SENSOR_CAN:{
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											CAN_LLPx->TxMessage.DLC=6;
											CAN_LLPx->TxMessage.ExtId=0;
											CAN_LLPx->TxMessage.Data[0]=Sensors.PumpSpeedSensor.Calib.BaseValuePt[0];
											CAN_LLPx->TxMessage.Data[1]=Sensors.PumpSpeedSensor.Calib.BaseValuePt[1];
											CAN_LLPx->TxMessage.Data[2]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[0];
											CAN_LLPx->TxMessage.Data[3]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[0]>>8;
											CAN_LLPx->TxMessage.Data[4]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[1];
											CAN_LLPx->TxMessage.Data[5]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[1]>>8;
											}	break;
			case	PUMP_CONT_CALIB_CAN: {
											CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
											CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
											switch (nPacket)
													{
														case 1:	{
																CAN_LLPx->TxMessage.DLC=5;
																CAN_LLPx->TxMessage.Data[0]=Actuators.Pump.Calib.BaseValuePt[0];
																CAN_LLPx->TxMessage.Data[1]=Actuators.Pump.Calib.BaseValuePt[1];
																CAN_LLPx->TxMessage.Data[2]=Actuators.Pump.Calib.BaseValuePt[2];
																CAN_LLPx->TxMessage.Data[3]=Actuators.Pump.Calib.BaseValuePt[3];
																CAN_LLPx->TxMessage.Data[4]=Actuators.Pump.Calib.BaseValuePt[4];	
																nPacket=2;
																} break;
														case  2:{
																CAN_LLPx->TxMessage.DLC=8;
																CAN_LLPx->TxMessage.Data[0]=Actuators.Pump.Calib.ConvValuePt[0];
																CAN_LLPx->TxMessage.Data[1]=Actuators.Pump.Calib.ConvValuePt[1];
																CAN_LLPx->TxMessage.Data[2]=Actuators.Pump.Calib.ConvValuePt[2];
																CAN_LLPx->TxMessage.Data[3]=Actuators.Pump.Calib.ConvValuePt[2]>>8;
																CAN_LLPx->TxMessage.Data[4]=Actuators.Pump.Calib.ConvValuePt[3];
																CAN_LLPx->TxMessage.Data[5]=Actuators.Pump.Calib.ConvValuePt[3]>>8;
																CAN_LLPx->TxMessage.Data[6]=Actuators.Pump.Calib.ConvValuePt[4];
																CAN_LLPx->TxMessage.Data[7]=Actuators.Pump.Calib.ConvValuePt[4]>>8;
																nPacket=1;
															   } break;
													  }
										   }	break;
														
			case	TEST_PARAMS_CAN:		{
											if ((Actuators.TCMode==TEST_MODE_HAND)||(Actuators.TCMode==TEST_MODE_AUTO))
												{
													CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
													CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
													CAN_LLPx->TxMessage.DLC=8;
													CAN_LLPx->TxMessage.Data[0]=TestParams.DiscreteInputs;
													CAN_LLPx->TxMessage.Data[1]=TestParams.BitumTemp;
													CAN_LLPx->TxMessage.Data[2]=TestParams.AutoSpeed;
										    		CAN_LLPx->TxMessage.Data[3]=TestParams.BitumLevel1;
													CAN_LLPx->TxMessage.Data[4]=TestParams.BitumLevel2;
													CAN_LLPx->TxMessage.Data[5]=TestParams.PumpSpeed;
													CAN_LLPx->TxMessage.Data[6]=(uint16_t)TestParams.PumpSpeed>>8;
													CAN_LLPx->TxMessage.Data[7]=TestParams.PumpPressure;
												}
										  	}	break;
			case   INJECT_WIDTH_CAN:		{
													CAN_LLPx->TxMessage.RTR=CAN_RTR_DATA;
													CAN_LLPx->TxMessage.IDE=CAN_Id_Standard;
													CAN_LLPx->TxMessage.DLC=1;
													CAN_LLPx->TxMessage.Data[0]=Actuators.Injects.InjectWidth;	
											}
			}
	CAN_LLPx->CAN_RspRdy=1;
}
/*============================================================================================*/
void	CAN_LLP_RequestMaster	(CAN_DATA_STRUCTURE *CAN_LLPx)
{ 
uint32_t	CAN_LLP_ID;

	
	CAN_LLP_ID=CAN_LLPx->RxMessage.StdId;
	if (CAN_LLP_ID==GET_ALL_CAN)
	    { 
			if ((CAN_LLPx->RxMessage.RTR==CAN_RTR_DATA)&&(CAN_LLPx->RxMessage.DLC==8))
				{
				 switch(CAN_LLPx->RxMessage.Data[0])
						{
						  case	1:	{
																	
										Actuators.TCMode			=CAN_LLPx->RxMessage.Data[1]&3;
										Actuators.BitumenBackValve	=(CAN_LLPx->RxMessage.Data[1]>>2)&1;
										Actuators.HeatingManual		=(CAN_LLPx->RxMessage.Data[1]>>3)&1;
										Actuators.Injects.InjectConfiguration=CAN_LLPx->RxMessage.Data[2]|(CAN_LLPx->RxMessage.Data[3]<<8)|(CAN_LLPx->RxMessage.Data[4]<<16)|(CAN_LLPx->RxMessage.Data[5]<<24);
										DiscreteInputs				=CAN_LLPx->RxMessage.Data[6];
										Sensors.Filling				=CAN_LLPx->RxMessage.Data[6]&1;
										Sensors.PneumoPressureSensor=(CAN_LLPx->RxMessage.Data[6]&2)>>1;
										Sensors.BitumPressureSensor	=(CAN_LLPx->RxMessage.Data[6]&4)>>2;
										Sensors.DirtyFilterSensor	=(CAN_LLPx->RxMessage.Data[6]&16)>>3;
										Sensors.Heating				=(CAN_LLPx->RxMessage.Data[6]&32)>>4;
										Sensors.AutoSpeedPrs		=(CAN_LLPx->RxMessage.Data[6]&64)>>5;
										CurrentParameters.ErrorMsg	=CAN_LLPx->RxMessage.Data[7];
										CAN_DATA_UPDATED=0;
									} break;
						  case	2:	{
										Sensors.TempSensor.CurrentValue			=CAN_LLPx->RxMessage.Data[1];
										Sensors.AutoSpeedSensor.CurrentValue	=CAN_LLPx->RxMessage.Data[2];
										Sensors.LevelSensor1.CurrentValue		=CAN_LLPx->RxMessage.Data[3];
										Sensors.LevelSensor2.CurrentValue		=CAN_LLPx->RxMessage.Data[4];
										Sensors.PumpSpeedSensor.CurrentValue	=CAN_LLPx->RxMessage.Data[5]|(CAN_LLPx->RxMessage.Data[6]>>8);
										Sensors.PressureSensor.CurrentValue		=CAN_LLPx->RxMessage.Data[7];
									} break;	
						  case	3:	{
										ComputedParams.FillingWidth				=CAN_LLPx->RxMessage.Data[1]/100.0;
										CurrentParameters.Receipt.nFillingRate	=(CAN_LLPx->RxMessage.Data[2]|(CAN_LLPx->RxMessage.Data[3]<<8))/100.0;
										ComputedParams.MixtureVolumeIn			=CAN_LLPx->RxMessage.Data[4]|(CAN_LLPx->RxMessage.Data[5]<<8);
										ComputedParams.MixtureVolumeOut			=CAN_LLPx->RxMessage.Data[6]|(CAN_LLPx->RxMessage.Data[7]<<8);
									} break;	
						  case	4:  {
										ComputedParams.TimeGone				=CAN_LLPx->RxMessage.Data[1]|(CAN_LLPx->RxMessage.Data[2]<<8);
										ComputedParams.DistanceGone			=CAN_LLPx->RxMessage.Data[3]|(CAN_LLPx->RxMessage.Data[4]<<8);
										ComputedParams.SquareFilled			=CAN_LLPx->RxMessage.Data[5]|(CAN_LLPx->RxMessage.Data[6]<<8);
									   	WriteDataToHR();
			 					   // CAN_DATA_UPDATED=1;
										CAN_PACKET=1;
									} break;							
						}
				}
     }
 	else 
		{
			CAN_PACKET=1;
		if (CAN_LLP_ID==TEST_PARAMS_CAN)
			TEST_DATA_UPDATED=1;
		}
ClearCANRxMsg(CAN_LLPx);
//CAN_LLPx->CAN_RspRdy=1;
}
