#include "GraphInterface.h"
#include "GraphObjects.h"
#include "stdlib.h"
#include "PanelGlobalVars.h"
#include "stdio.h"
#include "string.h"
#include "PanelDefinitions.h"
/*==================================================================*/
/*Data*/
uint8_t *AlarmLedsNames[6]={
" .",
".",
".",
"", 
" .",
".."
};
uint8_t *PageControlNames[5]={
"", 
"",
"",
"",
""
};
uint8_t *InjectTmbNames[5]={
"",
" .",
"..",
" .",
".-"
};
uint8_t *RInjectTmbNames[5]={
"",
"",
"",
"",
".."};
uint8_t *TCParamNames[12]={
".T,C",
".T,C",
"T..,C",
"T..,C",
"..,",
"..,",
".V,/",
".V,/",
" 1.,",
" ,",
" W..,/",
" .,/"
};
uint8_t	*Calibration1LabelsNames[4]={
" ",
" 1",
" 2",
"  .",
};
uint8_t *Calibration2LabelsNames[4]={
" ",
" ..",
" ...",
"   "
};
uint8_t *Calibration3LabelsNames[2]={
"   ",
"   "
};
uint8_t *Calibration4LabelsNames[3]={
", ",
"  ",
"  "
};

uint8_t	*CalibCaptionNames[59]={
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
"..1",
"..2",	
"..1",
"..2",
"..1",
"..2",
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
". .1",
". .2",
" .1",
" .2",
" .1",
" .2",
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
" .1",
" .2",
"..1",
"..2",
" .1",
" .2",
"..1",
"..2",
"..3",
"..4",
"..5",
"..1",
"..2",
"..3",
"..4",
"..5",
"..1",
"..2",
"..3",
"..4",
"..5"
};
uint8_t	*SettingsLabelNames[3]={
" ",
" ",
"  "
};

uint8_t *SettingsBoxesNames[5]={
"",
"",
"  1",
"  2",
"  "
};

uint8_t *ADCModes[2]={
"16-",
"24-"
};

uint8_t *ADCCng[4]={
"+/-10 ",
"0-10 ",
"+/-5 ",
"0-5 "
};

uint8_t *DACCng[7]={
".0-5 ",
".0-10 ",
".+/- 5 ",
".+/- 10 ",
" 4-20 ",
" 0-20 ",
" 0-24 "	
};

uint8_t *SSTypes[5]={
"10.06 Hz/Km/Hr",
"16.32 Hz/Km/Hr",
"26.11 Hz/Km/Hr",
"34.80 Hz/Km/Hr",
""
};
uint8_t *UnitTypes[2]={
"/2",
"/3",	
};

uint8_t	*MaterialTypes[2]={
"",
""
};

uint8_t	*EngKeboardKeyNames="QWERTYUIOPASDFGHJKLZXCVBNM.,";
uint8_t *RusKeyboardKeyNames=".,";
uint8_t *DigitSymbolKeyboardKeyNames="1234567890@&%=+-*/()!?'"":;_,.";
/*==================================================================*/
PAGE_CONTROL	PageControl;
PAGE_1				ControlPage;
PAGE_2				ConfigPage;
PAGE_3				CalibrationPage1;
PAGE_4				CalibrationPage2;
PAGE_5				CalibrationPage3;
PAGE_6				CalibrationPage4;
PAGE_7				AdditionalPage;
KEYBOARD			Keyboard;
/*==================================================================*/
void	InitPageControl	(PAGE_CONTROL* PageControl)
{
uint8_t i;	
uint16_t	wdthsumm;	
uint16_t	Xstart;
	for (i=0; i<5;i++)
			{
					
				PageControl->y=0;
				PageControl->ControlPages[i].Color=0xC600;
				PageControl->ControlPages[i].Caption=PageControlNames[i];
				PageControl->ControlPages[i].CaptionColor=BLACK;
				PageControl->ControlPages[i].CaptionFont=&ARIAL9pt;
				PageControl->height=PageControl->ControlPages[i].CaptionFont->Height+6;
				PageControl->ActivePage=0;
				PageControl->ControlPages[i].width=GetStringLenght(PageControl->ControlPages[i].Caption,PageControl->ControlPages[i].CaptionFont);
				wdthsumm=wdthsumm+PageControl->ControlPages[i].width;
			}
	 Xstart=0;
	 for (i=0;i<5; i++)
				{
					PageControl->ControlPages[i].x=Xstart;
					PageControl->ControlPages[i].width=PageControl->ControlPages[i].width+(TFT_WIDTH-wdthsumm)/5;
					Xstart=PageControl->ControlPages[i].x+PageControl->ControlPages[i].width;
				}	
}
/*==================================================================*/
void	InitControlPage	(void)
{
	uint8_t		i=0;
	uint16_t	Xstart=LED_RADIUS+1;

	  ControlPage.pageWidth	=TFT_WIDTH;
	  ControlPage.pageHeight=TFT_HEIGHT-(PageControl.y+PageControl.height);	
	  ControlPage.BackColor	=GREEN;
		ControlPage.Xstart	=0;
	  ControlPage.Ystart=PageControl.y+PageControl.height+ARIAL24pt.Height;	
	
	  ControlPage.MessageBox.x=1;
	  ControlPage.MessageBox.y=1;
	  ControlPage.MessageBox.width=TFT_WIDTH-2;	
	  ControlPage.MessageBox.lineWidth=3;
	  ControlPage.MessageBox.height=45;
	  ControlPage.MessageBox.shape=ROUNDED;//rounded angels or not
	  ControlPage.MessageBox.color=ORANGE1;

	
	Xstart=LED_RADIUS+1;
	for (i=0;i<INJECT_NUM;i++)
		{
			
			ControlPage.InjectLeds[i].R=LED_RADIUS;
			ControlPage.InjectLeds[i].x=Xstart;
			ControlPage.InjectLeds[i].y=TFT_HEIGHT-LED_RADIUS-1;
			ControlPage.InjectLeds[i].color=LED_INACTIVE;
			ControlPage.InjectLeds[i].Caption=(uint8_t*)malloc(2);
			HexToASCII(i+1,ControlPage.InjectLeds[i].Caption);
			ControlPage.InjectLeds[i].CaptionWdth=GetStringLenght(ControlPage.InjectLeds[i].Caption,&ARIAL9pt);
			ControlPage.InjectLeds[i].CaptionColor=BLACK;
			Xstart=ControlPage.InjectLeds[i].x+2*LED_RADIUS;
		}
		//Alarm message
		ControlPage.AlarmMessage.x=0;
		ControlPage.AlarmMessage.y=PageControl.y+PageControl.height;	
		ControlPage.AlarmMessage.color=RED1;
		ControlPage.AlarmMessage.CaptionFont=&ARIAL24pt;
		ControlPage.AlarmMessage.ValueFont=&ARIAL10pt;
		ControlPage.AlarmMessage.Value=(uint8_t*)malloc(51);
		if (ControlPage.AutoSpeed.Value)	
			 memset(ControlPage.AutoSpeed.Value,0,51);
					
		//Alarm leds initialization
		Xstart=(GetStringLenght(AlarmLedsNames[0],&ARIAL10pt)/2);
		for (i=0;i<6;i++)
		{
			ControlPage.AlarmLeds[i].R=ALARM_LED_RADIUS;
			ControlPage.AlarmLeds[i].x=Xstart+ControlPage.AlarmLeds[i].R+1;
			ControlPage.AlarmLeds[i].y=ControlPage.AlarmMessage.y+ControlPage.AlarmMessage.CaptionFont->Height+ARIAL10pt.Height+5;
			ControlPage.AlarmLeds[i].color=LED_INACTIVE;
			ControlPage.AlarmLeds[i].Caption=AlarmLedsNames[i];
			ControlPage.AlarmLeds[i].CaptionWdth=GetStringLenght(ControlPage.AlarmLeds[i].Caption,&ARIAL10pt);
			ControlPage.AlarmLeds[i].CaptionColor=BLACK;
			Xstart=ControlPage.AlarmLeds[i].x+ControlPage.AlarmLeds[i].CaptionWdth/2+ControlPage.AlarmLeds[i].R+26;
		}	
	
	ControlPage.PumpSpeed.CaptionFont=&ARIAL10pt;	
	ControlPage.PumpSpeed.Caption="V..,/";
	ControlPage.PumpSpeed.CaptionWdth=GetStringLenght(ControlPage.PumpSpeed.Caption,ControlPage.PumpSpeed.CaptionFont);
	ControlPage.PumpSpeed.ValueFont=&ARIAL24pt;		
	ControlPage.PumpSpeed.Value=(uint8_t*)malloc(10);
	if (ControlPage.PumpSpeed.Value)	
			{
				memset(ControlPage.PumpSpeed.Value,0,10);
				sprintf(ControlPage.PumpSpeed.Value,"%d",0);
			}
	ControlPage.PumpSpeed.x=(ControlPage.PumpSpeed.CaptionWdth/2)-(GetStringLenght(ControlPage.PumpSpeed.Value,ControlPage.PumpSpeed.ValueFont)/2)+1;
	ControlPage.PumpSpeed.y=ControlPage.AlarmLeds[0].y+ControlPage.AlarmLeds[0].R+ControlPage.PumpSpeed.CaptionFont->Height+10;//106;
	ControlPage.PumpSpeed.color=BLACK;
	

	ControlPage.AutoSpeed.CaptionFont=&ARIAL10pt;		
	ControlPage.AutoSpeed.Caption="V,/";
	ControlPage.AutoSpeed.CaptionWdth=GetStringLenght(ControlPage.AutoSpeed.Caption,ControlPage.AutoSpeed.CaptionFont);
	ControlPage.AutoSpeed.x=ControlPage.PumpSpeed.x+85;
	ControlPage.AutoSpeed.y=ControlPage.PumpSpeed.y;	
	ControlPage.AutoSpeed.Value=(uint8_t*)malloc(10);
	if (ControlPage.AutoSpeed.Value)	
			{
				memset(ControlPage.AutoSpeed.Value,0,10);
				sprintf(ControlPage.AutoSpeed.Value,"%d",0);
			}	
	ControlPage.AutoSpeed.color=BLACK;
	ControlPage.AutoSpeed.ValueFont=&ARIAL24pt;
	
	ControlPage.Temperature.Caption=".,";
	ControlPage.Temperature.x=ControlPage.AutoSpeed.x+85;
	ControlPage.Temperature.y=ControlPage.PumpSpeed.y;	
	ControlPage.Temperature.Value=(uint8_t*)malloc(10);
	if (ControlPage.Temperature.Value)	
			{
				memset(ControlPage.Temperature.Value,0,10);
				sprintf(ControlPage.Temperature.Value,"%d",0);
			}		
	ControlPage.Temperature.color=BLACK;
	ControlPage.Temperature.CaptionFont=&ARIAL10pt;
	ControlPage.Temperature.ValueFont=&ARIAL24pt;
	ControlPage.Temperature.CaptionWdth=GetStringLenght(ControlPage.Temperature.Caption,ControlPage.Temperature.CaptionFont);
	
	ControlPage.CurrentVolume.Caption="..,";
	ControlPage.CurrentVolume.x=ControlPage.Temperature.x+85;
	ControlPage.CurrentVolume.y=ControlPage.PumpSpeed.y;	
	ControlPage.CurrentVolume.Value=(uint8_t*)malloc(10);
	if (ControlPage.CurrentVolume.Value)	
			{
				memset(ControlPage.CurrentVolume.Value,0,10);
				sprintf(ControlPage.CurrentVolume.Value,"%d",0);
			}		
	ControlPage.CurrentVolume.color=BLACK;
	ControlPage.CurrentVolume.CaptionFont=&ARIAL10pt;
	ControlPage.CurrentVolume.ValueFont=&ARIAL24pt;
	ControlPage.CurrentVolume.CaptionWdth=GetStringLenght(ControlPage.CurrentVolume.Caption,ControlPage.CurrentVolume.CaptionFont);
	
	ControlPage.FilledVolume.Caption="..,";
	ControlPage.FilledVolume.x=ControlPage.CurrentVolume.x+85;
	ControlPage.FilledVolume.y=ControlPage.PumpSpeed.y;	
	ControlPage.FilledVolume.Value=(uint8_t*)malloc(10);
	if (ControlPage.FilledVolume.Value)	
			{
				memset(ControlPage.FilledVolume.Value,0,10);
				sprintf(ControlPage.FilledVolume.Value,"%d",0);
			}		
	ControlPage.FilledVolume.color=BLACK;
	ControlPage.FilledVolume.CaptionFont=&ARIAL10pt;
	ControlPage.FilledVolume.ValueFont=&ARIAL24pt;
	ControlPage.FilledVolume.CaptionWdth=GetStringLenght(ControlPage.FilledVolume.Caption,ControlPage.FilledVolume.CaptionFont);
	
	
	
	ControlPage.Time.CaptionFont=&ARIAL10pt;
	ControlPage.Time.Caption=", ";
	ControlPage.Time.CaptionWdth=GetStringLenght(ControlPage.Time.Caption,ControlPage.Time.CaptionFont);
	ControlPage.Time.x=ControlPage.PumpSpeed.x;
	ControlPage.Time.y=ControlPage.PumpSpeed.y+ControlPage.PumpSpeed.CaptionFont->Height+ControlPage.PumpSpeed.CaptionFont->Height/2+ControlPage.PumpSpeed.ValueFont->Height;	//165
	ControlPage.Time.ValueFont=&ARIAL24pt;
	ControlPage.Time.Value=(uint8_t*)malloc(10);
	if (ControlPage.Time.Value)	
			{
				memset(ControlPage.Time.Value,0,10);
				sprintf(ControlPage.Time.Value,"%d",0);
			}	
	ControlPage.Time.color=BLACK;

  ControlPage.Distance.CaptionFont=&ARIAL10pt;
	ControlPage.Distance.Caption=".,";
	ControlPage.Distance.CaptionWdth=GetStringLenght(ControlPage.Distance.Caption,ControlPage.Distance.CaptionFont);
	ControlPage.Distance.x=ControlPage.AutoSpeed.x;
	ControlPage.Distance.y=ControlPage.Time.y;//165;	
	ControlPage.Distance.ValueFont=&ARIAL24pt;
	ControlPage.Distance.Value=(uint8_t*)malloc(10);
	if (ControlPage.Distance.Value)	
			{
				memset(ControlPage.Distance.Value,0,10);
				sprintf(ControlPage.Distance.Value,"%d",0);
			}	
	ControlPage.Distance.color=BLACK;
	
	ControlPage.Square.CaptionFont=&ARIAL10pt;
	ControlPage.Square.Caption=",^2";
	ControlPage.Square.CaptionWdth=GetStringLenght(ControlPage.Square.Caption,ControlPage.Square.CaptionFont);
	ControlPage.Square.x=ControlPage.Temperature.x;
	ControlPage.Square.y=ControlPage.Time.y;//165;165;	
	ControlPage.Square.ValueFont=&ARIAL24pt;
	ControlPage.Square.Value=(uint8_t*)malloc(10);
	if (ControlPage.Square.Value)	
			{
				memset(ControlPage.Square.Value,0,10);
				sprintf(ControlPage.Square.Value,"%d",0);
			}		
	ControlPage.Square.color=BLACK;
	
	ControlPage.FillingRate.CaptionFont=&ARIAL10pt;
	ControlPage.FillingRate.Caption=" ,/^2";
	ControlPage.FillingRate.CaptionWdth=GetStringLenght(ControlPage.FillingRate.Caption,ControlPage.FillingRate.CaptionFont);
	ControlPage.FillingRate.x=ControlPage.CurrentVolume.x;
	ControlPage.FillingRate.y=ControlPage.Time.y;//165;	
	ControlPage.FillingRate.ValueFont=&ARIAL24pt;
	ControlPage.FillingRate.Value=(uint8_t*)malloc(10);
	if (ControlPage.FillingRate.Value)	
			{
				memset(ControlPage.FillingRate.Value,0,10);
				sprintf(ControlPage.FillingRate.Value,"%d",0);
			}		
	ControlPage.FillingRate.color=BLACK;
	
	ControlPage.FillingWidth.CaptionFont=&ARIAL10pt;
	ControlPage.FillingWidth.Caption=", ";
	ControlPage.FillingWidth.CaptionWdth=GetStringLenght(ControlPage.FillingWidth.Caption,ControlPage.FillingWidth.CaptionFont);
	ControlPage.FillingWidth.x=ControlPage.FilledVolume.x;
	ControlPage.FillingWidth.y=ControlPage.Time.y;//165;
	ControlPage.FillingWidth.ValueFont=&ARIAL24pt;
	ControlPage.FillingWidth.Value=(uint8_t*)malloc(10);
	if (ControlPage.FillingWidth.Value)	
			{
				memset(ControlPage.FillingWidth.Value,0,10);
				sprintf(ControlPage.FillingWidth.Value,"%d",0);
			}		
	ControlPage.FillingWidth.color=BLACK;
	
	Xstart=GetStringLenght(InjectTmbNames[0],&ARIAL9pt)/2+16;
	for (i=0; i<5;i++)
			{
				ControlPage.InjectTmb[i].Caption=InjectTmbNames[i];
				ControlPage.InjectTmb[i].CaptionFont=&ARIAL9pt;
				ControlPage.InjectTmb[i].CaptionWdth=GetStringLenght(ControlPage.InjectTmb[i].Caption,ControlPage.InjectTmb[i].CaptionFont);
				ControlPage.InjectTmb[i].CaptionColor=BLACK;
				ControlPage.InjectTmb[i].Color=0xC600;
				ControlPage.InjectTmb[i].TrueColor=LIME_GREEN;
				ControlPage.InjectTmb[i].R=8;
				ControlPage.InjectTmb[i].x=Xstart-ControlPage.InjectTmb[i].R;
				ControlPage.InjectTmb[i].y=ControlPage.FillingWidth.y+ControlPage.FillingWidth.CaptionFont->Height+ControlPage.InjectTmb[i].CaptionFont->Height+ControlPage.InjectTmb[i].R+30;
				ControlPage.InjectTmb[i].State=OFF;
				Xstart=Xstart+ControlPage.InjectTmb[i].R+70;
			}
	ControlPage.InjectTmb[4].State=ON;
	
	ControlPage.ModeButton.y=ControlPage.PumpSpeed.y;//210;
	ControlPage.ModeButton.width=60;
	ControlPage.ModeButton.height=30;
	ControlPage.ModeButton.Color=0xC600;
	ControlPage.ModeButton.Caption="AUTO";
	ControlPage.ModeButton.CaptionColor=BLACK;
	ControlPage.ModeButton.Font=&ARIAL10pt;
	ControlPage.ModeButton.CaptionWdth=GetStringLenght(ControlPage.ModeButton.Caption,ControlPage.ModeButton.Font);
	ControlPage.ModeButton.x=TFT_WIDTH-ControlPage.ModeButton.width-5;
	
	
				
	ControlPage.HeatingTmb.width=32;
	ControlPage.HeatingTmb.height=31;
	ControlPage.HeatingTmb.Color=0xC600;
	ControlPage.HeatingTmb.Caption="";
	ControlPage.HeatingTmb.Pos1Caption="On";
	ControlPage.HeatingTmb.Pos2Caption="Off";
	ControlPage.HeatingTmb.CaptionColor=BLACK;
	ControlPage.HeatingTmb.State=OFF;
	ControlPage.HeatingTmb.img=TumblerImgOff;
	ControlPage.HeatingTmb.CaptionFont=&ARIAL9pt;
	ControlPage.HeatingTmb.x=ControlPage.FillingWidth.x;
	ControlPage.HeatingTmb.y=ControlPage.ModeButton.y+3*ControlPage.ModeButton.height+ControlPage.HeatingTmb.CaptionFont->Height+10;//210
	
	ControlPage.BackBitumTmb.y=ControlPage.HeatingTmb.y;//210;
	ControlPage.BackBitumTmb.width=32;
	ControlPage.BackBitumTmb.height=31;
	ControlPage.BackBitumTmb.Color=0xC600;
	ControlPage.BackBitumTmb.Caption="";
	ControlPage.BackBitumTmb.Pos1Caption="On";
	ControlPage.BackBitumTmb.Pos2Caption="Off";
	ControlPage.BackBitumTmb.CaptionColor=BLACK;
	ControlPage.BackBitumTmb.State=OFF;
	ControlPage.BackBitumTmb.img=TumblerImgOff;
	ControlPage.BackBitumTmb.CaptionFont=&ARIAL9pt;
	ControlPage.BackBitumTmb.x=ControlPage.HeatingTmb.x+ControlPage.HeatingTmb.width+20;
	
	ControlPage.PumpSpeedControl.x=ControlPage.ModeButton.x-15;
	ControlPage.PumpSpeedControl.y=ControlPage.ModeButton.y+ControlPage.ModeButton.height+35;
	ControlPage.PumpSpeedControl.width=ControlPage.ModeButton.width;
	ControlPage.PumpSpeedControl.height=32;
	ControlPage.PumpSpeedControl.lineWdth=3;
	ControlPage.PumpSpeedControl.LineColor=BLACK;
	ControlPage.PumpSpeedControl.Color=0xC600;
	ControlPage.PumpSpeedControl.Caption="W..,/";
	ControlPage.PumpSpeedControl.CaptionColor=BLACK;
	ControlPage.PumpSpeedControl.CaptionFont=&ARIAL9pt;
	ControlPage.PumpSpeedControl.MinValue=0;
	ControlPage.PumpSpeedControl.MaxValue=1500;
	ControlPage.PumpSpeedControl.Value=ControlPage.PumpSpeedControl.MinValue;
	ControlPage.PumpSpeedControl.ValueColor=BLACK;
	ControlPage.PumpSpeedControl.ValueFont=&ARIAL9pt;
	}
/*==================================================================*/
void	ShowLed	(CIRCLE* Led)
{
	TFT_DrawFilledCircleMy(Led->x, Led->y, (float)Led->R, Led->color);
}
/*==================================================================*/
void	ShowInjectLeds	(CIRCLE* Leds)
{
	uint8_t i;
	
	for (i=0; i<INJECT_NUM; i++)
			{
				ShowLed	(&Leds[i]);
				TFT_Log	(Leds[i].x-(Leds[i].CaptionWdth/2),Leds[i].y-Leds[i].R+2,Leds[i].Caption,Leds[i].color,Leds[i].CaptionColor,&ARIAL9pt);
			}
}
/*==================================================================*/
void	ShowAlarmLeds	(void)
{
	uint8_t i;
	
	for (i=0; i<ALARM_NUM; i++)
			{
				ShowLed	(&ControlPage.AlarmLeds[i]);
					TFT_Log(ControlPage.AlarmLeds[i].x-(ControlPage.AlarmLeds[i].CaptionWdth/2),ControlPage.AlarmLeds[i].y-ControlPage.AlarmLeds[i].R-ARIAL10pt.Height,ControlPage.AlarmLeds[i].Caption,ControlPage.BackColor,ControlPage.AlarmLeds[i].CaptionColor,&ARIAL10pt);
			}
}
/*==================================================================*/
void	ShowLabel	(LABEL* Label, uint16_t BackColor)
{
	TFT_Log(Label->x+(GetStringLenght(Label->Value,Label->ValueFont)/2)-((Label->CaptionWdth/2)), Label->y-(Label->CaptionFont->Height+Label->CaptionFont->Height/4),Label->Caption,BackColor,Label->color,Label->CaptionFont);
	TFT_Log(Label->x, Label->y,Label->Value,BackColor,Label->color,Label->ValueFont);
}
/*==================================================================*/
void	ShowTumbler			(TUMBLER* Tmb, uint16_t backcolor)
{
	if (Tmb->State==ON)
			Tmb->img=TumblerImgOn;
			else
					Tmb->img=TumblerImgOff;
	TFT_DrawBmpImg(Tmb->x,Tmb->width,Tmb->y, Tmb->height,Tmb->Color,backcolor,(uint8_t*)Tmb->img);
	TFT_Log(Tmb->x+Tmb->width/2-5-GetStringLenght(Tmb->Caption,Tmb->CaptionFont)/2, Tmb->y-(Tmb->CaptionFont->Height),Tmb->Caption,backcolor,Tmb->CaptionColor,Tmb->CaptionFont);

	if (Tmb->State==ON)
		{
			TFT_Log(Tmb->x+Tmb->width-8, Tmb->y,Tmb->Pos1Caption,backcolor,RED1,Tmb->CaptionFont);
			TFT_Log(Tmb->x+Tmb->width-10, Tmb->y+8+Tmb->CaptionFont->Height,Tmb->Pos2Caption,backcolor,Tmb->CaptionColor,Tmb->CaptionFont);
		}
		else
		{
			TFT_Log(Tmb->x+Tmb->width-8, Tmb->y,Tmb->Pos1Caption,backcolor,Tmb->CaptionColor,Tmb->CaptionFont);
			TFT_Log(Tmb->x+Tmb->width-10, Tmb->y+8+Tmb->CaptionFont->Height,Tmb->Pos2Caption,backcolor,RED1,Tmb->CaptionFont);
		}
}
/*==================================================================*/
void	ShowPageControl (void)
{
uint16_t i;
uint16_t j;
uint16_t n;
uint16_t s_prc=10;
uint16_t prc;	
uint16_t totalwdth=0;


	for (n=0; n<5; n++)
			totalwdth=totalwdth+GetStringLenght(PageControl.ControlPages[n].Caption,PageControl.ControlPages[n].CaptionFont);
	
	for (n=0; n<5;n++)
			{	
				prc=PageControl.ControlPages[n].width*s_prc/100;
				WindowSet(PageControl.ControlPages[n].x,PageControl.ControlPages[n].x+PageControl.ControlPages[n].width,PageControl.y,PageControl.y+PageControl.height-prc);
				LCD_WriteCommand(CMD_WR_MEMSTART);
			  WriteDataBus(PageControl.ControlPages[n].Color,PageControl.ControlPages[n].width*PageControl.height);
			  i=1;
				j=1;
				while (i<=prc)
							{
								TFT_DrawHorLine(PageControl.ControlPages[n].x+j,PageControl.y+PageControl.height-prc+i-1, PageControl.ControlPages[n].width-2*j+1, 1,PageControl.ControlPages[n].Color);
								i++;
								TFT_DrawHorLine(PageControl.ControlPages[n].x+j,PageControl.y+PageControl.height-prc+i-1, PageControl.ControlPages[n].width-2*j+1, 1,PageControl.ControlPages[n].Color);
								i++;
								j++;
							}	
				TFT_Log(PageControl.ControlPages[n].x+(TFT_WIDTH-totalwdth)/10,PageControl.y+PageControl.ControlPages[n].CaptionFont->Height/2-3,PageControl.ControlPages[n].Caption,PageControl.ControlPages[n].Color,PageControl.ControlPages[n].CaptionColor,PageControl.ControlPages[n].CaptionFont);
			
				}
}
/*==================================================================*/
void	ShowRadioBtn	(RADIO_BUTTON* RBtn, uint16_t backcolor)
{
uint8_t i;
uint16_t color;
	
	for(i=0;i<5;i++)
			{
				TFT_DrawCircleMy(RBtn[i].x, RBtn[i].y, RBtn[i].R, RBtn[i].Color);
				if (RBtn[i].State==ON)
						color=RBtn[i].TrueColor;
						else
								color=RBtn[i].Color;
				TFT_DrawFilledCircleMy (RBtn[i].x, RBtn[i].y, (float)RBtn[i].R/2, color);
				TFT_Log(RBtn[i].x-RBtn[i].CaptionWdth/2, RBtn[i].y-RBtn[i].R-1.5*RBtn[i].CaptionFont->Height,RBtn[i].Caption, backcolor, RBtn[i].CaptionColor, RBtn[i].CaptionFont);	
			}
}
/*==================================================================*/
void	ShowControlPage	(void)
{
	TFT_DrawRoundRectFilled	(ControlPage.Xstart, ControlPage.pageWidth,ControlPage.Ystart, ControlPage.pageHeight, 0,ControlPage.BackColor);
	ShowAlarmLeds();
	ShowInjectLeds(ControlPage.InjectLeds);
	ShowLabel(&ControlPage.PumpSpeed, ControlPage.BackColor);
	ShowLabel(&ControlPage.AutoSpeed, ControlPage.BackColor);
	ShowLabel(&ControlPage.Time, ControlPage.BackColor);	
	ShowLabel(&ControlPage.Distance, ControlPage.BackColor);
	ShowLabel(&ControlPage.Square, ControlPage.BackColor);
	ShowLabel(&ControlPage.FillingWidth, ControlPage.BackColor);
	ShowLabel(&ControlPage.FillingRate, ControlPage.BackColor);	
	ShowLabel(&ControlPage.CurrentVolume, ControlPage.BackColor);
	ShowLabel(&ControlPage.FilledVolume, ControlPage.BackColor);	
	ShowLabel(&ControlPage.Temperature, ControlPage.BackColor);
	TFT_DrawButton(&ControlPage.ModeButton);
	ShowTumbler(&ControlPage.HeatingTmb, ControlPage.BackColor);
	ShowTumbler(&ControlPage.BackBitumTmb, ControlPage.BackColor);
	ShowRadioBtn(ControlPage.InjectTmb,ControlPage.BackColor);
	ShowIncDecEditBox(&ControlPage.PumpSpeedControl);
}
/*==================================================================*/
void	InitConfigPage	(void)
{
uint8_t i;
uint16_t Xstart=5;
uint16_t Ystart;
	
	ConfigPage.Xstart=0;
	ConfigPage.Ystart=ControlPage.AlarmMessage.y+ControlPage.AlarmMessage.CaptionFont->Height-1;
	ConfigPage.pageWidth=TFT_WIDTH;
	ConfigPage.pageHeight=TFT_HEIGHT-ConfigPage.Ystart;
	ConfigPage.BackColor=ControlPage.BackColor;
	
	
	for (i=0; i<12; i++)
			{
					ConfigPage.TCParams[i].CaptionFont=&ARIAL9pt;
					ConfigPage.TCParams[i].ValueFont=&ARIAL10pt;
					ConfigPage.TCParams[i].lineWdth=3;
					ConfigPage.TCParams[i].width=60;
					ConfigPage.TCParams[i].lineWdth=3;
					ConfigPage.TCParams[i].height=ConfigPage.TCParams[i].ValueFont->Height+ConfigPage.TCParams[i].lineWdth*2+2;
					if ((i%3)==0)
						{
							if (i>0)
									Xstart=ConfigPage.TCParams[i-1].x+ConfigPage.TCParams[i-1].width+30;
									Ystart=ConfigPage.Ystart+ConfigPage.TCParams[i].CaptionFont->Height+2;
						}
					ConfigPage.TCParams[i].x=Xstart;
					if ((i==0)||(i==3)||(i==6)||(i==9))
						ConfigPage.TCParams[i].y=Ystart;
						else
								ConfigPage.TCParams[i].y=Ystart+ConfigPage.TCParams[i].height*2;
					ConfigPage.TCParams[i].LineColor=BLACK;
					ConfigPage.TCParams[i].Color=WHITE;
					ConfigPage.TCParams[i].Caption=TCParamNames[i];
					ConfigPage.TCParams[i].CaptionColor=BLACK;
					ConfigPage.TCParams[i].Value=(uint8_t*)malloc(6);	
					if (ConfigPage.TCParams[i].Value)
							memset(ConfigPage.TCParams[i].Value,0,6);
					ConfigPage.TCParams[i].ValueColor=BLACK;
					Ystart=ConfigPage.TCParams[i].y;
					Xstart=ConfigPage.TCParams[i].x;
			}
		
	Xstart=LED_RADIUS+1;
	for (i=0;i<INJECT_NUM;i++)
			{
					ConfigPage.ReceiptBox.RInjectLeds[i].R=LED_RADIUS;
					ConfigPage.ReceiptBox.RInjectLeds[i].x=Xstart;
					ConfigPage.ReceiptBox.RInjectLeds[i].y=TFT_HEIGHT-LED_RADIUS-1;
					ConfigPage.ReceiptBox.RInjectLeds[i].color=LED_INACTIVE;
					ConfigPage.ReceiptBox.RInjectLeds[i].Caption=(uint8_t*)malloc(2);
					HexToASCII(i+1,ConfigPage.ReceiptBox.RInjectLeds[i].Caption);
					ConfigPage.ReceiptBox.RInjectLeds[i].CaptionWdth=GetStringLenght(ConfigPage.ReceiptBox.RInjectLeds[i].Caption,&ARIAL9pt);
					ConfigPage.ReceiptBox.RInjectLeds[i].CaptionColor=BLACK;
					Xstart=ConfigPage.ReceiptBox.RInjectLeds[i].x+2*LED_RADIUS;
			}
	ConfigPage.ReceiptBox.RInjectConfig=0;
	
	ConfigPage.SetRecButton.x=66;
	ConfigPage.SetRecButton.width=24;
	ConfigPage.SetRecButton.height=24;
	ConfigPage.SetRecButton.y=TFT_HEIGHT-2*ConfigPage.ReceiptBox.RInjectLeds[0].R-ConfigPage.SetRecButton.height-5;
	ConfigPage.SetRecButton.Font=&ARIAL9pt;
	ConfigPage.SetRecButton.Color=0xC600;
	ConfigPage.SetRecButton.CaptionColor=BLACK;
  ConfigPage.SetRecButton.Image=SetSignImg;	
			
	ConfigPage.SaveRecButton.width=24;
	ConfigPage.SaveRecButton.height=24;
	ConfigPage.SaveRecButton.x=ConfigPage.Xstart+ConfigPage.pageWidth-3*(ConfigPage.SaveRecButton.width+5)-1;
	ConfigPage.SaveRecButton.y=TFT_HEIGHT-2*ConfigPage.ReceiptBox.RInjectLeds[0].R-ConfigPage.SaveRecButton.height-5;
	ConfigPage.SaveRecButton.Color=0xC600;
	ConfigPage.SaveRecButton.CaptionColor=BLACK;
  ConfigPage.SaveRecButton.Image=SaveSignImg;	
	
	ConfigPage.DelRecButton.x=ConfigPage.SaveRecButton.x+ConfigPage.SaveRecButton.width+5;
	ConfigPage.DelRecButton.y=ConfigPage.SaveRecButton.y;		
	ConfigPage.DelRecButton.width=24;
	ConfigPage.DelRecButton.height=24;
	ConfigPage.DelRecButton.CaptionColor=BLACK;
	ConfigPage.DelRecButton.Color=0xC600;
  ConfigPage.DelRecButton.Image=DelSignImg;		

	ConfigPage.DelAllRecButton.x=ConfigPage.DelRecButton.x+ConfigPage.DelRecButton.width+5;
	ConfigPage.DelAllRecButton.y=ConfigPage.DelRecButton.y;		
	ConfigPage.DelAllRecButton.width=24;
	ConfigPage.DelAllRecButton.height=24;
	ConfigPage.DelAllRecButton.CaptionColor=BLACK;
	ConfigPage.DelAllRecButton.Color=0xC600;
  ConfigPage.DelAllRecButton.Image=DelAllSignImg;	
	
	ConfigPage.SaveTCButton.x=ConfigPage.TCParams[PROD_RATE].x+ConfigPage.TCParams[PROD_RATE].width;
	ConfigPage.SaveTCButton.y=ConfigPage.TCParams[PROD_RATE].y+ConfigPage.TCParams[PROD_RATE].height+2;		
	ConfigPage.SaveTCButton.width=80;
	ConfigPage.SaveTCButton.Font=&ARIAL9pt;
	ConfigPage.SaveTCButton.height=ConfigPage.SaveTCButton.Font->Height+6;
	ConfigPage.SaveTCButton.CaptionColor=BLACK;
	ConfigPage.SaveTCButton.Caption="";
	ConfigPage.SaveTCButton.CaptionWdth=GetStringLenght(ConfigPage.SaveTCButton.Caption,ConfigPage.SaveTCButton.Font);
	ConfigPage.SaveTCButton.Color=0xC600;
  ConfigPage.SaveTCButton.Image=NONE;

		ConfigPage.RecLabel.x=ConfigPage.TCParams[0].x;
		ConfigPage.RecLabel.y=ConfigPage.TCParams[2].y+ConfigPage.TCParams[2].height+ConfigPage.TCParams[2].lineWdth*2+3;
		ConfigPage.RecLabel.Value=" ";
		ConfigPage.RecLabel.ValueFont=&ARIAL10pt;
		ConfigPage.RecLabel.Caption="";
		ConfigPage.RecLabel.CaptionFont=&ARIAL9pt;
		ConfigPage.RecLabel.CaptionWdth=GetStringLenght(ConfigPage.RecLabel.Caption,ConfigPage.RecLabel.CaptionFont);
		ConfigPage.RecLabel.color=BLACK;
			
		ConfigPage.ReceiptBox.ItemIndex=0;	
			
		ConfigPage.ReceiptBox.RName.x=5;
		ConfigPage.ReceiptBox.RName.CaptionFont=ConfigPage.TCParams[0].CaptionFont;
		ConfigPage.ReceiptBox.RName.y=ConfigPage.RecLabel.y+ConfigPage.RecLabel.ValueFont->Height+ConfigPage.ReceiptBox.RName.CaptionFont->Height+5;
		ConfigPage.ReceiptBox.RName.width=ConfigPage.TCParams[0].width;
		ConfigPage.ReceiptBox.RName.height=ConfigPage.TCParams[0].height;
		ConfigPage.ReceiptBox.RName.lineWdth=ConfigPage.TCParams[0].lineWdth;
		ConfigPage.ReceiptBox.RName.Caption=". .";
		ConfigPage.ReceiptBox.RName.ValueFont=ConfigPage.TCParams[0].ValueFont;
		ConfigPage.ReceiptBox.RName.Value=(uint8_t*)malloc(STRING_LENGHT);
		if (ConfigPage.ReceiptBox.RName.Value)
				memset(ConfigPage.ReceiptBox.RName.Value,0,STRING_LENGHT);
				
		ConfigPage.ReceiptBox.RName.Color=WHITE;
		ConfigPage.ReceiptBox.RName.LineColor=BLACK;
		ConfigPage.ReceiptBox.RName.CaptionColor=BLACK;
		ConfigPage.ReceiptBox.RName.ValueColor=BLACK;			
		
		ConfigPage.ReceiptBox.Material.y=ConfigPage.ReceiptBox.Unit.y=ConfigPage.ReceiptBox.FRate.y=ConfigPage.ReceiptBox.FWidth.y=ConfigPage.ReceiptBox.RName.y;
		ConfigPage.ReceiptBox.Material.width=ConfigPage.ReceiptBox.Unit.width=ConfigPage.ReceiptBox.FRate.width=ConfigPage.ReceiptBox.FWidth.width=ConfigPage.ReceiptBox.RName.width;
		ConfigPage.ReceiptBox.Material.height=ConfigPage.ReceiptBox.Unit.height=ConfigPage.ReceiptBox.FRate.height=ConfigPage.ReceiptBox.FWidth.height=ConfigPage.ReceiptBox.RName.height;
		ConfigPage.ReceiptBox.Material.lineWdth=ConfigPage.ReceiptBox.Unit.lineWdth=ConfigPage.ReceiptBox.FRate.lineWdth=ConfigPage.ReceiptBox.FWidth.lineWdth=ConfigPage.ReceiptBox.RName.lineWdth;
		ConfigPage.ReceiptBox.Material.CaptionFont=ConfigPage.ReceiptBox.Unit.CaptionFont=ConfigPage.ReceiptBox.FRate.CaptionFont=ConfigPage.ReceiptBox.FWidth.CaptionFont=ConfigPage.ReceiptBox.RName.CaptionFont;
		ConfigPage.ReceiptBox.Material.ValueFont=ConfigPage.ReceiptBox.Unit.ValueFont=ConfigPage.ReceiptBox.FRate.ValueFont=ConfigPage.ReceiptBox.FWidth.ValueFont=ConfigPage.ReceiptBox.RName.ValueFont;
		ConfigPage.ReceiptBox.Material.Color=ConfigPage.ReceiptBox.Unit.Color=ConfigPage.ReceiptBox.FRate.Color=ConfigPage.ReceiptBox.FWidth.Color=ConfigPage.ReceiptBox.RName.Color;
		ConfigPage.ReceiptBox.Material.LineColor=ConfigPage.ReceiptBox.Unit.LineColor=ConfigPage.ReceiptBox.FRate.LineColor=ConfigPage.ReceiptBox.FWidth.LineColor=ConfigPage.ReceiptBox.RName.LineColor;
		ConfigPage.ReceiptBox.Material.CaptionColor=ConfigPage.ReceiptBox.Unit.CaptionColor=ConfigPage.ReceiptBox.FRate.CaptionColor=ConfigPage.ReceiptBox.FWidth.CaptionColor=ConfigPage.ReceiptBox.RName.CaptionColor;
		ConfigPage.ReceiptBox.Material.ValueColor=ConfigPage.ReceiptBox.Unit.ValueColor=ConfigPage.ReceiptBox.FRate.ValueColor=ConfigPage.ReceiptBox.FWidth.ValueColor=ConfigPage.ReceiptBox.RName.ValueColor;
	
		
		ConfigPage.ReceiptBox.Material.x=ConfigPage.SetRecButton.x+ConfigPage.SetRecButton.width+15;//ConfigPage.TCParams[3].x;
		ConfigPage.ReceiptBox.Material.Caption="";
		ConfigPage.ReceiptBox.Material.Value=(uint8_t*)malloc(9);		
		if (ConfigPage.ReceiptBox.Material.Value)
				memset(ConfigPage.ReceiptBox.Material.Value,0,9);
		
		ConfigPage.ReceiptBox.Unit.x=ConfigPage.ReceiptBox.Material.x+ConfigPage.ReceiptBox.Material.width+15;//ConfigPage.TCParams[6].x;
		ConfigPage.ReceiptBox.Unit.Caption=". .";	
		ConfigPage.ReceiptBox.Unit.Value=(uint8_t*)malloc(6);
		if (ConfigPage.ReceiptBox.Unit.Value)
				memset(ConfigPage.ReceiptBox.Unit.Value,0,6);
			
		ConfigPage.ReceiptBox.FRate.x=ConfigPage.ReceiptBox.Unit.x+ConfigPage.ReceiptBox.Unit.width+15;//ConfigPage.TCParams[9].x;
		ConfigPage.ReceiptBox.FRate.Caption="P,..";	
		ConfigPage.ReceiptBox.FRate.Value=(uint8_t*)malloc(5);
		if (ConfigPage.ReceiptBox.FRate.Value)
				memset(ConfigPage.ReceiptBox.FRate.Value,0,5);
		
		ConfigPage.ReceiptBox.FWidth.x=ConfigPage.ReceiptBox.FRate.x+ConfigPage.ReceiptBox.FRate.width+15;//ConfigPage.TCParams[9].x+ConfigPage.TCParams[6].width+20;
		ConfigPage.ReceiptBox.FWidth.Caption="P,";	
		ConfigPage.ReceiptBox.FWidth.Value=(uint8_t*)malloc(5);
		if (ConfigPage.ReceiptBox.FWidth.Value)
				memset(ConfigPage.ReceiptBox.FWidth.Value,0,5);
			
			
	for (i=0; i<5;i++)
			{
				ConfigPage.RInjectTmb[i].Caption=RInjectTmbNames[i];
				ConfigPage.RInjectTmb[i].CaptionFont=&ARIAL9pt;
				ConfigPage.RInjectTmb[i].CaptionWdth=GetStringLenght(ConfigPage.RInjectTmb[i].Caption,ConfigPage.RInjectTmb[i].CaptionFont);
				ConfigPage.RInjectTmb[i].CaptionColor=BLACK;
				ConfigPage.RInjectTmb[i].Color=0xC600;
				ConfigPage.RInjectTmb[i].TrueColor=LIME_GREEN;
				ConfigPage.RInjectTmb[i].R=8;
				ConfigPage.RInjectTmb[i].State=OFF;
				Ystart=ConfigPage.RInjectTmb[i].y+10;
			}
	ConfigPage.RInjectTmb[4].State=ON;
			
  ConfigPage.RInjectTmb[0].x=ConfigPage.RInjectTmb[2].x=ConfigPage.TCParams[VOLUME_RATE].x+ConfigPage.TCParams[VOLUME_RATE].width+70;
	ConfigPage.RInjectTmb[1].x=ConfigPage.RInjectTmb[3].x=ConfigPage.RInjectTmb[0].x+ConfigPage.RInjectTmb[0].R+40;
	ConfigPage.RInjectTmb[4].x=ConfigPage.RInjectTmb[0].x+20;
	ConfigPage.RInjectTmb[0].y=ConfigPage.RInjectTmb[1].y=ConfigPage.TCParams[VOLUME_RATE].y+ConfigPage.RInjectTmb[0].R+10;
	ConfigPage.RInjectTmb[2].y=ConfigPage.RInjectTmb[3].y=ConfigPage.TCParams[G_FREQ_RATE].y+ConfigPage.RInjectTmb[0].R+10;	
	ConfigPage.RInjectTmb[4].y=ConfigPage.TCParams[PROD_RATE].y+ConfigPage.RInjectTmb[0].R+10;			

	if (ConfigPage.ReceiptBox.RName.Value)
			strncpy(ConfigPage.ReceiptBox.RName.Value,"...",8);
	if (ConfigPage.ReceiptBox.Material.Value)
			strncpy(ConfigPage.ReceiptBox.Material.Value,MaterialTypes[0],9);
	if(ConfigPage.ReceiptBox.Unit.Value)
			strncpy(ConfigPage.ReceiptBox.Unit.Value,UnitTypes[0],6);
	if (ConfigPage.ReceiptBox.FRate.Value)
			sprintf(ConfigPage.ReceiptBox.FRate.Value,"%.3f",0);
	if (ConfigPage.ReceiptBox.FWidth.Value)
			sprintf(ConfigPage.ReceiptBox.FWidth.Value,"%3f",0);

for	(i=0;i<MAX_RECEIPT;i++)
	  TCReceipts.ReceiptName[i]=(uint8_t*)calloc(STRING_LENGHT,1);
}
/*==================================================================*/
void  ShowEditBox	(EDIT_BOX* EBox)
{
	uint8_t str[20];
	uint8_t n;
	
	memset(str,0,20);
	TFT_DrawRect						(EBox->x, EBox->y, EBox->width,EBox->height, EBox->lineWdth, EBox->LineColor);
	TFT_DrawRoundRectFilled	(EBox->x+EBox->lineWdth, EBox->width-2*EBox->lineWdth,EBox->y+EBox->lineWdth, EBox->height-2*EBox->lineWdth, 0,EBox->Color);
	TFT_Log(EBox->x,EBox->y-(EBox->CaptionFont->Height)-EBox->lineWdth,EBox->Caption,ConfigPage.BackColor,EBox->CaptionColor,EBox->CaptionFont);	
	n=GetStringByWidth(EBox->Value,EBox->width-EBox->lineWdth*2,EBox->ValueFont);
	strncpy(str,EBox->Value,n);
	TFT_Log(EBox->x+EBox->lineWdth+2,EBox->y+EBox->lineWdth+1,str, EBox->Color , EBox->ValueColor, EBox->ValueFont);	
}
/*==================================================================*/
void	ShowIncDecEditBox	(INCDEC_EDIT_BOX* EBox)
{
	uint8_t str[6];
	
	TFT_DrawRect						(EBox->x, EBox->y, EBox->width,EBox->height, EBox->lineWdth, EBox->LineColor);
	TFT_DrawRoundRectFilled	(EBox->x+EBox->lineWdth, EBox->width-2*EBox->lineWdth,EBox->y+EBox->lineWdth, EBox->height-2*EBox->lineWdth, 0,EBox->Color);
	TFT_Log(EBox->x,EBox->y-(EBox->CaptionFont->Height)-EBox->lineWdth,EBox->Caption,ConfigPage.BackColor,EBox->CaptionColor,EBox->CaptionFont);	
	sprintf(str,"%d",EBox->Value);
	TFT_Log(EBox->x+EBox->lineWdth+2,EBox->y+(EBox->height-EBox->ValueFont->Height)/2,str, EBox->Color , EBox->ValueColor, EBox->ValueFont);	
	TFT_DrawBmpImg(EBox->x+EBox->width, 16, EBox->y, 16,BLACK,0xC600,IncImg);
	TFT_DrawBmpImg(EBox->x+EBox->width, 16, EBox->y+EBox->height-16, 16,BLACK,0xC600,DecImg);
}
/*==================================================================*/
void	ShowConfigPage(void)
{
	uint8_t i;
	uint8_t	j;
	
	
	TFT_DrawRoundRectFilled	(ConfigPage.Xstart, ConfigPage.pageWidth,ConfigPage.Ystart, ConfigPage.pageHeight, 0,ConfigPage.BackColor);
	
	for (i=0;i<12; i++)
			ShowEditBox(&ConfigPage.TCParams[i]);
	ShowLabel(&ConfigPage.RecLabel, ConfigPage.BackColor);
	
	ShowEditBox(&ConfigPage.ReceiptBox.RName);
	ShowEditBox(&ConfigPage.ReceiptBox.Unit);
	ShowEditBox(&ConfigPage.ReceiptBox.Material);
	ShowEditBox(&ConfigPage.ReceiptBox.FRate);
	ShowEditBox(&ConfigPage.ReceiptBox.FWidth);

	ShowInjectLeds(ConfigPage.ReceiptBox.RInjectLeds);
	ShowRadioBtn(ConfigPage.RInjectTmb,ConfigPage.BackColor);
	TFT_DrawBmpImg(ConfigPage.SetRecButton.x,ConfigPage.SetRecButton.width,ConfigPage.SetRecButton.y, ConfigPage.SetRecButton.height,ConfigPage.SetRecButton.CaptionColor,ConfigPage.SetRecButton.Color,ConfigPage.SetRecButton.Image);
	TFT_DrawBmpImg(ConfigPage.SaveRecButton.x,ConfigPage.SaveRecButton.width,ConfigPage.SaveRecButton.y, ConfigPage.SaveRecButton.height,ConfigPage.SaveRecButton.CaptionColor,ConfigPage.SaveRecButton.Color,ConfigPage.SaveRecButton.Image);
	TFT_DrawBmpImg(ConfigPage.DelRecButton.x,ConfigPage.DelRecButton.width,ConfigPage.DelRecButton.y, ConfigPage.DelRecButton.height,ConfigPage.DelRecButton.CaptionColor,ConfigPage.DelRecButton.Color,ConfigPage.DelRecButton.Image);
	TFT_DrawBmpImg(ConfigPage.DelAllRecButton.x,ConfigPage.DelAllRecButton.width,ConfigPage.DelAllRecButton.y, ConfigPage.DelAllRecButton.height,ConfigPage.DelAllRecButton.CaptionColor,ConfigPage.DelAllRecButton.Color,ConfigPage.DelAllRecButton.Image);
	TFT_DrawButton(&ConfigPage.SaveTCButton);
}
/*==================================================================*/
void	InitCalibrationPages	(void)
{
uint8_t	 	i;
uint16_t 	Xstart=5;
uint16_t	Ystart;
uint8_t		j=0,z=0;	

CalibrationPage1.Xstart=CalibrationPage2.Xstart=CalibrationPage3.Xstart=CalibrationPage4.Xstart=0;
CalibrationPage1.Ystart=CalibrationPage2.Ystart=CalibrationPage3.Ystart=CalibrationPage4.Ystart=ControlPage.AlarmMessage.y+ControlPage.AlarmMessage.CaptionFont->Height-1;	
CalibrationPage1.pageWidth=CalibrationPage2.pageWidth=CalibrationPage3.pageWidth=CalibrationPage4.pageWidth=TFT_WIDTH;
CalibrationPage1.pageHeight=CalibrationPage2.pageHeight=CalibrationPage3.pageHeight=CalibrationPage4.pageHeight=TFT_HEIGHT-ConfigPage.Ystart;
CalibrationPage1.BackColor=CalibrationPage2.BackColor=CalibrationPage3.BackColor=CalibrationPage4.BackColor=ControlPage.BackColor;

	for (i=0;i<CALIB_SENSORS_4;i++)
		{
			CalibrationPage1.CalibSensors[i].width=60;
			CalibrationPage1.CalibSensors[i].ValueFont=&ARIAL9pt;
			CalibrationPage1.CalibSensors[i].CaptionFont=&ARIAL9pt;
			CalibrationPage1.CalibSensors[i].lineWdth=3;
			CalibrationPage1.CalibSensors[i].height=CalibrationPage1.CalibSensors[i].ValueFont->Height+2*CalibrationPage1.CalibSensors[i].lineWdth+2;
			CalibrationPage1.CalibSensors[i].LineColor=BLACK;
			CalibrationPage1.CalibSensors[i].CaptionColor=BLACK;
			CalibrationPage1.CalibSensors[i].ValueColor=BLACK;
			CalibrationPage1.CalibSensors[i].Color=WHITE;
			CalibrationPage1.CalibSensors[i].Value=(uint8_t*)malloc(6);
			if (CalibrationPage1.CalibSensors[i].Value)
					sprintf(CalibrationPage1.CalibSensors[i].Value,"%d",0);
			CalibrationPage1.CalibSensors[i].Caption=CalibCaptionNames[i];
		}
	for (i=0;i<4;i++)
			{
				CalibrationPage1.Label1[i].Caption="";
				CalibrationPage1.Label1[i].Value=Calibration1LabelsNames[i];
				CalibrationPage1.Label1[i].ValueFont=&ARIAL10pt;
				CalibrationPage1.Label1[i].color=BLACK;
			}
	for (i=0;i<4;i++)
			{
				CalibrationPage2.Label2[i].Caption="";
				CalibrationPage2.Label2[i].Value=Calibration2LabelsNames[i];
				CalibrationPage2.Label2[i].ValueFont=&ARIAL10pt;
				CalibrationPage2.Label2[i].color=BLACK;
			}
	for (i=0;i<2;i++)
			{
				CalibrationPage3.Label3[i].Caption="";
				CalibrationPage3.Label3[i].Value=Calibration3LabelsNames[i];
				CalibrationPage3.Label3[i].ValueFont=&ARIAL10pt;
				CalibrationPage3.Label3[i].color=BLACK;
			}
	for (i=0;i<3;i++)
			{
				CalibrationPage4.Label4[i].Caption="";
				CalibrationPage4.Label4[i].Value=Calibration4LabelsNames[i];
				CalibrationPage4.Label4[i].ValueFont=&ARIAL10pt;
				CalibrationPage4.Label4[i].color=BLACK;
			}
			
	Ystart=CalibrationPage1.Ystart+CalibrationPage1.Label1[0].ValueFont->Height+CalibrationPage1.CalibSensors[0].CaptionFont->Height+2;
//x settings	
	for (i=0;i<=CALIB_SENSORS_4-10;i)
			{
				if (i<24)
					{
						if (i==8)
								i=16;
						switch(z)
							{
								case	0:	{	
														Xstart=5;
														z++;
													}	break;
								case	1:	{Xstart=CalibrationPage1.CalibSensors[i-1].x+CalibrationPage1.CalibSensors[i-1].width+10;	z++;}	break;
								case	2:	{Xstart=CalibrationPage1.CalibSensors[i-1].x+CalibrationPage1.CalibSensors[i-1].width+60; z++;} break;
								case	3:	{Xstart=CalibrationPage1.CalibSensors[i-1].x+CalibrationPage1.CalibSensors[i-1].width+10;	z=0;} break;
							}
					
							CalibrationPage1.CalibSensors[i].x=CalibrationPage1.CalibSensors[i+1].x=CalibrationPage1.CalibSensors[i+8].x=CalibrationPage1.CalibSensors[i+9].x=Xstart;
					i=i+2;
					}
					else if(i<44)	
								{
									if (i==24)
										{
											z=0;
											i=32;
										}
									switch(z)
												{
													case 0: {Xstart=5; z++;}	break;
													default:{
																		Xstart=CalibrationPage1.CalibSensors[i-1].x+CalibrationPage1.CalibSensors[i-1].width+60;
																		if (z==2)
																				z=0;
																				else z++;
																	}	break;
												}
									CalibrationPage1.CalibSensors[i].x=CalibrationPage1.CalibSensors[i+1].x=CalibrationPage1.CalibSensors[i+6].x=CalibrationPage1.CalibSensors[i+7].x=Xstart;
								i=i+2;
								}						
					else 
						{
							if (i==44)
									z=0;
							switch(z)
										{
											case 0: {Xstart=5;z++;}break;
											default :{
																Xstart=CalibrationPage1.CalibSensors[i-1].x+CalibrationPage1.CalibSensors[i-1].width+40;	
																if (z==4)
																		z=0;
																		else
																				z++;
															} break;
										}
							CalibrationPage1.CalibSensors[i].x=CalibrationPage1.CalibSensors[i+5].x=CalibrationPage1.CalibSensors[i+10].x=Xstart;
					i++;	
					}
		}		
//y settings			
		for (i=0;i<=CALIB_SENSORS_2-9;i)
				{
					if (i==8)
							i=16;
					CalibrationPage1.CalibSensors[i].y=Ystart;
					CalibrationPage1.CalibSensors[i+1].y=CalibrationPage1.CalibSensors[i].y+CalibrationPage1.CalibSensors[i].height+CalibrationPage1.CalibSensors[i].CaptionFont->Height+4;
					CalibrationPage1.CalibSensors[i+8].y=CalibrationPage1.CalibSensors[i+1].y+CalibrationPage1.CalibSensors[i+1].height+CalibrationPage1.CalibSensors[i+1].CaptionFont->Height+CalibrationPage1.Label1[2].ValueFont->Height+10;
					CalibrationPage1.CalibSensors[i+9].y=CalibrationPage1.CalibSensors[i+8].y+CalibrationPage1.CalibSensors[i+8].height+CalibrationPage1.CalibSensors[i+8].CaptionFont->Height+4;
					i=i+2;
				}
		for (i=CALIB_SENSORS_2;i<=CALIB_SENSORS_3-8;i)
				{
					CalibrationPage1.CalibSensors[i].y=Ystart;
					CalibrationPage1.CalibSensors[i+1].y=CalibrationPage1.CalibSensors[i].y+CalibrationPage1.CalibSensors[i].height+CalibrationPage1.CalibSensors[i].CaptionFont->Height+2;
					CalibrationPage1.CalibSensors[i+6].y=CalibrationPage1.CalibSensors[i+1].y+CalibrationPage1.CalibSensors[i+1].height+CalibrationPage1.CalibSensors[i+1].CaptionFont->Height+CalibrationPage1.Label1[2].ValueFont->Height+10;
					CalibrationPage1.CalibSensors[i+7].y=CalibrationPage1.CalibSensors[i+6].y+CalibrationPage1.CalibSensors[i+6].height+CalibrationPage1.CalibSensors[i+6].CaptionFont->Height+4;
					i=i+2;
				}
		for (i=CALIB_SENSORS_3;i<CALIB_SENSORS_4;i)
				{
					for(j=0;j<5;j++)
							{
								CalibrationPage1.CalibSensors[i+j].y=Ystart;
							}
					Ystart=CalibrationPage1.CalibSensors[i].y+CalibrationPage1.CalibSensors[i].height+CalibrationPage1.CalibSensors[i].CaptionFont->Height+CalibrationPage4.Label4[0].ValueFont->Height+10;
					i=i+5;
				}
	CalibrationPage1.Label1[0].x=CalibrationPage1.Label1[2].x=CalibrationPage2.Label2[0].x=CalibrationPage2.Label2[2].x=CalibrationPage3.Label3[0].x=CalibrationPage3.Label3[1].x=CalibrationPage4.Label4[0].x=CalibrationPage4.Label4[1].x=CalibrationPage4.Label4[2].x=CalibrationPage1.CalibSensors[0].x;
	CalibrationPage1.Label1[1].x=CalibrationPage1.Label1[3].x=CalibrationPage2.Label2[1].x=CalibrationPage2.Label2[3].x=CalibrationPage1.CalibSensors[4].x;
	CalibrationPage1.Label1[0].y=CalibrationPage1.Label1[1].y=CalibrationPage2.Label2[0].y=CalibrationPage2.Label2[1].y=CalibrationPage3.Label3[0].y=CalibrationPage4.Label4[0].y=CalibrationPage1.Ystart;
	CalibrationPage1.Label1[2].y=CalibrationPage1.Label1[3].y=CalibrationPage2.Label2[2].y=CalibrationPage2.Label2[3].y=CalibrationPage3.Label3[1].y=CalibrationPage1.CalibSensors[1].y+CalibrationPage1.CalibSensors[1].height+5;
	CalibrationPage4.Label4[1].y=CalibrationPage1.CalibSensors[PC_VOL1_BOX].y+CalibrationPage1.CalibSensors[PC_VOL1_BOX].height+7;
	CalibrationPage4.Label4[2].y=CalibrationPage1.CalibSensors[PC_FREQ1_BOX].y+CalibrationPage1.CalibSensors[PC_FREQ1_BOX].height+7;
				
				
	CalibrationPage1.CalibrateButton.width=90;
	CalibrationPage1.CalibrateButton.height=20;
	CalibrationPage1.CalibrateButton.x=CalibrationPage1.Xstart+CalibrationPage1.pageWidth/2-CalibrationPage1.CalibrateButton.width/2;
	CalibrationPage1.CalibrateButton.y=CalibrationPage1.Ystart+CalibrationPage1.pageHeight-CalibrationPage1.CalibrateButton.height-4;
	CalibrationPage1.CalibrateButton.Color=0xC600;
	CalibrationPage1.CalibrateButton.Caption="";
	CalibrationPage1.CalibrateButton.Font=&ARIAL9pt;
	CalibrationPage1.CalibrateButton.CaptionWdth=GetStringLenght(CalibrationPage1.CalibrateButton.Caption,CalibrationPage1.CalibrateButton.Font);
	CalibrationPage1.CalibrateButton.CaptionColor=BLACK;
  CalibrationPage1.CalibrateButton.Image=NONE;	

		
	CalibrationPage1.NextButton.width=60;
	CalibrationPage1.NextButton.height=20;	
	CalibrationPage1.NextButton.x=CalibrationPage1.Xstart+CalibrationPage1.pageWidth-CalibrationPage1.NextButton.width-15;
	CalibrationPage1.NextButton.y=CalibrationPage1.CalibrateButton.y-CalibrationPage1.NextButton.height;	
	CalibrationPage1.NextButton.Color=0xC600;
	CalibrationPage1.NextButton.Caption=">";
	CalibrationPage1.NextButton.Font=&ARIAL9pt;
	CalibrationPage1.NextButton.CaptionWdth=GetStringLenght(CalibrationPage1.NextButton.Caption,CalibrationPage1.NextButton.Font);
	CalibrationPage1.NextButton.CaptionColor=BLACK;
  CalibrationPage1.NextButton.Image=NONE;		
	
	CalibrationPage2.PrevButton.width=60;
	CalibrationPage2.PrevButton.height=20;	
	CalibrationPage2.PrevButton.x=CalibrationPage1.NextButton.x-CalibrationPage1.NextButton.width-15;
	CalibrationPage2.PrevButton.y=CalibrationPage1.NextButton.y;	
	CalibrationPage2.PrevButton.Color=0xC600;
	CalibrationPage2.PrevButton.Caption="<";
	CalibrationPage2.PrevButton.Font=&ARIAL9pt;
	CalibrationPage2.PrevButton.CaptionWdth=GetStringLenght(CalibrationPage2.PrevButton.Caption,CalibrationPage2.PrevButton.Font);
	CalibrationPage2.PrevButton.CaptionColor=BLACK;
  CalibrationPage2.PrevButton.Image=NONE;	
	
	
	CalibrationPage2.CalibrateButton=CalibrationPage3.CalibrateButton=CalibrationPage4.CalibrateButton=&CalibrationPage1.CalibrateButton;
	CalibrationPage2.NextButton=CalibrationPage3.NextButton=CalibrationPage1.NextButton;
	CalibrationPage3.PrevButton=CalibrationPage4.PrevButton=CalibrationPage2.PrevButton;
	CalibrationPage4.PrevButton.x=CalibrationPage1.NextButton.x;
	CalibrationPage4.PrevButton.y=CalibrationPage4.PrevButton.y+5;
	
}
/*==================================================================*/
void	ShowCalibrationPage1 (void)
{
	uint8_t i;
	TFT_DrawRoundRectFilled	(CalibrationPage1.Xstart, CalibrationPage1.pageWidth,CalibrationPage1.Ystart, CalibrationPage1.pageHeight, 0,CalibrationPage1.BackColor);
	
	for (i=0;i<CALIB_SENSORS_1; i++)
			ShowEditBox(&CalibrationPage1.CalibSensors[i]);
	for (i=0;i<4;i++)
			ShowLabel(&CalibrationPage1.Label1[i], CalibrationPage1.BackColor);
	TFT_DrawButton(&CalibrationPage1.CalibrateButton);
	TFT_DrawButton(&CalibrationPage1.NextButton);
}
/*==================================================================*/
void	ShowCalibrationPage2 (void)
{
	uint8_t i;
	TFT_DrawRoundRectFilled	(CalibrationPage2.Xstart, CalibrationPage2.pageWidth,CalibrationPage2.Ystart, CalibrationPage2.pageHeight, 0,CalibrationPage2.BackColor);
	
	for (i=CALIB_SENSORS_1;i<CALIB_SENSORS_2; i++)
			ShowEditBox(&CalibrationPage1.CalibSensors[i]);
	for (i=0;i<4;i++)
			ShowLabel(&CalibrationPage2.Label2[i], CalibrationPage2.BackColor);
	TFT_DrawButton(CalibrationPage2.CalibrateButton);
	TFT_DrawButton(&CalibrationPage2.NextButton);
	TFT_DrawButton(&CalibrationPage2.PrevButton);
}
/*==================================================================*/
void	ShowCalibrationPage3 (void)
{
	uint8_t i;
	TFT_DrawRoundRectFilled	(CalibrationPage3.Xstart, CalibrationPage3.pageWidth,CalibrationPage3.Ystart, CalibrationPage3.pageHeight, 0,CalibrationPage3.BackColor);
	
	for (i=CALIB_SENSORS_2;i<CALIB_SENSORS_3; i++)
			ShowEditBox(&CalibrationPage1.CalibSensors[i]);
	for (i=0;i<2;i++)
			ShowLabel(&CalibrationPage3.Label3[i], CalibrationPage3.BackColor);
	TFT_DrawButton(CalibrationPage3.CalibrateButton);
	TFT_DrawButton(&CalibrationPage3.PrevButton);
	TFT_DrawButton(&CalibrationPage3.NextButton);	
}
/*==================================================================*/
void	ShowCalibrationPage4 (void)
{
	uint8_t i;
	TFT_DrawRoundRectFilled	(CalibrationPage4.Xstart, CalibrationPage4.pageWidth,CalibrationPage4.Ystart, CalibrationPage4.pageHeight, 0,CalibrationPage4.BackColor);
	
	for (i=CALIB_SENSORS_3;i<CALIB_SENSORS_4; i++)
			ShowEditBox(&CalibrationPage1.CalibSensors[i]);
	for (i=0;i<3;i++)
			ShowLabel(&CalibrationPage4.Label4[i], CalibrationPage3.BackColor);
	TFT_DrawButton(CalibrationPage4.CalibrateButton);
	TFT_DrawButton(&CalibrationPage4.PrevButton);
}
/*==================================================================*/
void	InitAdditionalPage	(void)
{
	uint8_t i;
	uint8_t len;
	
	AdditionalPage.Xstart=CalibrationPage1.Xstart;
	AdditionalPage.Ystart=CalibrationPage1.Ystart;	
	AdditionalPage.pageWidth=CalibrationPage1.pageWidth;
	AdditionalPage.pageHeight=CalibrationPage1.pageHeight;
	AdditionalPage.BackColor=CalibrationPage1.BackColor;

	for (i=0;i<5;i++)
		{
			AdditionalPage.SettingsBoxes[i].width=105;
			AdditionalPage.SettingsBoxes[i].ValueFont=&ARIAL9pt;
			AdditionalPage.SettingsBoxes[i].CaptionFont=&ARIAL9pt;
			AdditionalPage.SettingsBoxes[i].lineWdth=3;
			AdditionalPage.SettingsBoxes[i].height=AdditionalPage.SettingsBoxes[i].ValueFont->Height+2*AdditionalPage.SettingsBoxes[i].lineWdth+2;
			AdditionalPage.SettingsBoxes[i].LineColor=BLACK;
			AdditionalPage.SettingsBoxes[i].CaptionColor=BLACK;
			AdditionalPage.SettingsBoxes[i].ValueColor=BLACK;
			AdditionalPage.SettingsBoxes[i].Color=WHITE;
			AdditionalPage.SettingsBoxes[i].Caption=SettingsBoxesNames[i];
		}
	
	AdditionalPage.SettingsBoxes[0].Value=(uint8_t*)calloc(13,1);
	if (AdditionalPage.SettingsBoxes[0].Value)
		{
			len=strlen(ADCModes[0]);
			strncpy(AdditionalPage.SettingsBoxes[0].Value,ADCModes[0],len);
		}
	
	AdditionalPage.SettingsBoxes[1].Value=(uint8_t*)calloc(8,1);
	if (AdditionalPage.SettingsBoxes[1].Value)
		{
			len=strlen(ADCCng[0]);
			strncpy(AdditionalPage.SettingsBoxes[1].Value,ADCCng[0],len);
		}
	AdditionalPage.SettingsBoxes[2].Value=(uint8_t*)calloc(15,1);
	if (AdditionalPage.SettingsBoxes[2].Value)
		{
			len=strlen(DACCng[0]);
			strncpy(AdditionalPage.SettingsBoxes[2].Value,DACCng[0],len);
		}
	AdditionalPage.SettingsBoxes[3].Value=(uint8_t*)calloc(15,1);
	if (AdditionalPage.SettingsBoxes[3].Value)
		{
			len=strlen(DACCng[0]);
			strncpy(AdditionalPage.SettingsBoxes[3].Value,DACCng[0],len);
		}
	AdditionalPage.SettingsBoxes[4].Value=(uint8_t*)calloc(15,1);
	if (AdditionalPage.SettingsBoxes[4].Value)
		{
			len=strlen(SSTypes[0]);
			strncpy(AdditionalPage.SettingsBoxes[4].Value,SSTypes[0],len);
		}
	for (i=0;i<5;i++)
			AdditionalPage.SettingsBoxes[i].ItemIndex=0;

	for (i=0;i<3;i++)
			{
				
				AdditionalPage.SettingsLabels[i].Caption="";
				AdditionalPage.SettingsLabels[i].Value=SettingsLabelNames[i];
				AdditionalPage.SettingsLabels[i].ValueFont=&ARIAL10pt;
				AdditionalPage.SettingsLabels[i].color=BLACK;
				AdditionalPage.SettingsLabels[i].x=(TFT_WIDTH-GetStringLenght(AdditionalPage.SettingsLabels[i].Value,AdditionalPage.SettingsLabels[i].ValueFont))/2;
			}
	AdditionalPage.SettingsLabels[0].y=AdditionalPage.Ystart+2;
	
	
	AdditionalPage.SettingsBoxes[0].x=AdditionalPage.SettingsBoxes[2].x=AdditionalPage.SettingsBoxes[4].x=5;
	AdditionalPage.SettingsBoxes[1].x=AdditionalPage.SettingsBoxes[3].x=AdditionalPage.SettingsBoxes[0].x+AdditionalPage.SettingsBoxes[0].width+90;	
	AdditionalPage.SettingsBoxes[0].y=AdditionalPage.SettingsBoxes[1].y=AdditionalPage.SettingsLabels[0].y+AdditionalPage.SettingsLabels[0].ValueFont->Height+AdditionalPage.SettingsBoxes[0].CaptionFont->Height+5;
	AdditionalPage.SettingsLabels[1].y=AdditionalPage.SettingsBoxes[0].y+AdditionalPage.SettingsBoxes[0].height+2;
	AdditionalPage.SettingsBoxes[2].y=AdditionalPage.SettingsBoxes[3].y=AdditionalPage.SettingsLabels[1].y+AdditionalPage.SettingsLabels[1].ValueFont->Height+AdditionalPage.SettingsBoxes[0].CaptionFont->Height+5;
	AdditionalPage.SettingsLabels[2].y=AdditionalPage.SettingsBoxes[2].y+AdditionalPage.SettingsBoxes[2].height+2;
	AdditionalPage.SettingsBoxes[4].y=AdditionalPage.SettingsLabels[2].y+AdditionalPage.SettingsLabels[2].ValueFont->Height+AdditionalPage.SettingsBoxes[0].CaptionFont->Height+5;

			
	AdditionalPage.SaveSetButton.width=75;
	AdditionalPage.SaveSetButton.height=20;	
	AdditionalPage.SaveSetButton.x=TFT_WIDTH/2-AdditionalPage.SaveSetButton.width/2;
	AdditionalPage.SaveSetButton.y=CalibrationPage1.NextButton.y;	
	AdditionalPage.SaveSetButton.Color=0xC600;
	AdditionalPage.SaveSetButton.Caption="";
	AdditionalPage.SaveSetButton.Font=&ARIAL9pt;
	AdditionalPage.SaveSetButton.CaptionWdth=GetStringLenght(AdditionalPage.SaveSetButton.Caption,AdditionalPage.SaveSetButton.Font);
	AdditionalPage.SaveSetButton.CaptionColor=BLACK;
  AdditionalPage.SaveSetButton.Image=NONE;	
}
/*==================================================================*/
void	ShowAdditionalPage	(void)
{
	uint8_t i;
	TFT_DrawRoundRectFilled	(AdditionalPage.Xstart, AdditionalPage.pageWidth,AdditionalPage.Ystart, AdditionalPage.pageHeight, 0,AdditionalPage.BackColor);
	
	for (i=0;i<5;i++)
			ShowEditBox(&AdditionalPage.SettingsBoxes[i]);
	for (i=0;i<3;i++)
			ShowLabel(&AdditionalPage.SettingsLabels[i], AdditionalPage.BackColor);
	TFT_DrawButton(&AdditionalPage.SaveSetButton);
}
/*==================================================================*/
void	KeyboardInit	(void)
{
			
				Keyboard.width=TFT_WIDTH/11;
				Keyboard.CaptionFont=&ARIAL24pt;		
				Keyboard.height=Keyboard.CaptionFont->Height+6;
				Keyboard.x=4;
				Keyboard.y=TFT_HEIGHT-4*Keyboard.height;
				Keyboard.Color=0xC600;
				Keyboard.CaptionString=RusKeyboardKeyNames;
				Keyboard.CaptionColor=BLACK;
				
					Keyboard.KeyNames[0]="Aa";
					Keyboard.KeyNames[1]="12!?";
					Keyboard.KeyNames[2]="ABC";
					Keyboard.KeyNames[3]="Del";
					Keyboard.KeyNames[4]="Enter";

				Keyboard.RetVal=(uint8_t*)malloc(STRING_LENGHT);
}
/*==================================================================*/
void	ShowKeyboard	(void)
{
	
uint8_t   i, num, num1, num2, num3, linewidth=3;
uint16_t  X=Keyboard.x,Y=Keyboard.y,width;
uint8_t   ch[1];
uint8_t*	ptr;	

TFT_DrawRoundRectFilled	(ConfigPage.Xstart, ConfigPage.pageWidth,ConfigPage.Ystart, ConfigPage.pageHeight, 0,ConfigPage.BackColor);

switch	(Keyboard.Type){
	case RUSSIAN:
			{
				Keyboard.CaptionString=RusKeyboardKeyNames;
				ptr=Keyboard.CaptionString;
				width=Keyboard.width;
				num=33;
				num1=10;
				num2=21;
				num3=32;
				Keyboard.KeyNames[2]="ABC";
			}	break;
	case	ENGLISH:
			{
				Keyboard.CaptionString=EngKeboardKeyNames;
				ptr=Keyboard.CaptionString;
				width=Keyboard.width+Keyboard.width/10;
				num=28;
				num1=9;
				num2=19;
				num3=27;
				Keyboard.KeyNames[2]="";
			}	break;
	case	DIGIT:
		 {
			 Keyboard.CaptionString=DigitSymbolKeyboardKeyNames;
			 ptr=Keyboard.CaptionString;
			 width=Keyboard.width+Keyboard.width/10;
			 num=28;
			 num1=9;
			 num2=19;
			 num3=27;
		 } break;
	default: break;
	}
	
	TFT_DrawRect	(X, Y-Keyboard.CaptionFont->Height-6, (num1+1)*width, Keyboard.height,linewidth, BLACK);
	TFT_DrawRoundRectFilled	(X+linewidth, (num1+1)*width-2*linewidth,Y-Keyboard.CaptionFont->Height-6+linewidth, Keyboard.height-2*linewidth, 0,WHITE);
	TFT_Log(10, Keyboard.y-Keyboard.CaptionFont->Height-6+(Keyboard.height-Keyboard.CaptionFont->Height)/2,Keyboard.RetVal,WHITE,BLACK,&ARIAL24pt);

		for (i=0;i<num;i++)
				{
					TFT_DrawRect	(X, Y, width, Keyboard.height,linewidth, BLACK);
					TFT_DrawRoundRectFilled	(X+linewidth, width-2*linewidth,Y+linewidth, Keyboard.height-2*linewidth, 0,Keyboard.Color);
					ch[0]=GetChar(ptr++);
					TFT_Log(X+(width-GetStringLenght(ch,Keyboard.CaptionFont))/2, Y+(Keyboard.height-Keyboard.CaptionFont->Height)/2,ch,Keyboard.Color,Keyboard.CaptionColor,Keyboard.CaptionFont);
					if ((i==num1)||(i==num2)||(i==num3))
							{
								X=Keyboard.x;
								Y=Y+Keyboard.height;
							}
							else
									X=X+width;
				}
	
		for (i=0;i<5;i++)
				{
					
					TFT_DrawRect(X, Y, width, Keyboard.height,linewidth, BLACK);
					TFT_DrawRoundRectFilled	(X+linewidth, width-2*linewidth,Y+linewidth, Keyboard.height-2*linewidth, 0,Keyboard.Color);
					TFT_Log(X+(width-GetStringLenght(Keyboard.KeyNames[i],&ARIAL9pt))/2, Y+(Keyboard.height-ARIAL9pt.Height)/2,Keyboard.KeyNames[i],Keyboard.Color,Keyboard.CaptionColor,&ARIAL9pt);
					if (i==1)
						{
							TFT_DrawRect(X+width, Y, 6*width, Keyboard.height,linewidth, BLACK);
							TFT_DrawRoundRectFilled	(X+width+linewidth, 6*width-2*linewidth,Y+linewidth, Keyboard.height-2*linewidth, 0,Keyboard.Color);
							TFT_Log(X, Y,"",Keyboard.Color,Keyboard.CaptionColor,&ARIAL9pt);
						  if (Keyboard.Type!=RUSSIAN)
									X=X+width+6*width;
									else
												X=X+6*width;
						}
						else 
								{
									X=X+width;
									if (i==3)
											{
												width=2*width;
												if (Keyboard.Type!=RUSSIAN)
														{
															Y=Y-Keyboard.height;
															X=X-width;
														}
											}
								}
				}		
Keyboard.State=PROCESSING;
}
/*==================================================================*/
void	ShowPage	(void)
{
	switch	(PageControl.ActivePage)
					{
						case	CONTROL_PAGE:				ShowControlPage(); 				break;
						case	CONFIG_PAGE:				ShowConfigPage(); 				break;
						case	SETTINGS_PAGE:			/*ShowSettingsPage();	*/			break;
						case	CALIBRATE_PAGE1:		ShowCalibrationPage1(); 	break;
						case	CALIBRATE_PAGE2:		ShowCalibrationPage2(); 	break;
						case	CALIBRATE_PAGE3:		ShowCalibrationPage3(); 	break;
						case	CALIBRATE_PAGE4:		ShowCalibrationPage4(); 	break;
						case	ADDITIONAL_PAGE:		ShowAdditionalPage(); 		break;
						default:	break;
					}
}
/*==================================================================*/
void	UpdateInjects	(uint32_t InjectCng, CIRCLE* Injects)
{
	uint8_t i;
	
	for (i=0;i<NUM_INJECTS;i++)
			{
				if (InjectCng&(1<<i))
						Injects->color=RED1;
						else
								Injects->color=0xC600;
			}
}
/*==================================================================*/
void	SwitchButton	(BUTTON* Btn,uint8_t condition,uint8_t* str1, uint8_t* str2)
{
if (condition)
		Btn->Caption=str1;
		else
				Btn->Caption=str2;
}
/*==================================================================*/
void	UpdateControlParams		(void)
{
uint8_t i;
	
	TFT_DrawRoundRectFilled(0,ControlPage.ModeButton.x,ControlPage.AutoSpeed.y,ControlPage.AutoSpeed.ValueFont->Height, 0,GREEN);
	TFT_DrawRoundRectFilled(0,ControlPage.ModeButton.x,ControlPage.Time.y,ControlPage.Time.ValueFont->Height, 0,GREEN);
		
	TFT_Log(ControlPage.AutoSpeed.x,ControlPage.AutoSpeed.y,ControlPage.AutoSpeed.Value,ControlPage.BackColor,ControlPage.AutoSpeed.color,ControlPage.AutoSpeed.ValueFont);
	TFT_Log(ControlPage.PumpSpeed.x,ControlPage.PumpSpeed.y,ControlPage.PumpSpeed.Value,ControlPage.BackColor,ControlPage.PumpSpeed.color,ControlPage.PumpSpeed.ValueFont);
	TFT_Log(ControlPage.Temperature.x,ControlPage.Temperature.y,ControlPage.Temperature.Value,ControlPage.BackColor,ControlPage.Temperature.color,ControlPage.Temperature.ValueFont);
	TFT_Log(ControlPage.Time.x,ControlPage.Time.y,ControlPage.Time.Value,ControlPage.BackColor,ControlPage.Time.color,ControlPage.Time.ValueFont);
	TFT_Log(ControlPage.Square.x,ControlPage.Square.y,ControlPage.Square.Value,ControlPage.BackColor,ControlPage.Square.color,ControlPage.Square.ValueFont);
	TFT_Log(ControlPage.Distance.x,ControlPage.Distance.y,ControlPage.Distance.Value,ControlPage.BackColor,ControlPage.Distance.color,ControlPage.Distance.ValueFont);
	TFT_Log(ControlPage.FillingRate.x,ControlPage.FillingRate.y,ControlPage.FillingRate.Value,ControlPage.BackColor,ControlPage.FillingRate.color,ControlPage.FillingRate.ValueFont);
	TFT_Log(ControlPage.FillingWidth.x,ControlPage.FillingWidth.y,ControlPage.FillingWidth.Value,ControlPage.BackColor,ControlPage.FillingWidth.color,ControlPage.FillingWidth.ValueFont);
	TFT_Log(ControlPage.CurrentVolume.x,ControlPage.CurrentVolume.y,ControlPage.CurrentVolume.Value,ControlPage.BackColor,ControlPage.CurrentVolume.color,ControlPage.CurrentVolume.ValueFont);
	TFT_Log(ControlPage.FilledVolume.x,ControlPage.FilledVolume.y,ControlPage.FilledVolume.Value,ControlPage.BackColor,ControlPage.FilledVolume.color,ControlPage.FilledVolume.ValueFont);
	UpdateInjects(Actuators.Injects.InjectConfiguration,ControlPage.InjectLeds);	
	
//Show error message
TFT_Log(ControlPage.AlarmMessage.x+(TFT_WIDTH-GetStringLenght(ControlPage.AlarmMessage.Value,ControlPage.AlarmMessage.ValueFont))/2,ControlPage.AlarmMessage.y+10,ControlPage.AlarmMessage.Value,ControlPage.BackColor,ControlPage.AlarmMessage.color,&ARIAL10pt);
//Show Alarm Leds
for (i=0;i<ALARM_NUM;i++)
		ShowLed	(&ControlPage.AlarmLeds[i]);
	
//Show Control Tumblers	

	ShowTumbler(&ControlPage.BackBitumTmb, ControlPage.BackColor);
	ShowTumbler(&ControlPage.HeatingTmb, ControlPage.BackColor);	

//Show mode buttons	
TFT_DrawButton(&ControlPage.ModeButton);		
//Show current injects state		
ShowInjectLeds(ControlPage.InjectLeds);
}
/*==================================================================*/
void	LoadDisplayParameters	(void)	//load middle params to display data
{
uint8_t i;
//ControlParams	
sprintf(ControlPage.AutoSpeed.Value,"%d",Sensors.AutoSpeedSensor.CurrentValue);
sprintf(ControlPage.PumpSpeed.Value,"%d",Sensors.PumpSpeedSensor.CurrentValue);		
sprintf(ControlPage.Time.Value,"%d",ComputedParams.TimeGone);
sprintf(ControlPage.Distance.Value,"%d",ComputedParams.DistanceGone);	

sprintf(ControlPage.Square.Value,"%d",ComputedParams.SquareFilled);
sprintf(ControlPage.FillingWidth.Value,"%d",ComputedParams.FillingWidth);		
sprintf(ControlPage.FillingRate.Value,"%d",CurrentParameters.nFillingRate);
sprintf(ControlPage.Temperature.Value,"%d",Sensors.TempSensor.CurrentValue);	

sprintf(ControlPage.CurrentVolume.Value,"%d",ComputedParams.MixtureVolumeIn);		
sprintf(ControlPage.FilledVolume.Value,"%d",ComputedParams.MixtureVolumeOut);
//AlarmLeds
for (i=0;i<ALARM_NUM;i++)
		{
			if (DiscreteInputs&(1<<i))
						ControlPage.AlarmLeds[i].color=RED1;
						else
								ControlPage.AlarmLeds[i].color=0xC600;	
		}
//ErrorMessage
if (!CurrentParameters.ErrorMsg)
		{
			if (ControlPage.AlarmMessage.Value!="")
				{
					memset(ControlPage.AlarmMessage.Value,0,51);
					TFT_DrawRoundRectFilled(0,TFT_WIDTH,ControlPage.AlarmMessage.y,ControlPage.AlarmMessage.CaptionFont->Height, 0,GREEN);
				}
		}
			else
					{
						if (strcmp(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1]))
								{
									TFT_DrawRoundRectFilled(0,TFT_WIDTH,ControlPage.AlarmMessage.y,ControlPage.AlarmMessage.CaptionFont->Height, 0,GREEN);
									memset(ControlPage.AlarmMessage.Value,0,51);
									if (strlen(msg[CurrentParameters.ErrorMsg-1])<=50)
											strncpy(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1],strlen(msg[CurrentParameters.ErrorMsg-1]));
											else strncpy(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1],50);
								}
					}
//ControlTumblers	
	ControlPage.BackBitumTmb.State=Actuators.BitumenBackValve;
	ControlPage.HeatingTmb.State	=Actuators.HeatingManual;

//Switch buttton
	SwitchButton(&ControlPage.ModeButton,Actuators.TCMode==AUTO_MODE,"AUTO","HAND");
//Switch Injects 
UpdateInjects(Actuators.Injects.InjectConfiguration,ControlPage.InjectLeds);					
}		
/*==================================================================*/
void	AlarmMsgShow	(void)
{
	
//ErrorMessage
if (!CurrentParameters.ErrorMsg)
		{
			if (ControlPage.AlarmMessage.Value!="")
				{
					memset(ControlPage.AlarmMessage.Value,0,51);
					TFT_DrawRoundRectFilled(0,TFT_WIDTH,ControlPage.AlarmMessage.y,ControlPage.AlarmMessage.CaptionFont->Height, 0,GREEN);
				}
		}
			else
					{
						if (strcmp(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1]))
								{
									TFT_DrawRoundRectFilled(0,TFT_WIDTH,ControlPage.AlarmMessage.y,ControlPage.AlarmMessage.CaptionFont->Height, 0,GREEN);
									memset(ControlPage.AlarmMessage.Value,0,51);
									if (strlen(msg[CurrentParameters.ErrorMsg-1])<=50)
											strncpy(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1],strlen(msg[CurrentParameters.ErrorMsg-1]));
											else strncpy(ControlPage.AlarmMessage.Value,msg[CurrentParameters.ErrorMsg-1],50);
								}
					}
TFT_Log(ControlPage.AlarmMessage.x+(TFT_WIDTH-GetStringLenght(ControlPage.AlarmMessage.Value,&ARIAL10pt))/2,ControlPage.AlarmMessage.y+10,ControlPage.AlarmMessage.Value,ControlPage.BackColor,ControlPage.AlarmMessage.color,&ARIAL10pt);
}