#include "GraphObjects.h"
#include "GraphInterface.h"
/*==================================================================*/
void	SetPixelXY	(uint16_t	x,uint16_t	y,uint16_t color)
{
	WindowSet(x,x+1,y,y+1);
	LCD_WriteCommand(CMD_WR_MEMSTART);
	WriteDataBus(color,1);
}
/*==============================================================================================*/
void	TFT_DrawHorLine				(uint16_t	Xpos,uint16_t Ypos, uint32_t Lenght, uint8_t LineWidth,uint32_t Color)
{
	uint16_t i,j;
	
	for (i=Ypos; i<Ypos+LineWidth; i++)
  {
    Set_Y(i,i);
		LCD_WriteCommand(CMD_WR_MEMSTART);
		for (j=Xpos; j<Xpos+Lenght;j++)
				{
					Set_X(Xpos,Xpos+Lenght);
					LCD_WriteCommand(CMD_WR_MEMSTART);
					WriteDataBus(Color,Lenght);
				}
	}
}
/*==================================================================================================================*/
void	TFT_DrawRoundRectFilled	(uint16_t Xpos, uint16_t Width,uint16_t Ypos, uint16_t Height, uint8_t prc,uint16_t Color)
//prc percent of cut
{
	uint16_t i=1; 
	uint16_t j=1;
	uint16_t X=Xpos;
	uint16_t Y=Ypos;
	uint16_t k;
	
	prc=Width*prc/100;
	if (prc==0)
			{
				for (k=0;k<Height;k++)
						{
							Set_Y(Y+k,Y+k+1);
							Set_X(X,X+Width);
							LCD_WriteCommand(CMD_WR_MEMSTART);
							WriteDataBus(Color,Width);
						}
			}//WindowSet(X,X+Width,Y,Y+Height);
		 else
				//WindowSet(X,X+Width,Y+prc,Y+Height-prc);
				{
					for (k=0;k<Height-prc;k++)
						{
							Set_Y(Y+k+prc,Y+k+1-prc);
							Set_X(X,X+Width);
							LCD_WriteCommand(CMD_WR_MEMSTART);
							WriteDataBus(Color,Width);
						}
				}	
			
	//WriteCommand(CMD_WR_MEMSTART);
	//WriteDataBus(Color,Width*Height);
	if (prc)
			{
				while (i<=prc)
							{
								TFT_DrawHorLine(X+j,Ypos+prc-i, Width-2*j+1, 1,Color);
								i++;
								TFT_DrawHorLine(X+j,Ypos+prc-i, Width-2*j+1, 1,Color);
								i++;
								j++;
							}
				i=1;
				j=1;
				while (i<=prc)
							{
								TFT_DrawHorLine(X+j,Ypos+Height-prc+i-1, Width-2*j+1, 1,Color);
								i++;
								TFT_DrawHorLine(X+j,Ypos+Height-prc+i-1, Width-2*j+1, 1,Color);
								i++;
								j++;
							}
			}
}
/*==================================================================================================================*/
void	TFT_DrawRect	(uint16_t Xpos, uint16_t Ypos, uint16_t Width, uint16_t Height, uint8_t LineWidth, uint16_t color)
{
	TFT_DrawHorLine(Xpos,Ypos, Width, LineWidth,color);
	TFT_DrawHorLine(Xpos,Ypos+Height-LineWidth, Width, LineWidth,color);
	TFT_DrawHorLine(Xpos,Ypos, LineWidth, Height,color);
	TFT_DrawHorLine(Xpos+Width-LineWidth,Ypos, LineWidth, Height,color);
}
/*==================================================================================================================*/
void	TFT_DrawRoundRect (uint16_t Xpos, uint16_t Width,uint16_t Ypos, uint16_t Height, uint16_t LineWidth, uint8_t prc,uint16_t color) 
{
	uint16_t i=1;
	
	if (Width<Height)
			prc=Width*prc/100;
			else prc=Height*prc/100;
	TFT_DrawHorLine(Xpos+prc*LineWidth, Ypos, Width-2*prc*LineWidth,LineWidth, color);
	TFT_DrawHorLine(Xpos+prc*LineWidth, Ypos+Height-LineWidth, Width-2*prc*LineWidth,LineWidth, color);	
	TFT_DrawHorLine(Xpos, Ypos+prc*LineWidth, LineWidth,Height-2*prc*LineWidth, color);
	TFT_DrawHorLine(Xpos+Width-LineWidth, Ypos+prc*LineWidth, LineWidth,Height-2*prc*LineWidth, color);	
	if (prc)
			{
				while (i<=prc)
							{
								TFT_DrawHorLine(Xpos+Width-LineWidth-i*LineWidth,Ypos+prc*LineWidth-i*LineWidth, LineWidth,LineWidth,color);
								TFT_DrawHorLine(Xpos+i*LineWidth,Ypos+prc*LineWidth-i*LineWidth, LineWidth,LineWidth,color);
								
								i++;
							}
				i=1;
				while (i<=prc)
							{
								TFT_DrawHorLine(Xpos+Width-prc*LineWidth-LineWidth+i*LineWidth,Ypos+Height-LineWidth-i*LineWidth, LineWidth, LineWidth, color);
								TFT_DrawHorLine(Xpos+prc*LineWidth-i*LineWidth,Ypos+Height-LineWidth-i*LineWidth, LineWidth, LineWidth, color);
								i++;
							}
			}
}
/*==================================================================================================================*/
void	TFT_DrawCircleMy	(uint16_t X0, uint16_t Y0, float R, uint16_t color)
{
	double x,y;
	
	x=X0;
	while(x<=X0+R)
				{
					y=(double)my_sqrt(R*R-(x-X0)*(x-X0))+Y0;
	  			SetPixelXY(x,y,color);
					SetPixelXY(x,2*Y0-y,color);
					x=x+0.05;
				}
	x=X0;
	while (x>=X0-R)
				{
					y=(double)my_sqrt(R*R-(x-X0)*(x-X0))+Y0;
				  SetPixelXY(x, y,color);
				  SetPixelXY(x, 2*Y0-y,color);
					x=x-0.05;
		   }	
}
/*==================================================================================================================*/
void	TFT_DrawFilledCircleMy (uint16_t X0, uint16_t Y0, float R, uint16_t color)
{
  static uint16_t    y,i,j;

					for (j=X0;j<=X0+R;j++)
							{
								Set_X(j,j+1);
								LCD_WriteCommand(CMD_WR_MEMSTART);
								y=my_sqrt(R*R-(j-X0)*(j-X0))+Y0;
							for (i=2*Y0-y;i<y;i++)
									{
										Set_Y(i,i);
										LCD_WriteCommand(CMD_WR_MEMSTART);
										WriteDataBus(color,1);
									}
							}		
							
						for (j=X0;j>=X0-R;j--)
							{
								Set_X(j,j+1);
								LCD_WriteCommand(CMD_WR_MEMSTART);
								y=my_sqrt(R*R-(j-X0)*(j-X0))+Y0;
							for (i=2*Y0-y;i<y;i++)
									{
										Set_Y(i,i);
										LCD_WriteCommand(CMD_WR_MEMSTART);
										WriteDataBus(color,1);
									}
							}
}
/*==================================================================================================================*/
void 	TFT_DrawImage	(uint16_t Xpos, uint16_t Ypos, uint16_t width, uint16_t height, uint16_t* img)
{
uint32_t i,j;
					
		for (j=Ypos;j<Ypos+height;j++)
			{
				WindowSet(Xpos,Xpos+width,j,j+1);
			  LCD_WriteCommand(CMD_WR_MEMSTART);
				RDSET;
				RSSET;
				CSCLR;
				for(i=Xpos;i<Xpos+width;i++)
					{
					WRCLR;
					DATA_BUS=((*img>>11)<<3)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((*img>>5)&0x3f)<<2)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((*img++)&0x1f)<<3)<<8;
					WRSET;
					}
					WRSET;		
					CSSET;
			}
}
/*==================================================================================================================*/
void  TFT_DrawBmpImg (uint16_t Xpos, uint16_t width, uint16_t Ypos, uint16_t height,uint16_t color, uint16_t backcolor,uint8_t* img)//   -,   - 1-  , 0 - 
{
uint32_t index = 0, counter = 0,ctr=0;
uint32_t k=0;
	
	for (index = 0; index < height; index++)
  {
    WindowSet(Xpos,Xpos+width,Ypos+index,Ypos+index+1);
		LCD_WriteCommand(CMD_WR_MEMSTART);
				RDSET;
				RSSET;
				CSCLR;
    for (counter = 0; counter < width; counter++)
    {
      if (ctr==8)
				{
				 *img++;
					ctr=0;	
				}
			//k=*img;
			if ((*img&(1<<ctr))==0)
			/* SmallFonts have bytes in reverse order */
     // k=*img&(1<<counter);
			//if (k==0)// ((*img)& (1 << counter) == 0x00) 
      {
					WRCLR;
					DATA_BUS=((backcolor>>11)<<3)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((backcolor>>5)&0x3f)<<2)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((backcolor)&0x1f)<<3)<<8;
					WRSET;
      }
      else
      {
        	WRCLR;
					DATA_BUS=((color>>11)<<3)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((color>>5)&0x3f)<<2)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((color)&0x1f)<<3)<<8;
					WRSET;
      }
		ctr++;
		}
		WRSET;		
		CSSET;
	}	
}
/*==================================================================================================================*/
void	TFT_DrawButton (BUTTON* Button)
{

	if (Button->Image==NONE)
			{
				TFT_DrawRoundRect	(Button->x-1, Button->width+2,Button->y-1, Button->height+2,1,0,BLACK);
				TFT_DrawRoundRectFilled	(Button->x, Button->width,Button->y, Button->height, 0,Button->Color);
				TFT_Log(Button->x+((Button->width-Button->CaptionWdth)/2),Button->y+(Button->height-16)/2,Button->Caption,Button->Color,Button->CaptionColor,Button->Font);
			}
			else 
				{
					TFT_DrawRoundRect	(Button->x-1, Button->width+2,Button->y-1, Button->height+2,1,0,BLACK);
					TFT_DrawRoundRectFilled	(Button->x, Button->width+20,Button->y, Button->height+1, 0,Button->Color);
					TFT_DrawBmpImg(Button->x+10, Button->width, Button->y+1, Button->height,Button->CaptionColor, Button->Color,Button->Image);
				}
}
/*==================================================================================================================*/