#include 	"stm32f10x.h"
#include 	"Modbus_ASCIIGlobalVars.h"
#include	"ModbusMaster_functions.h"
//(0x17)==================================================================================
void	Read_WriteMulRegister_Master	(MODBUS_DATA *MODBUS, uint8_t slave_id, uint16_t rd_start_addr, uint16_t rd_quantity, uint16_t wr_start_addr,uint16_t wr_quantity, uint16_t wr_buff[])
{
uint16_t	i=0;
uint16_t	j=0;

if (!(MODBUS->StateFlags&(1<<MB_REQUEST_READY_FLAG)))
	{
		MODBUS->StartAddr=rd_start_addr;
		MODBUS->Device_addr=slave_id;
		MODBUS->MODBUS_FRAME[DATA_FIELD]=rd_start_addr/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+1]=rd_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD+2]=rd_quantity/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+3]=rd_quantity;
		MODBUS->MODBUS_FRAME[DATA_FIELD+4]=wr_start_addr/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+5]=wr_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD+6]=wr_quantity/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+7]=wr_quantity;
		MODBUS->MODBUS_FRAME[DATA_FIELD+8]=2*wr_quantity;

		j=11;
		for	(i=0;i<wr_quantity;i++)
			{
	 			MODBUS->MODBUS_FRAME[j++]=wr_buff[i]/0x100;
	 			MODBUS->MODBUS_FRAME[j++]=wr_buff[i];
			}
		MODBUS->Transmit_data_lenght=12+i;
		MODBUS->MODBUS_FRAME[MODBUS->Transmit_data_lenght]=CountRequestLRC_Master(MODBUS->Transmit_data_lenght++,&MODBUS);
		FormFrameStartEnd_Master(slave_id, 0x17, MODBUS);
		
}
}
//(0x10)//=================================================================
void	WriteMultipleRegister_Master	(MODBUS_DATA *MODBUS,uint8_t slave_id,uint16_t wr_start_addr,uint16_t wr_quantity,uint16_t wr_buff[])
{
uint8_t		i;
uint8_t		j;
uint16_t	temp;

if (!(MODBUS->StateFlags&(1<<MB_REQUEST_READY_FLAG)))
	{
		MODBUS->MODBUS_FRAME[DATA_FIELD]=wr_start_addr/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+1]=wr_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD+2]=wr_quantity/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+3]=wr_quantity;
		MODBUS->MODBUS_FRAME[DATA_FIELD+4]=2*wr_quantity;

		j=5;
		for	(i=0;i<(2*wr_quantity);i++)
			{
	 			MODBUS->MODBUS_FRAME[DATA_FIELD+j]=wr_buff[i]/0x100;
	 			j++;
	 			MODBUS->MODBUS_FRAME[DATA_FIELD+j]=wr_buff[i];
	 			j++;
			}
		MODBUS->Transmit_data_lenght=8+j;
		MODBUS->MODBUS_FRAME[MODBUS->Transmit_data_lenght]=CountRequestLRC_Master(MODBUS->Transmit_data_lenght++,&MODBUS);
		FormFrameStartEnd_Master(slave_id, 0x10, MODBUS);
	}
}
//(0x06)===================================================================
void	WriteSingleRegister_Master	(MODBUS_DATA *MODBUS,uint8_t slave_id,uint16_t wr_start_addr,uint16_t wr_value)
{
if (!(MODBUS->StateFlags&(1<<MB_REQUEST_READY_FLAG)))
	{
		MODBUS->MODBUS_FRAME[DATA_FIELD]=wr_start_addr/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+1]=wr_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD+2]=wr_value/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+3]=wr_value;
		MODBUS->Transmit_data_lenght=6;
		MODBUS->MODBUS_FRAME[MODBUS->Transmit_data_lenght]=CountRequestLRC_Master(MODBUS->Transmit_data_lenght++,&MODBUS);
		FormFrameStartEnd_Master(slave_id, 0x06, MODBUS);
	}
}
//(0x03)//===========================================================================================================
void	ReadHoldingRegister_Master(MODBUS_DATA *MODBUS,uint8_t slave_id,uint16_t rd_start_addr,uint16_t rd_quantity)
{
if (!(MODBUS->StateFlags&(1<<MB_REQUEST_READY_FLAG)))
	{
		MODBUS->StartAddr=rd_start_addr;
		//MODBUS->strAddrReg=rd_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD]=rd_start_addr/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+1]=rd_start_addr;
		MODBUS->MODBUS_FRAME[DATA_FIELD+2]=rd_quantity/0x100;
		MODBUS->MODBUS_FRAME[DATA_FIELD+3]=rd_quantity;
		MODBUS->Transmit_data_lenght=6;
		MODBUS->MODBUS_FRAME[MODBUS->Transmit_data_lenght]=CountRequestLRC_Master(MODBUS->Transmit_data_lenght++,&MODBUS);
		FormFrameStartEnd_Master(slave_id, 0x03, MODBUS);
	}
}
//===================================     =============================//
//(0x03)//=============================================================================================================
void	Read_WRHoldingRegisterReceived(MODBUS_DATA *MODBUS,uint8_t slave_id)
{
uint8_t	 i,j,k=0;	
uint16_t rd_quantity;

rd_quantity=MODBUS->RESPONSE_FRAME[DATA_FIELD]/2;

for	(i=0; i<rd_quantity; i++)
	{
	 HoldingRegister[MODBUS->StartAddr+i]=MODBUS->RESPONSE_FRAME[DATA_FIELD+1+k]*0x100+MODBUS->RESPONSE_FRAME[DATA_FIELD+2+k];
	 k=k+2;
	}
}


