#include "stm32f10x.h"
#include "ModbusPeriph.h"
#include "Modbus_ASCIIDefinitions.h"
#include "stm32f10x_usart.h"
#include "NVIC.h"
#include "HoldingRegMapDefinitions.h"
#include "PanelGlobalVars.h"
#include "TIM.h"
#include "GraphInterface.h"
#include "DMA.h"
/*-===========================================================================================*/
void	Init_Modbus	(s32 Boudrate,uint16_t Pin_Tx,uint16_t Pin_Rx, uint16_t Pin_CS, GPIO_TypeDef * GPIOx,USART_TypeDef *USARTx,uint8_t IRQChannel,uint32_t Remap,uint8_t Modbus_Priority, MODBUS_DATA *MODBUS,uint8_t Modbus_type,TIM_TypeDef *TIMx)
{
 RCC_ClocksTypeDef RCC_Clocks;
 
 RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOD|RCC_APB2Periph_AFIO,ENABLE); //!!!!
 RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE); //!!!!
 RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);	 				 //!!!!	
 	
 Init_GPIO_USART(Remap, Pin_Tx, Pin_Rx,Pin_CS, GPIOx);	//!!
 Init_USART(Boudrate,USARTx,USART_WordLength_8b);										//!!
 NVIC_ConfigurationUSART(IRQChannel,USARTx); 
 NVIC_SetPriority(USART1_IRQn,Modbus_Priority);						//!!
 //USART_ITConfig(USARTx,USART_IT_TC,ENABLE);
 USART_ITConfig(USARTx,USART_IT_RXNE,ENABLE);
 MODBUS->Device_addr=0x01; 
 if (Modbus_type==MODBUS_MASTER)
 	{
	 	InitTimer	(TIMx,2000,35999);
		NVICTmrInit	(TIMx,MODBUS1_MASTER_TIM_IRQ,3);
		MODBUS->StateFlags|=1<<MB_RESPONSE_READY_FLAG;
	}
}
/*===========================================================================================*/
unsigned char	ModbusProcessMaster	(MODBUS_DATA *MODBUS,TIM_TypeDef *TIMx)//    	//return 1 if error; 0 - if OK
{
if	(Check_LRC_Master(MODBUS)) // 	LRC
		{
	 	MODBUS->MODBUS_Error=LRCERR;
	 	}	// Check_LRC=1,      
	else
	if ((MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]>0x80)||(MODBUS->MODBUS_Error==TIMEOUT_ERROR))
		{
			switch (MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD])
					{
						case	0x81: MODBUS->MODBUS_Error=EXCERR1;break;
						case	0x82: MODBUS->MODBUS_Error=EXCERR2;break;
						case	0x83: MODBUS->MODBUS_Error=EXCERR3;break;
						case	0x84: MODBUS->MODBUS_Error=EXCERR4;break;
						case	0x85: MODBUS->MODBUS_Error=EXCERR5;break;
						default:	break;
					}
		}
		else	
			{
			 MODBUS->MODBUS_Error=RESPONSEOK;
			 if ((MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]==0x03)||(MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]==0x17))
				Read_WRHoldingRegisterReceived(MODBUS,1);
			}
Reset_Frame_Master(MODBUS,TIMx);
ClearModbusBuf(MODBUS);
}
/*============================================================================================*/
void	ModbusRequestMaster	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx,TIM_TypeDef *TIMx)			//return 1 if transmitted; 0 - if is transmitting
{  
if ((!(MODBUS->StateFlags&(1<<MB_TRANSMIT_FLAG)))&&(MODBUS->StateFlags&(1<<MB_REQUEST_READY_FLAG))&&(!(MODBUS->StateFlags&(1<<MB_TRS_FLAG))))
	{	 
   	MODBUS->StateFlags|=1<<MB_TRANSMIT_FLAG;
		MODBUS->StateFlags&=~(1<<MB_REQUEST_READY_FLAG);
		MODBUS->subbyte=0;
   	MODBUS->ind_tx=0;
   	//USARTx->DR=0x3a;
		//StartDMAUSART2Tx(MODBUS->TransmitdataLenght);
	}
if (MODBUS->StateFlags&(1<<MB_TRS_FLAG))
   	{
		  MODBUS->StateFlags&=~(1<<MB_TRANSMIT_FLAG);
			ClearResponseBuf(MODBUS);
   		ClearModbusBuf(MODBUS);
			MODBUS->StateFlags&=~(1<<MB_TRS_FLAG);
			MODBUS->StateFlags|=1<<MB_RESPONSE_WAIT_FLAG;
			TmrOn(TIMx);
		}//  
}
/*============================================================================================*/
void	ProcessMODBUSError	(uint8_t i)
{
if (strcmp(ControlPage.AlarmMessage.Value,MBErrMsg[i-1]))	
	{
		TFT_DrawRoundRectFilled(0,TFT_WIDTH,ControlPage.AlarmMessage.y,ControlPage.AlarmMessage.CaptionFont->Height, 0,GREEN);
		memset(ControlPage.AlarmMessage.Value,0,51);
		if (strlen(MBErrMsg[i-1])<=50)
			strncpy(ControlPage.AlarmMessage.Value,MBErrMsg[i-1],strlen(MBErrMsg[i-1]));
			else
				strncpy(ControlPage.AlarmMessage.Value,MBErrMsg[i-1],50);	
		TFT_Log(ControlPage.AlarmMessage.x+(TFT_WIDTH-GetStringLenght(ControlPage.AlarmMessage.Value,&ARIAL10pt))/2,ControlPage.AlarmMessage.y+10,ControlPage.AlarmMessage.Value,ControlPage.BackColor,ControlPage.AlarmMessage.color,&ARIAL10pt);
	}
}
/*============================================================================================*/
void	MODBUS_ASCII_MASTER	(MODBUS_DATA *MODBUS, USART_TypeDef *USARTx,TIM_TypeDef *TIMx)
{
if ((CHALLENGE_FLAG)&&(MODBUS->StateFlags&(1<<MB_RESPONSE_READY_FLAG)))
				{
					CHALLENGE_FLAG=0;
					MODBUS->StateFlags&=~(1<<MB_RESPONSE_READY_FLAG);
					WriteDataToHR();
					Read_WriteMulRegister_Master(&MODBUS2, MODBUS2.Device_addr,TC_MODE_REG,39, MODBUS_ADDRESS,92,HoldingRegister);
				}
if (MODBUS->StateFlags&(1<<NO_CONNECT_FLAG))
		MODBUS->MODBUS_Error=TIMEOUT_ERROR;				
ModbusRequestMaster(MODBUS,USARTx,TIMx);
if (MODBUS->StateFlags&(1<<MB_RCF_FLAG)) //  
	{
	 TmrOff(TIMx);
	 ModbusProcessMaster(MODBUS,TIMx);
	 ClearResponseBuf(MODBUS);
   Reset_Frame_Master(MODBUS,TIMx);
	 MODBUS->HR_UpdateFlag=1;	
	 MODBUS->StateFlags|=1<<MB_RESPONSE_READY_FLAG;
	 TmrOn(CHALLENGE_TIM);	
  }
if (MODBUS->MODBUS_Error)
	{
		MODBUS->StateFlags&=~(1<<NO_CONNECT_FLAG);	
		ProcessMODBUSError(MODBUS->MODBUS_Error);
		MODBUS->MODBUS_Error=0;
	}
}
/*/  /*/
/*===========================================================================================*/
unsigned char	ModbusProcess	(MODBUS_DATA *MODBUS)//    	//return 1 if error; 0 - if OK
{
if (MODBUS->StateFlags&(1<<MB_TRANSMIT_FLAG)) return 0;
else
	{
	if	(Check_LRC(MODBUS)) // 	LRC
		{
	 	Reset_Frame(MODBUS);
	 	return 1;
		}	// Check_LRC=1,      
  	else
	  {
	  if (Check_except_error(MODBUS))	 			//     
		FormExceptionResponse(MODBUS);
		else
			FormNormalResponse(MODBUS);
	  MODBUS->StateFlags|=1<<MB_RESPONSE_READY_FLAG;
	  return 0;
	   }
	}
}
/*============================================================================================*/
void	ModbusResponse	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx)			//return 1 if transmitted; 0 - if is transmitting
{  
if (!(MODBUS->StateFlags&(1<<MB_TRANSMIT_FLAG)))
	{	 
   	MODBUS->HR_UpdateFlag=1;
	MODBUS->StateFlags|=1<<MB_TRANSMIT_FLAG;
	MODBUS->subbyte=0;
   	MODBUS->ind_tx=0;
	if (USARTx==RS_485)
		EnableRS_485Transmitter;  	//set CS - disable receiver, enable transmitter

   	USARTx->DR=0x3a;
	}
if (MODBUS->StateFlags&(1<<MB_TRS_FLAG))
   	{
		  ClearResponseBuf(MODBUS);
   		  ClearModbusBuf(MODBUS);
		  Reset_Frame(MODBUS);
		  if (USARTx==RS_485)
		  	  DisableRS_485Transmitter;	//reset CS - enable receiver, disable transmitter
		  //HR_UpdateFlag=1;
	}//  
}
/*============================================================================================*/
void	MODBUS_ASCII	(MODBUS_DATA *MODBUS, USART_TypeDef *USARTx)
{
if (MODBUS->StateFlags&(1<<MB_RCF_FLAG)) //  
			{
		 	if (!(ModbusProcess(MODBUS))) //     
		 		{
				  ModbusResponse(MODBUS,USARTx);
				}
			}
}