#include 	"stm32f10x.h"
#include 	"Modbus_ASCIIGlobalVars.h"
#include	"Modbus_protocol.h"
//(9)========================================================================================!!!!!!
//(7)//return temp_var as 1 byte value from 2 ascii chars:first - MSN; second -LSN
unsigned char	ASCII_to_Hex	(unsigned char temp_buf,MODBUS_DATA *MODBUS)
{
static unsigned char	temp_var;
 if ((temp_buf>0x2F)&& (temp_buf<0x3A)) 
 	{temp_buf=temp_buf-0x30;}
	else	if	((temp_buf>0x40)&&(temp_buf<0x47))
	{temp_buf=temp_buf-0x37;}

 if	(!(MODBUS->subbyte))
	{						   
     temp_var=temp_buf*0x10;	//ascii-0x30= dec value*0x10=shift on 4 bits left
	 MODBUS->subbyte++;
	}
 else	
	{
	 MODBUS->subbyte=0;
     temp_var=temp_var+temp_buf;
	}
return temp_var;
}
//(10)//======================================================================================!!!!
void	Reset_Frame	(MODBUS_DATA *MODBUS)	//  
{
  MODBUS->StateFlags&=~(1<<MB_RECEIVE_FLAG);  //not address id				  //   
  MODBUS->StateFlags&=~(1<<MB_TRANSMIT_FLAG);
  MODBUS->ind_rx=0;
  MODBUS->ind_tx=0;
  MODBUS->ExceptionCode=0;
  MODBUS->Received_Frame_Lenght=0;
  MODBUS->subbyte=0;
  MODBUS->Transmit_data_lenght=0;
  MODBUS->StateFlags&=~(1<<MB_RCF_FLAG);
  MODBUS->StateFlags&=~(1<<MB_TRS_FLAG);
  MODBUS->StateFlags&=~(1<<MB_RESPONSE_READY_FLAG);
	MODBUS->StateFlags&=~(1<<MB_RESPONSE_WAIT_FLAG);
}
///(11)
////(6)===================================================!!!!!!,        
void	Receive_Quest	(MODBUS_DATA *MODBUS, USART_TypeDef *USARTx)
{
static unsigned char pred_char;
	   unsigned char	temp_var;
	   unsigned char 	temp_buf;
if (MODBUS->ind_rx<MAX_FRAME_LENGHT) //      256
	{
 	temp_buf=USARTx->DR;		 // 
 	if	(!(MODBUS->StateFlags&(1<<MB_RECEIVE_FLAG)))					 //    
 		 {
	 	  if (temp_buf==0x3A)				 //.        
 			  {
		 	  MODBUS->StateFlags|=1<<MB_RECEIVE_FLAG;				 //  -    
		 	  MODBUS->ind_rx=0;							 // MODBUS1.ind_rx
			  } 
		 }
 	 else		//if receiving frame  		//   
 		  {
		  if	((temp_buf==0x0A)&&(pred_char==0x0D))			   //,        
		         {
		   		 MODBUS->StateFlags&=~(1<<MB_RECEIVE_FLAG);	  							  // ,     	
			  	 MODBUS->Received_Frame_Lenght=MODBUS->Received_Frame_Lenght;	  				 //   = + + +LRC	
			  	 MODBUS->StateFlags|=(1<<MB_RCF_FLAG);	 								//	    							
				 }
			else   												//     
				{
			     temp_var=ASCII_to_Hex(temp_buf,MODBUS);								//       16-
				 if(!(MODBUS->subbyte))		  							//   - (ASCII_to_Hex  subbyte=0)
				 	{
			 		if	((MODBUS->ind_rx==0)&&(temp_var!=MODBUS->Device_addr))   //        ( )    
						{
				  		 Reset_Frame(MODBUS);	   								//      .        
						}
			   		else   											//              
			 			{	  
			  	 		MODBUS->MODBUS_FRAME[MODBUS->ind_rx++]=temp_var;	   				//    
			 	 		MODBUS->Received_Frame_Lenght++;								//  
						}
					}		//       	
				}
		 }
	
  	pred_char=temp_buf;
	}
 else Reset_Frame(MODBUS);//	      256  -  
}
//(12)======================================================================================== 
void	FormExceptionResponse	(MODBUS_DATA *MODBUS)
{
uint8_t LRC_count=0;

MODBUS->RESPONSE_FRAME[DEVICE_ID_FIELD]=MODBUS->MODBUS_FRAME[DEVICE_ID_FIELD];
MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]=MODBUS->MODBUS_FRAME[FUNCTION_CODE_FIELD]+0x80;
MODBUS->RESPONSE_FRAME[DATA_FIELD]=MODBUS->ExceptionCode;
LRC_count=MODBUS->RESPONSE_FRAME[DEVICE_ID_FIELD+1]+MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]+MODBUS->RESPONSE_FRAME[DATA_FIELD];
LRC_count=0xFF-LRC_count+1;
MODBUS->RESPONSE_FRAME[DATA_FIELD+1]=LRC_count;  //1
MODBUS->RESPONSE_FRAME[DATA_FIELD+2]=0x0d;  //0x0d;
MODBUS->RESPONSE_FRAME[DATA_FIELD+3]=0x0a;  //0x0a;
MODBUS->Transmit_data_lenght=6;
}
//(13)==========================================================================================
uint8_t	Check_except_error	(MODBUS_DATA *MODBUS)				  //return exception code		!!!!!!
//-----------------------------------------------------------------------------------------
{
uint16_t	start_addr=0;
uint16_t	quantity=0;
uint16_t	l_param=0;
uint16_t	h_param=0;
uint16_t	l_param_1=0;
uint16_t	h_param_1=0;
uint16_t	else_param=0;
uint16_t	else2_param=0;

uint16_t	output_address=0;
uint16_t	output_value=0;
uint16_t	second_data_word=0;
uint16_t	first_data_word=0;
uint16_t	b_count_write=0;
uint16_t	q_write=0;
uint16_t	start_wr_addr=0;

second_data_word=(MODBUS->MODBUS_FRAME[DATA_FIELD+2]*0x100)+MODBUS->MODBUS_FRAME[DATA_FIELD+3];				 //    2  (  )
first_data_word=MODBUS->MODBUS_FRAME[DATA_FIELD]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+1]; 					//    2  (  )   
switch	(MODBUS->MODBUS_FRAME[FUNCTION_CODE_FIELD])	 //    	      ,   ..   
   			{
			 case	0x03:	{
			 				l_param=MIN_QUANTITY;
							h_param=MAX_QUANTITY;
							else_param=1;
							if ((first_data_word+second_data_word)<=MAX_QUANTITY)//!!,       
								else2_param=1;
								 else else2_param=0;
							} break;
			 case	0x06:	{
			 				l_param=0x00; 
							h_param=0xFFFF;
							else_param=1;
							if (first_data_word<=MAX_QUANTITY)//!!,       
								else2_param=1;
								else else2_param=0;
								 
							} break;
			 case	0x10:	{
			 				l_param=MIN_QUANTITY;
							h_param=MAX_QUANTITY-2;
							if (MODBUS->MODBUS_FRAME[DATA_FIELD+4]==(second_data_word*2)) 
							else_param=1;
								else else_param=0;
							if ((first_data_word+second_data_word)<=MAX_QUANTITY)
							else2_param=1;
								else else2_param=0;
							} break;
			 case	0x17:	{
			 				l_param=MIN_QUANTITY;
							h_param=MAX_QUANTITY; 
							l_param_1=MIN_QUANTITY;
							h_param_1=MAX_QUANTITY-4;
							b_count_write=MODBUS->MODBUS_FRAME[DATA_FIELD+8];
							q_write=MODBUS->MODBUS_FRAME[DATA_FIELD+6]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+7];
							start_wr_addr=MODBUS->MODBUS_FRAME[DATA_FIELD+4]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+5];
							if ((q_write>=l_param_1)&&(q_write<=h_param_1)&&(b_count_write==q_write*2))
							else_param=1;
								else else_param=0;
							if (((second_data_word+first_data_word)<=MAX_QUANTITY)&&((start_wr_addr>=0x00)&&(start_wr_addr<=MAX_QUANTITY)&&((start_wr_addr+q_write)<=MAX_QUANTITY)))
							else2_param=1;
								else	else2_param=0;
							} break;
			 default: {MODBUS->ExceptionCode=1; goto exit;}	 //   1
			}
						 
if	(!((second_data_word>=l_param)&&(second_data_word<=h_param)&&(else_param))) //   
	MODBUS->ExceptionCode=3;	 						//   3
	else
		{
		if	(!((first_data_word>=0)&&(first_data_word<=0xFFFF)&&(else2_param)))  //    
			MODBUS->ExceptionCode=2;													   //   2
		}
exit:
return	MODBUS->ExceptionCode;		//  ,  0 -  
}
//(14)/=======================================================================================	 !!!
//(=====================================================================================  !!!!!
int	Check_LRC	(MODBUS_DATA *MODBUS)	  //return 0 if NO LRC eroor; return 1 if LRC error is
///==================================================================================================
{
unsigned	char	i=0;
unsigned	char	LRC_count=0;
   for (i=0;i<(MODBUS->Received_Frame_Lenght-1);i++)
   		{
		 LRC_count=LRC_count+MODBUS->MODBUS_FRAME[i];	 //       LRC
		}
   LRC_count=0xFF-(unsigned char)LRC_count+1; 	// 	 LRC_count
   if	(MODBUS->MODBUS_FRAME[MODBUS->Received_Frame_Lenght-1]!=LRC_count)
   		return	1;	 //    LRC        1
	else	return 0;  //    0
}
//======================================================================================
unsigned char	Hex_to_ASCII	(unsigned char	hex_data,MODBUS_DATA *MODBUS)
{
unsigned	char	temp_data=0;
if (!((MODBUS->ind_tx>=MODBUS->Transmit_data_lenght-2)||((hex_data==0x3a)&&(MODBUS->ind_tx==0))))	  //(MODBUS1.ind_tx!=MODBUS1.Transmit_data_lenght-3)
	{
	 if(!(MODBUS->subbyte))
   			{
			temp_data=hex_data/0x10;
			MODBUS->subbyte++;
			}
			else 
				{
		 		MODBUS->subbyte=0;
				temp_data=hex_data&0x0f;
				MODBUS->ind_tx++;
		 		}
	 if	((temp_data>=0)&&(temp_data<=9))
			{
			 temp_data=temp_data+0x30;
			}
		else
			{	if ((temp_data>=0x0A)&&(temp_data<=0x0F))
   					{
  		 			temp_data=temp_data+0x37;
   					}
			}
	}
  else	{temp_data=hex_data;MODBUS->ind_tx++;}
return	temp_data;
}
//(17)
//======================================================================================
void	SendResponse	(MODBUS_DATA *MODBUS, USART_TypeDef *USARTx)
{
if	(MODBUS->HR_UpdateFlag)
	{
		if (MODBUS->ind_tx<MODBUS->Transmit_data_lenght)
			{
			USARTx->DR=Hex_to_ASCII(MODBUS->MODBUS_FRAME[MODBUS->ind_tx],MODBUS);
			}
		else 
			{
			MODBUS->StateFlags|=1<<MB_TRS_FLAG;
			}
}
}
//(18)=====================================================count LRC for response!!!!
unsigned	char	CountResponseLRC	(MODBUS_DATA *MODBUS, uint8_t a)
{
uint8_t	i;
uint8_t	b=0;
 for  (i=DEVICE_ID_FIELD;i<a;i++)
 	{
	 b=b+MODBUS->RESPONSE_FRAME[i];
	}
b=0xFF-b+1;
return	b;
}
//(19)==============================================================  !!!
void	FormNormalResponse	(MODBUS_DATA *MODBUS)
{
MODBUS->RESPONSE_FRAME[DEVICE_ID_FIELD]=MODBUS->MODBUS_FRAME[DEVICE_ID_FIELD];
MODBUS->RESPONSE_FRAME[FUNCTION_CODE_FIELD]=MODBUS->MODBUS_FRAME[FUNCTION_CODE_FIELD];

switch (MODBUS->MODBUS_FRAME[FUNCTION_CODE_FIELD])
		{
		case	0x03: ReadHoldingRegister(MODBUS);break;
		case	0x06: WriteSingleRegister(MODBUS);break;
		case	0x10: WriteMultipleRegister(MODBUS);break;
		case	0x17: Read_WriteMulRegister(MODBUS);break;
		default: break;
		}
MODBUS->RESPONSE_FRAME[MODBUS->Transmit_data_lenght]=CountResponseLRC(MODBUS,MODBUS->Transmit_data_lenght);  //
MODBUS->RESPONSE_FRAME[++MODBUS->Transmit_data_lenght]=0x0d;  //13=0x0d;
MODBUS->RESPONSE_FRAME[++MODBUS->Transmit_data_lenght]=0x0a;  //10=0x0a;
MODBUS->Transmit_data_lenght++;
}

