#define	MAX_RECEIPT		16

extern	uint8_t* 		msg[20];
extern	uint32_t		DiscreteOutputs; //  
extern	uint8_t			DiscreteInputs;

/*========================================================================================*/
//Define structure Converter
typedef struct		  //
{
uint16_t	BaseValuePt[5];			//     
uint16_t	ConvValuePt[5];		   //   (/)    
uint16_t	Type;
} CONVERTER_DATA_TYPE;
/*========================================================================================*/
//Define structure ADC
typedef struct		  //
{
CONVERTER_DATA_TYPE		ADCCalib;						//  
			uint16_t	ADCMode;						// 
			uint16_t	ADCConfig;						// 
			float		ADCBuffer [8];					//   
			uint8_t		ADC_RDY_FLAG;
			uint16_t	ADC_Codes[8];
			uint8_t		CONVERSION_FLAG;
} ADC_DATA_TYPE;
extern 		ADC_DATA_TYPE	dADC1;
/*========================================================================================*/
//Define structure DAC
typedef struct		  //
{
CONVERTER_DATA_TYPE		DACCalib;						//  
			uint16_t	DACConfig;						// 
			uint16_t	DACCode;						//  
			float		DACCurrent;						// 
			float		DACVoltage;						// 
} DAC_DATA_TYPE;
extern 		DAC_DATA_TYPE	dDAC1,dDAC2;
/*========================================================================================*/
//Define structure Analogue Sensor
typedef struct		  //
{
CONVERTER_DATA_TYPE		Calib;							//  
float					BaseValue;						//   
float					ConvValue;						//   
float					CurrentValue;					//   
} AN_SENSOR_DATA_TYPE;
/*========================================================================================*/
//Define structure of all sensors of the board
typedef struct		  //
{
AN_SENSOR_DATA_TYPE		TempSensor; 					// 
AN_SENSOR_DATA_TYPE		LevelSensor1;					//   
AN_SENSOR_DATA_TYPE		LevelSensor2; 					//   
AN_SENSOR_DATA_TYPE		LevelSensor3; 					//   
AN_SENSOR_DATA_TYPE		AutoSpeedSensor;				//  
AN_SENSOR_DATA_TYPE		PumpSpeedSensor;				//   
AN_SENSOR_DATA_TYPE		PressureSensor;					// 
uint8_t					PneumoPressureSensor;			//  () 
uint8_t					BitumPressureSensor;			//  ()   
uint8_t					DirtyFilterSensor;				//  
uint8_t					Filling;						//  
uint8_t					Heating;						// 
uint8_t					AutoSpeedPrs;					//   
uint8_t					LevelAlarm;						//    (  )
} BOARD_SENSORS_DATA_TYPE;
extern 		BOARD_SENSORS_DATA_TYPE	Sensors;
/*========================================================================================*/
//Define structure of Injects
typedef struct		  //
{
uint32_t	InjectConfiguration; 						// 
uint8_t		nInjects; 									// 
float		InjectWidth;								//  1 
} INJECT_DATA_TYPE;
/*========================================================================================*/
//Define structure of Pump
typedef struct		  //
{
CONVERTER_DATA_TYPE		Calib;							//     (-)		
CONVERTER_DATA_TYPE		Calib1;							//     ()
//CONVERTER_DATA_TYPE		Calib2;	
			float		PumpSpeedRate;						//    
			float		PumpProdRate;						//    
	uint16_t	PumpSpeed;						//    
} PUMP_DATA_TYPE;
/*========================================================================================*/
//Define structure of Actuators
typedef struct		  //
{
INJECT_DATA_TYPE	Injects;
PUMP_DATA_TYPE		Pump;
uint8_t			    BitumenBackValve;
uint8_t				HeatingManual;
uint8_t				HeatingAuto;
uint8_t				TCMode;
uint8_t				LevelAlarm;
} ACTUATOR_DATA_TYPE;
extern 		ACTUATOR_DATA_TYPE	Actuators;
/*========================================================================================*/
//Define structure of Controls on Front Panel (operator Panel)
typedef struct		  //
{
uint32_t	Injects;					// 
uint16_t	PumpSpeedManual;	//    
uint8_t		BitumenBackValve;	//    
uint8_t		HeatingManual;		// 
uint8_t		TCMode;						//	
uint8_t   Material;					//material. ruchnoy rejim
uint8_t   Unit;							//ed.izmereniya normi rozliva na letu ruch. rejim
float			FRate;						//norma rozlive na letu vmesto skorosti nasosa	
} CONTROL_PANEL_DATA_TYPE;
extern 		CONTROL_PANEL_DATA_TYPE	Controls;
/*========================================================================================*/
//Define structure of Receipt
typedef struct		  //
{
uint8_t			  nReceipt;
uint8_t				Material;								//    
uint8_t				Unit;										//     	   
float					nFillingRate;  					//   	   
uint32_t			InjectConfig;						//       
} RECEIPT_DATA_TYPE;
/*========================================================================================*/
//Define structure of ComputedParams
typedef struct		  //
{
float		MixtureVolumeIn; 				//    
float		MixtureVolumeOut; 				//  
float		SquareFilled;					// 
float		FillingWidth;  					// 
uint16_t	DistanceGone;  					//    
uint16_t	TimeGone;  						// 
} COMPUTED_PARAMS_DATA_TYPE;
extern		COMPUTED_PARAMS_DATA_TYPE	ComputedParams;
/*========================================================================================*/
//Define structure InputConfiguration
typedef struct		  //
{
RECEIPT_DATA_TYPE	Receipt;					//     	
//uint16_t TCParameters[12];	
uint16_t	MaxBitumLevel;  					//  
uint16_t	MinBitumLevel;  					//  
uint8_t		MaxBitumTemp;  						//  
uint8_t		MinBitumTemp;  						//  
uint8_t		MaxBurnTemperature;  				//  
uint8_t		MinBurnTemperature;  				//  
uint8_t		MinAutoSpeed;  						//  
uint8_t		MaxAutoSpeed;  						//  */
float			VolumeRate;	
} INPUT_CONFIGURATION;
extern 		INPUT_CONFIGURATION	SystemBoardConfig;
/*========================================================================================*/
//Define structure Current Parameters
typedef struct		  //
{
RECEIPT_DATA_TYPE			Receipt;				//  
uint8_t								ErrorMsg;				//  
float									nFillingRate;
uint8_t 							Material;
uint8_t 							Unit;	
} CURRENT_PARAMETERS;							   
extern	CURRENT_PARAMETERS	CurrentParameters;
/*========================================================================================*/
//Define structure Testing Parameters
typedef struct		  //
{
uint8_t		AutoSpeed;
uint8_t		BitumTemp;
uint8_t		BitumLevel1;
uint8_t		BitumLevel2;
uint8_t		PumpPressure;
uint16_t	PumpSpeed;
uint8_t		DiscreteInputs;
} TEST_PARAMETERS;							   
extern	TEST_PARAMETERS	TestParams;
/*========================================================================================*/
typedef struct
{
	uint8_t*	ReceiptName[MAX_RECEIPT];		//nazvanie receptov
	uint8_t 	MatUnit[MAX_RECEIPT];			//material/ed.ismereniya
	float			FRate[MAX_RECEIPT];					//norma rozliva
	uint32_t	RecInjectConfig[MAX_RECEIPT];//configuratsiya forsunok
	uint8_t 	NReceipts;			//kolichestvo receptov
}RECEIPTS;
extern RECEIPTS	TCReceipts;
/*========================================================================================*/
extern	uint8_t	 		CHALLENGE_FLAG;
extern	uint8_t	 		CONTROLS_CHANGED_FLAG;
extern	uint8_t			CommandCode;
