#include "stm32f10x.h"
#include "GlobalVars.h"
#include "GPIO.h"
/*/===================================================================================================*/
void	Init_GPIO_USART	(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, GPIO_TypeDef * GPIO)	 
 {
 GPIO_InitTypeDef	GPIO_InitStructure;
 if (Remap) GPIO_PinRemapConfig(Remap, ENABLE );        // remap PD3-PD7 to USART

 if (Pin_Tx)
 	{
 	//Tx
 	GPIO_InitStructure.GPIO_Pin=Pin_Tx;	//PD5=Tx; 
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // Alt Function - Push Pull 
 	GPIO_Init(GPIO, &GPIO_InitStructure); 
 	}
 if (Pin_Rx)
 	{
	//Rx
 	GPIO_InitStructure.GPIO_Pin=Pin_Rx;	//PD6=Rx;
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;            // 
 	GPIO_Init(GPIO, &GPIO_InitStructure); 
 	//
	}
}
/*/===================================================================================================*/
 void	Init_GPIO_CAN	(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, GPIO_TypeDef * GPIOx)	 
 {
 GPIO_InitTypeDef	GPIO_InitStructure;

 //Tx
 GPIO_InitStructure.GPIO_Pin=Pin_Tx;	//PA2=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // Alt Function - Push Pull 
 GPIO_Init(GPIOx, &GPIO_InitStructure); 
 //Rx
 GPIO_InitStructure.GPIO_Pin=Pin_Rx;	//PA3=Rx;
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;            // 
 GPIO_Init(GPIOx, &GPIO_InitStructure); 
 //
 if (Remap)
 	GPIO_PinRemapConfig(Remap, ENABLE);
}
/*===================================================================================================*/
void	DiscreteInputConfiguration	(void)
{
 GPIO_InitTypeDef	GPIO_InitStructure;
 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_All;	//PD5=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode =GPIO_Mode_IN_FLOATING;            // 
 GPIO_Init(GPIOE, &GPIO_InitStructure);

 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_All;//GPIO_Pin_0|GPIO_Pin_2;	//PD5=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;            // 
 GPIO_Init(GPIOB, &GPIO_InitStructure);

 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_All;//GPIO_Pin_4;	//PD5=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;            // 
 GPIO_Init(GPIOC, &GPIO_InitStructure);

 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_4|GPIO_Pin_6;	//PD5=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;            // 
 GPIO_Init(GPIOA, &GPIO_InitStructure);
}
/*===================================================================================================*/
void 	DiscreteOuputConfiguration	(void) 
{
 GPIO_InitTypeDef	GPIO_InitStructure;
 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_7|GPIO_Pin_9;	// 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 GPIO_Init(GPIOE, &GPIO_InitStructure);
 
 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_1;	// 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 GPIO_Init(GPIOB, &GPIO_InitStructure);

 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_5;	// 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 GPIO_Init(GPIOC, &GPIO_InitStructure);

 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_5|GPIO_Pin_7;	// 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 GPIO_Init(GPIOA, &GPIO_InitStructure);
}