#include "GlobalVars.h"
#include "Timers.h"
/*===============================================================================================================*/
void	Init_TMR	(TIM_TypeDef* TIM, unsigned short delay) //       
{
TIM_TimeBaseInitTypeDef 	Tim_InitStruct;
Tim_InitStruct.TIM_ClockDivision=TIM_CKD_DIV1;
Tim_InitStruct.TIM_CounterMode=TIM_CounterMode_Up;
Tim_InitStruct.TIM_Period=delay;		 //	   1 
Tim_InitStruct.TIM_Prescaler=35999;	 	//
TIM_TimeBaseInit(TIM,&Tim_InitStruct);
}
/*================================================================================================================*/
void	Timer_ON	(TIM_TypeDef* TIM)	 	//		timer 2 on delay 1 sec
{
TIM_Cmd(TIM,ENABLE); 
TIM_ITConfig(TIM,TIM_IT_Update,ENABLE);
}
/*==================================================================================================================*/////////////////////////////////////
void	Timer_OFF	(TIM_TypeDef* TIM)
{
TIM_Cmd(TIM,DISABLE);			 //disable counting timer 2
TIM_SetCounter	(TIM,0);		 //reset CNT
TIM_ITConfig(TIM,TIM_IT_Update,DISABLE);
}

/*==============================================================================================================*/
void NVICTmrInit	(TIM_TypeDef* TIMx,uint8_t TIMx_IRQ_Channel, uint8_t Priority)
{
NVIC_InitTypeDef NVIC_InitStructure;
NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
NVIC_InitStructure.NVIC_IRQChannel = TIMx_IRQ_Channel;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
NVIC_InitStructure.NVIC_IRQChannelSubPriority =0;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);
TIM_ClearITPendingBit(TIMx,TIM_IT_Update);
TIM_ITConfig(TIMx,TIM_IT_Update,ENABLE);
NVIC_SetPriority(TIMx_IRQ_Channel,Priority);
}
/*================================================================================================================*/
void	TIM2_IRQHandler	(void)  //   
{
if	(TIM_GetITStatus(TIM2,TIM_IT_Update))
	{
	//TIM_ClearITPendingBit(TIM2,TIM_IT_Update);		 
	TIM2->SR=0;
	Timer_OFF(TIM2);
	CHALLENGE_FLAG=1;
	Timer_ON(TIM2);
	}
}	
/*================================================================================================================*/
void	TIM3_IRQHandler	(void)  // 
{
if	(TIM_GetITStatus(TIM3,TIM_IT_Update))
	{
	TIM_ClearITPendingBit(TIM3,TIM_IT_Update);		 
	Timer_OFF(TIM3);
//	Event|=(1<<READ_CONTROL_PARAMS_FLAG);
	Timer_ON(TIM3);
	}
}
/*================================================================================================================*/
void	TmrConfig	(void)
{
  NVICTmrInit(TIM2,TIM2_IRQn, 1);
  Init_TMR	(TIM2, 2000);
}