#ifndef MY_GLOBALS_VARS
#define MY_GLOBALS_VARS
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
//MODBUS DATA TYPES
extern uint16_t	DiscreteInput	[125];
extern uint16_t	Coil			[125];
extern uint16_t	InputRegister	[125];
extern uint16_t	HoldingRegister	[125]; 
//Limits for registers
#define MIN_QUANTITY 0x01
#define MAX_QUANTITY 0x007D//125   
//Define maximum MODBUS frame lenght
#define MAX_FRAME_LENGHT 256
//Define array for of MAX_FRAME_LENGHT bytes for Modbus receive frame
//unsigned	char	MODBUS_FRAME[MAX_FRAME_LENGHT];
//Define array for of MAX_FRAME_LENGHT bytes for Modbus response frame
//unsigned	char	RESPONSE_FRAME[MAX_FRAME_LENGHT];
//Definitions  for modbus frame fields
#define		DEVICE_ID_FIELD			(uint8_t)		0
#define		FUNCTION_CODE_FIELD		(uint8_t)		1
#define		DATA_FIELD				(uint8_t)		2
#define		BYTE_COUNT_FIELD		(uint8_t)		2
#define		SIMPLE_DATA_LENGHT		(unsigned char)	6
//Define buffer for saving registers' data
//Variable that defines usart speed
extern s32			USART_SPEED;
//Definitions for else vars
extern unsigned	char	temp_buf;		// contains temporary data
extern unsigned	char	pred_char;	   //containes previous char 
extern uint16_t			temp_var;	   //containes temporary variable
extern uint8_t			LRC_count;	  //containes LRC value	
//unsigned	char	MODBUS1.Received_Frame_Lenght; //received data frame lenght
//unsigned	char	MODBUS1.Transmit_data_lenght; //transmitted data frame 
extern uint8_t			ExceptionCode;
//unsigned	char	MODBUS1.ind_rx;	       //index for receiving symbols
//unsigned	char	MODBUS1.ind_tx;		   //undex for transmitting symbols
extern unsigned	char	N;			  //byte count	
extern unsigned	char	subbyte;
//Modbus Flags
extern uint8_t		RECEIVE_FLAG; //receiving flag
extern uint8_t		RCF_FLAG;	  //frame received flag
extern uint8_t		TRS_FLAG;	  //frame sending flag
//Structure of MODBUS
typedef struct		  //size of structure is 517 byte
{
unsigned char	Device_addr;	  //1 byte  
unsigned char 	MODBUS_FRAME[MAX_FRAME_LENGHT];//256 bytes
unsigned char 	RESPONSE_FRAME[MAX_FRAME_LENGHT]; //256 bytes
unsigned char	ind_rx;							  //1 byte
unsigned char	ind_tx;							  //1 byte
unsigned char	Received_Frame_Lenght; //received data frame lenght	 1 byte
unsigned char	Transmit_data_lenght;								//1 byte
} MODBUS_DATA;
extern MODBUS_DATA MODBUS1;
extern unsigned	char	ReadDataBuf[MAX_FRAME_LENGHT-3];   //256-Device_ID-Func-LRC
//Discrete Board Inputs
extern	unsigned	char	FillingON;
extern  unsigned	char	PneumaticPressueNormal;
extern	unsigned	char	BitumPressueNormal;
extern	unsigned	char	FilterContamination;
extern	unsigned	char	HeatON;
extern	unsigned	char	Rezerv1;
extern	unsigned	char	Rezerv2;
extern	unsigned	char	Rezerv3;
//Analogue Board Inputs
extern	unsigned	short	CarSpeed;
extern	unsigned	short	BitumPupmSpeed;
extern	unsigned	short	BitumTemperature;
extern	unsigned	short	EmulsionTemperature;
extern	unsigned	short	FrontLevel;
extern	unsigned	short	BackLevel;
extern	unsigned	short	AnRezerv1;
extern	unsigned	short	AnRezerv2;
//=========================================================================
#define ADC_1	1
#define	ADC_2	2

#define QuanADC_Channel		4

//AD7433 command definitions
#define	ComReg_ModeReg		0x38
#define	WriteModeReg		0x48
#define	ComReg_ReadCh0Data	0x48
#define	ComReg_ReadCh1Data	0x49
#define	ComReg_ReadCh2Data	0x4A
#define	ComReg_ReadCh3Data	0x4B

extern	uint16_t			ADCBuffer;
extern	unsigned	char	ADC_RDY_FLAG;
#endif
