#include	"CAN.h"
#include  "CAN_LLPGlobalVars.h"

/*======================================================================================*/
void	Init_CAN			(CAN_TypeDef *  CANx, uint16_t	baudrate)
{
   	CAN_InitTypeDef        CAN_InitStructure;
	CAN_FilterInitTypeDef  CAN_FilterInitStructure;
   	
	CAN_DeInit(CANx);
		
	CAN_InitStructure.CAN_TTCM = DISABLE;
	CAN_InitStructure.CAN_ABOM = DISABLE;
	CAN_InitStructure.CAN_AWUM = DISABLE;
	CAN_InitStructure.CAN_NART = ENABLE;
	CAN_InitStructure.CAN_RFLM = DISABLE;
	CAN_InitStructure.CAN_TXFP = ENABLE;
	CAN_InitStructure.CAN_Mode = CAN_Mode_Normal;
	CAN_InitStructure.CAN_SJW = CAN_SJW_1tq;  
	CAN_InitStructure.CAN_BS1 = CAN_BS1_16tq;
 	CAN_InitStructure.CAN_BS2 = CAN_BS2_8tq;
	switch (baudrate)
	{
		case 1000:	CAN_InitStructure.CAN_Prescaler =1; break; //1Mb
		case 500: 	CAN_InitStructure.CAN_Prescaler =1; break; //500 kB
		case 250:	CAN_InitStructure.CAN_Prescaler =2; break; //250 kB
		case 125:	CAN_InitStructure.CAN_Prescaler =4; break; //125 kB
		case 100:	CAN_InitStructure.CAN_Prescaler =6; break; //100 kB
		case 50:	CAN_InitStructure.CAN_Prescaler =12; break; //50 kB
		case 20:	CAN_InitStructure.CAN_Prescaler =40; break; //20 kB
		case 10:	CAN_InitStructure.CAN_Prescaler =62; break; //10 kB
		default:	CAN_InitStructure.CAN_Prescaler =144; break;
	}
	//CAN_InitStructure.CAN_Prescaler =2; 
	CAN_Init(CANx, &CAN_InitStructure);

//Filter Configuration
	CAN_FilterInitStructure.CAN_FilterNumber = 1;
	CAN_FilterInitStructure.CAN_FilterMode = CAN_FilterMode_IdMask;
	CAN_FilterInitStructure.CAN_FilterScale = CAN_FilterScale_32bit;
	CAN_FilterInitStructure.CAN_FilterIdHigh = 0x0000;
	CAN_FilterInitStructure.CAN_FilterIdLow = 0x0000;
	CAN_FilterInitStructure.CAN_FilterMaskIdHigh = 0x0000;
	CAN_FilterInitStructure.CAN_FilterMaskIdLow = 0x0000;
	CAN_FilterInitStructure.CAN_FilterFIFOAssignment = 0;
	CAN_FilterInitStructure.CAN_FilterActivation = ENABLE;
 	CAN_FilterInit(&CAN_FilterInitStructure);
}
/*======================================================================================*/
void	CAN1_TX_IRQHandler	(void) 
{

  if (CAN_GetITStatus(CAN1,CAN_IT_TME))
  	 {                 
      CAN_ClearITPendingBit(CAN1,CAN_IT_TME);
	  CAN_LLP1.CAN_RspRdy=0;
	  CAN_LLP1.CAN_TxRdy=0;
	 }
}
/*======================================================================================*/ 
void	CAN1_RX0_IRQHandler	(void)
{

  if (CAN_GetITStatus(CAN1,CAN_IT_FMP0))
  	 {
		CAN_ClearITPendingBit(CAN1,CAN_IT_FF0);
		CAN_Receive(CAN1,0,&CAN_LLP1.RxMessage);       // read the message
		CAN_LLP_RequestMaster(&CAN_LLP1);
		CAN_LLP1.CAN_RxRdy=1;                                // set receive flag
	}

} 
