#include "DMA.h"
/*===========================================================================================*/
void	DMA_FSMC_Init	(uint32_t SRCAddr,uint32_t BufferSize)
{
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA2, ENABLE);
	DMA_DeInit(DMA2_Channel5);
  DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)SRCAddr;
  DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)TFT_FSMC_ADDR;    
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStructure.DMA_BufferSize = BufferSize;
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Enable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Word;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Word;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_M2M = DMA_M2M_Enable;
  DMA_Init(DMA2_Channel5, &DMA_InitStructure);
}
/*===========================================================================================*/
void Start_DMA_FSMC(unsigned int LengthBufer)
{
  DMA2_Channel5->CCR  &= ~DMA_CCR5_EN;      //  
  DMA2_Channel5->CNDTR =  LengthBufer;      //    
  DMA2->IFCR          |=  DMA_IFCR_CTCIF5;  //   
  DMA2_Channel5->CCR  |=  DMA_CCR5_EN;      //  
}
/*===========================================================================================*/
