#include "GPIO.h"
#include "TouchADS7843.h"
/*==========================================================================================*/
void TouchPENIRQInterruptConfig (void)
{
 EXTI_InitTypeDef	EXTI_InitStructure;
 EXTI_InitStructure.EXTI_Trigger =EXTI_Trigger_Falling;
 EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
 EXTI_InitStructure.EXTI_LineCmd = ENABLE;
 EXTI_InitStructure.EXTI_Line = TS_PENIRQ_LINE;
 EXTI_Init(&EXTI_InitStructure);
}
/*==========================================================================================*/
void	InitTFTGPIO	(void)
{
 GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable FSMC, GPIOD, GPIOE, GPIOF, GPIOG and AFIO clocks */
  //RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB |RCC_APB2Periph_GPIOD |
												 RCC_APB2Periph_GPIOE |RCC_APB2Periph_GPIOF |
												 RCC_APB2Periph_GPIOG |
                         RCC_APB2Periph_AFIO, ENABLE);

  /* Set PD.00(D2), PD.01(D3), PD.04(NOE), PD.05(NWE), PD.08(D13), PD.09(D14),
     PD.10(D15), PD.14(D0), PD.15(D1) as alternate 
     function push pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_4 | GPIO_Pin_5 |
                                GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_14 | 
                                GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  /* Set PE.07(D4), PE.08(D5), PE.09(D6), PE.10(D7), PE.11(D8), PE.12(D9), PE.13(D10),
     PE.14(D11), PE.15(D12) as alternate function push pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | 
                                GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | 
                                GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  /* Set PF.00(A0 (RS)) as alternate function push pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOF, &GPIO_InitStructure);

  /* Set PG.12(NE4 (LCD/CS)) as alternate function push pull - CE3(LCD /CS) */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOG, &GPIO_InitStructure);
	
	 /*Reset pin config PB.2 (LCD_RST)*/
 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_2;//RESET_PIN;	// 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 GPIO_Init(GPIOB/*RESET_PORT*/, &GPIO_InitStructure);
}
/*==========================================================================================*/
void	InitTouchGPIO		(void)
{
 GPIO_InitTypeDef	GPIO_InitStructure;
 
 RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOC|RCC_APB2Periph_AFIO,ENABLE);	
 
 GPIO_InitStructure.GPIO_Pin=TS_SDCLK_PIN|TS_SDOUT_PIN;	 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  
 GPIO_Init(TS_SDCLK_PORT, &GPIO_InitStructure);
 
 GPIO_InitStructure.GPIO_Pin=TS_SDIN_PIN;	
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
 GPIO_Init(TS_SDCLK_PORT, &GPIO_InitStructure);

//PENIRQ
 GPIO_InitStructure.GPIO_Pin=TS_PENIRQ_PIN; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;           
 GPIO_Init(TS_PENIRQ_PORT, &GPIO_InitStructure);
 GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource10);//*/
 TouchPENIRQInterruptConfig();
 //TS_CS
 GPIO_InitStructure.GPIO_Pin=TS_CS_PIN;	 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
 GPIO_Init(TS_CS_PORT, &GPIO_InitStructure); 
 
 Touchscreen.CALIB_FLAG=0;
}
/*===================================================================================================*/
void	Init_GPIO_USART	(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, uint16_t Pin_CS, GPIO_TypeDef * GPIO)	 
 {
 GPIO_InitTypeDef	GPIO_InitStructure;
 if (Remap) GPIO_PinRemapConfig(Remap, ENABLE );        // remap PD3-PD7 to USART

 if (Pin_Tx)
 	{
 	//Tx
 	GPIO_InitStructure.GPIO_Pin=Pin_Tx;	//PA9=Tx; 
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // Alt Function - Push Pull 
 	GPIO_Init(GPIO, &GPIO_InitStructure); 
 	}
 if (Pin_Rx)
 	{
	//Rx
 	GPIO_InitStructure.GPIO_Pin=Pin_Rx;	//PA10=Rx;
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;            // 
 	GPIO_Init(GPIO, &GPIO_InitStructure); 
 	//
	}
   if (Pin_CS)
 	{
	//Rx
 	GPIO_InitStructure.GPIO_Pin=Pin_CS;	//PA8=CS;
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // 
 	GPIO_Init(GPIO, &GPIO_InitStructure); 
 	//
	}
}
/*===================================================================================================*/
 void	Init_GPIO_CAN	(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, GPIO_TypeDef * GPIOx)	 
 {
 GPIO_InitTypeDef	GPIO_InitStructure;

 //Tx
 GPIO_InitStructure.GPIO_Pin=Pin_Tx;	//PA2=Tx; 
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // Alt Function - Push Pull 
 GPIO_Init(GPIOx, &GPIO_InitStructure); 
 //Rx
 GPIO_InitStructure.GPIO_Pin=Pin_Rx;	//PA3=Rx;
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;            // 
 GPIO_Init(GPIOx, &GPIO_InitStructure); 
 //
 if (Remap)
 	GPIO_PinRemapConfig(Remap, ENABLE);
}
/*===================================================================================================*/
