#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"

/*================================================================================*/
//TFT Definitions
/*================================================================================*/
#define	RESET_PORT				 GPIOB				
#define	RESET_PIN					 GPIO_Pin_2		
		
//Definition for RS pin
#define	RS_PORT					GPIOD							
#define	RS_PIN					GPIO_Pin_15				
		
// Definitions for CS pin
#define CS_PORT					GPIOB						 	
#define CS_PIN					GPIO_Pin_15				
		
// Definition for WR pin
#define	WR_PORT					GPIOB						
#define	WR_PIN					GPIO_Pin_14				
		
// Definition for RD pin
#define	RD_PORT					GPIOB							
#define	RD_PIN					GPIO_Pin_10				

//Definition fot SHUT pin
#define	SHUT_PORT				GPIOC
#define	SHUT_PIN				GPIO_Pin_8
	
//Definition for Data Bus
#define	DATA_BUS_PORT		GPIOE
#define	DATA_BUS				DATA_BUS_PORT->ODR
#define	DB0							GPIO_Pin_8
#define	DB1							GPIO_Pin_9
#define	DB2							GPIO_Pin_10
#define	DB3							GPIO_Pin_11
#define	DB4							GPIO_Pin_12
#define	DB5							GPIO_Pin_13
#define	DB6							GPIO_Pin_14
#define	DB7							GPIO_Pin_15
/*========================================================================================*/
//Definitions for TFT ports
#define RSCLR					  RS_PORT->BSRR = GPIO_BSRR_BR15	
#define RSSET						RS_PORT->BSRR = GPIO_BSRR_BS15	

#define RESETCLR				RESET_PORT->BSRR = GPIO_BSRR_BR2	
#define RESETSET				RESET_PORT->BSRR = GPIO_BSRR_BS2	
	
#define CSCLR						CS_PORT->BSRR = GPIO_BSRR_BR15	
#define CSSET						CS_PORT->BSRR = GPIO_BSRR_BS15 
	//
#define WRCLR						WR_PORT->BSRR = GPIO_BSRR_BR14 
#define WRSET						WR_PORT->BSRR = GPIO_BSRR_BS14 
	
#define RDCLR						RD_PORT->BSRR = GPIO_BSRR_BR10 
#define RDSET						RD_PORT->BSRR = GPIO_BSRR_BS10 
	
#define	SHUTCLR					SHUT_PORT->BSRR = GPIO_BSRR_BR8	
#define SHUTSET					SHUT_PORT->BSRR = GPIO_BSRR_BS8	
/*========================================================================================*/
//Definitions for Touchscreen
/*========================================================================================*/
#define	TS_CS_PORT				GPIOC						//touchscreen select
#define TS_CS_PIN					GPIO_Pin_3

#define	TS_SDCLK_PORT			GPIOA						//SPI1 CLK touchscreen
#define TS_SDCLK_PIN			GPIO_Pin_5

#define	TS_SDIN_PORT			GPIOA						//SPI input touchscreen
#define TS_SDIN_PIN				GPIO_Pin_6

#define	TS_SDOUT_PORT			GPIOA						//spi output touchscreen
#define TS_SDOUT_PIN			GPIO_Pin_7

#define	TS_PENIRQ_PORT		GPIOA					// touchscree interrupt
#define TS_PENIRQ_PIN			GPIO_Pin_10

#define	TS_PENIRQ_LINE		EXTI_Line10
#define	TS_INT						EXTI15_10_IRQn
/*========================================================================================*/
//Definitions for touchscreen ports
#define	TS_CSCLR					TS_CS_PORT->BSRR = GPIO_BSRR_BR3
#define	TS_CSSET					TS_CS_PORT->BSRR = GPIO_BSRR_BS3

#define	TS_SDICLR					TS_SDIN_PORT->BSRR =GPIO_BSRR_BR6 
#define	TS_SDISET					TS_SDIN_PORT->BSRR =GPIO_BSRR_BS6 

#define	TS_SDOUTCLR				TS_SDOUT_PORT->BSRR =GPIO_BSRR_BR7 
#define	TS_SDOUTSET				TS_SDOUT_PORT->BSRR =GPIO_BSRR_BS7

#define	TS_SDCLKCLR				TS_SDCLK_PORT->BSRR =GPIO_BSRR_BR5 
#define	TS_SDCLKSET				TS_SDCLK_PORT->BSRR =GPIO_BSRR_BS5

#define	TS_SDOUT					TS_SDOUT_PORT->IDR & (T_SDOUT_PIN)
#define TS_PENIRQ					TS_PENIRQ_PORT->IDR &(T_PENIRQ_PIN)

/*=========================================================================================*/
//Functions definitions
/*=========================================================================================*/
void	InitTFTGPIO			(void);
void	InitTouchGPIO		(void);
void	Init_GPIO_USART	(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, uint16_t Pin_CS, GPIO_TypeDef * GPIO);	 
void	Init_GPIO_CAN		(uint32_t Remap,uint16_t Pin_Tx, uint16_t Pin_Rx, GPIO_TypeDef * GPIOx);


