#include	"SPI.h"  
#include  "TouchADS7843.h"
/*===========================================================================================================================*/
void	SPI_Configuration (void) 
{ 
  SPI_InitTypeDef  SPI_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
  /* DISABLE SPI1 */ 
  SPI_Cmd(SPI1, DISABLE); 
  /* SPI1 Config -------------------------------------------------------------*/ 
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; 
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master; 
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; 
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; 
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; 
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; 
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; 
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; 
  SPI_InitStructure.SPI_CRCPolynomial = 7; 
  SPI_Init(SPI1, &SPI_InitStructure); 
  /* Enable SPI1 */ 
  SPI_Cmd(SPI1, ENABLE); 
}
/*******************************************************************************
* Function Name  : DelayUS
* Description    : ʱ1us
* Input          : - cnt: ʱֵ
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void DelayUS		(vu32 cnt)
{
  uint32_t i;
  for(i = 0;i<cnt;i++)
  {
     uint8_t us = 12; /* ֵΪ12Լ1΢ */    
     while (us--)     /* 1΢	*/
     {
       ;   
     }
  }
}
/*******************************************************************************
* Function Name  : WR_CMD
* Description    :  ADS7843д
* Input          : - cmd: 
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void WR_CMD (uint8_t cmd)  
{ 
  /* Wait for SPI1 Tx buffer empty */ 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET); 
  /* Send SPI1 data */ 
  SPI_I2S_SendData(SPI1,cmd); 
  /* Wait for SPI1 data reception */ 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET); 
  /* Read SPI1 received data */ 
  SPI_I2S_ReceiveData(SPI1); 
} 

/*******************************************************************************
* Function Name  : RD_AD
* Description    : ȡADCֵ
* Input          : None
* Output         : None
* Return         : ADS7843ضֽ
* Attention		 : None
*******************************************************************************/
static int RD_AD(void)  
{ 
  unsigned short buf,temp; 
  /* Wait for SPI1 Tx buffer empty */ 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET); 
  /* Send SPI1 data */ 
  SPI_I2S_SendData(SPI1,0x0000); 
  /* Wait for SPI1 data reception */ 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET); 
  /* Read SPI1 received data */ 
  temp=SPI_I2S_ReceiveData(SPI1); 
  buf=(temp&0x7F)<<8; 
  DelayUS(100); 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET); 
  /* Send SPI1 data */ 
  SPI_I2S_SendData(SPI1,0x0000); 
  /* Wait for SPI1 data reception */ 
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET); 
  /* Read SPI1 received data */ 
  temp=SPI_I2S_ReceiveData(SPI1); 
  buf |= temp; 
  buf>>=3; 
  buf&=0xfff; 
  return buf; 
} 

/*******************************************************************************
* Function Name  : Read_X
* Description    : ȡADS7843ͨX+ADCֵ 
* Input          : None
* Output         : None
* Return         : ADS7843ͨX+ADCֵ
* Attention		 : None
*******************************************************************************/
int Read_X(void)  
{  
  static int i/*,predi, n, summ*/; 
  
	TS_CSCLR; 
  DelayUS(1); 
  WR_CMD(0x90); 
  DelayUS(1); 
  i=RD_AD(); 
  TS_CSSET;
	/*do{
		predi=i;
		summ+=i;
		n++;
		TS_CSCLR; 
		DelayUS(100); 
		WR_CMD(0x90); 
		DelayUS(100); 
		i=RD_AD(); 
		TS_CSSET;
	}while (i!=predi);*/
return (/*summ/n*/i);    
} 

/*******************************************************************************
* Function Name  : Read_Y
* Description    : ȡADS7843ͨY+ADCֵ
* Input          : None
* Output         : None
* Return         : ADS7843ͨY+ADCֵ
* Attention		 : None
*******************************************************************************/
int Read_Y(void)  
{  
static   int i/*,predi, n, summ*/; 
	
  TS_CSCLR; 
  DelayUS(1); 
  WR_CMD(0xd0); 
  DelayUS(1); 
  i=RD_AD(); 
  TS_CSSET;
	/*do{
			predi=i;
		  summ+=i;
		  n++;
			TS_CSCLR; 
			DelayUS(100); 
			WR_CMD(0xd0); 
			DelayUS(100); 
			i=RD_AD(); 
			TS_CSSET;
	}while (predi!=i);*/
	return (i/*summ/n*/);     
} 

/*******************************************************************************
* Function Name  : TP_GetAdXY
* Description    : ȡADS7843 ͨX+ ͨY+ADCֵ
* Input          : None
* Output         : None
* Return         : ADS7843 ͨX+ ͨY+ADCֵ 
* Attention		 : None
*******************************************************************************/
void TP_GetAdXY	(uint8_t calibState)  
{ 
  static int adx,ady; 
  adx=Read_X(); 
  DelayUS(1); 
  ady=Read_Y(); 
	if (calibState==NO_CALIB)
		{
			Touchscreen.Xpos=adx;
			Touchscreen.Ypos=ady;
		}
		else
				{
						Touchscreen.Xpos=TS_K_Y*ady+TS_B_Y;			
						Touchscreen.Ypos=TS_K_X*adx+TS_B_X;
						if ((Touchscreen.Xpos<=(480-20))&&(Touchscreen.Xpos>45))
								Touchscreen.Xpos=Touchscreen.Xpos-25;
								else if (Touchscreen.Xpos<=45)
												Touchscreen.Xpos=Touchscreen.Xpos-45;
						if (Touchscreen.Ypos<=(272-25))
								Touchscreen.Ypos=Touchscreen.Ypos-25;
						if (Touchscreen.Xpos>480)
								Touchscreen.Xpos=480;
								else if (Touchscreen.Xpos<0)
												Touchscreen.Xpos=0;
						if (Touchscreen.Ypos>272)
								Touchscreen.Ypos=272;
								else if(Touchscreen.Ypos<0)
												Touchscreen.Ypos=0;		
				}
} 
/*******************************************************************************/

