#include 	"TIM.h"
#include	"PanelGlobalVars.h"
#include "Modbus_ASCIIGlobalVars.h"
#include "GraphInterface.h"
//#include "Text.h"
/*===================================================================================================*/
void	InitTimer		(TIM_TypeDef* TIMx, uint16_t period,uint16_t psc)//1ms timer
{
TIM_TimeBaseInitTypeDef 	Tim_InitStruct;
	
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM7, ENABLE);	
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);		
Tim_InitStruct.TIM_ClockDivision=TIM_CKD_DIV1;
Tim_InitStruct.TIM_CounterMode=TIM_CounterMode_Up;
Tim_InitStruct.TIM_Period=period;		 
Tim_InitStruct.TIM_Prescaler=psc;	 		
TIM_TimeBaseInit(TIMx,&Tim_InitStruct);
TIM_Cmd(TIMx,DISABLE);
}
/*====================================================================================*/
void	Delay 	(TIM_TypeDef* TIMx)
{
TIM2->CR1|=0x01; 
while(!TIMx->SR&TIM_FLAG_Update) {}
TIM2->CR1&=~0x01;
}  

/*==============================================================================================================*/

void	TmrOn	(TIM_TypeDef* TIMx)	 	//		timer 2 on delay 1 sec
{
TIM_Cmd(TIMx,ENABLE); 
}
/*==============================================================================================================*/
void	TmrOff	(TIM_TypeDef* TIMx)
{
TIM_Cmd			(TIMx,DISABLE);			 //disable counting timer 3
TIM_SetCounter	(TIMx,0);		//reset CNT
}
/*===============================================================*/
void	DelayMs	(uint32_t	timeMs)
{
	uint16_t	i;
	
	for (i=0;i<timeMs;i++)
		  Delay(TFT_DELAY_TIM);
}
/*===============================================================*/
void	TmrConfig	(TIM_TypeDef* TIMx,uint8_t TIM_IRQn, uint16_t delay,uint16_t psc, uint8_t priority)
{
InitTimer	(TIMx,delay,psc);
NVICTmrInit	(TIMx,TIM_IRQn,priority);
}
/*================================================================================================================*/
void	TIM2_IRQHandler	(void)  //  
{
if	(TIM_GetITStatus(TIM2,TIM_IT_Update))
	{
	//TIM_ClearITPendingBit(TIM2,TIM_IT_Update);		 
	TIM2->SR=0;
	TmrOff(TIM2);
	CHALLENGE_FLAG=1;
	//TmrOn(TIM2);
	}
}	
/*================================================================================================================*/
void	TIM7_IRQHandler	(void)  //   
{
if	(TIM_GetITStatus(TIM7,TIM_IT_Update))
	{
	TIM7->SR=0;
	Reset_Frame_Master(&MODBUS2,TIM7);
	MODBUS2.StateFlags&=~(1<<MB_RESPONSE_WAIT_FLAG);	
	MODBUS2.StateFlags|=1<<MB_RESPONSE_READY_FLAG;
	MODBUS2.StateFlags|=1<<NO_CONNECT_FLAG;
	TmrOn(CHALLENGE_TIM);
	}
}	