#include "MySSD1963.h"
#include "FSMC.h"

/*==================================================================*/
uint16_t LCD_ReadReg(uint8_t LCD_Reg)
{
	/**
  * @brief  Reads the selected LCD Register.
  * @param  None
  * @retval : LCD Register Value.
  */
  /* Write 16-bit Index (then Read Reg) */
 LCD_REG = LCD_Reg;
  /* Read 16-bit Reg */
  return (LCD_RAM);
}
/*==================================================================*/
void LCD_WriteCommand(uint8_t cmd) 
{
  LCD_REG = cmd;
}
/*==================================================================*/
void LCD_WriteData(uint8_t data) 
{
  LCD_RAM = data;
}
/*==================================================================*/
void LCD_WriteCmd(uint8_t cmd, uint8_t data)
{
  LCD_REG=cmd;
  LCD_RAM=data;
}
/*==================================================================*/
/*void Delay(uint32_t nCount)
{
	/**
  * @brief  Inserts a delay time.
  * @param ount: specifies the delay time length (time base 10 ms).
  * @retval : None
  */
 /* TimingDelay = nCount;
 
  while(TimingDelay != 0)
  {
  }
}*/
/*==================================================================*/
void	InitSSD1963	(void)
{
	
	/*GPIOB->BSRR = GPIO_BSRR_BR2;//*/RESETCLR;//RS=0
	DelayUS(1);
	/*GPIOB->BSRR = GPIO_BSRR_BS2;//*/RESETSET;//RS=1
	DelayUS(1);
	
	
	LCD_WriteCommand(CMD_SOFT_RESET);
	LCD_WriteCommand(CMD_SOFT_RESET);
	LCD_WriteCommand(CMD_SOFT_RESET);
		
	
	LCD_WriteCmd(CMD_PLL_START,0x01);//START PLL
	LCD_WriteCmd(CMD_PLL_START,0x03);//LOCK PLL
		
	LCD_WriteCommand(CMD_SET_PANEL_MODE);//SET LCD MODE SET TFT 18Bits MODE
	
	
	LCD_WriteData(0x0C);	 //SET TFT MODE & hsync+Vsync+DEN MODE
	LCD_WriteData(0x00);	 //SET TFT MODE & hsync+Vsync+DEN MODE
	LCD_WriteData(0x01);	 //SET horizontal size=320-1 HightByte
	LCD_WriteData(0x3f);	 //SET horizontal size=320-1 LowByte
	LCD_WriteData(0x00); 	//SET vertical size=240-1 HightByte
	LCD_WriteData(0xef); //SET vertical size=240-1 LowByte
	LCD_WriteData(0x00); //SET even/odd line RGB seq.=RGB
	
	
	LCD_WriteCmd(CMD_SET_DATA_INTERFACE,0x00); //SET pixel data I/F format=8bit
	//WriteCmd(CMD_SET_PIXEL_FORMAT,0x60); // SET R G B format = 6 6 6
	
	LCD_WriteCommand(CMD_SET_PLL_MN); //SET PLL freq=113.33MHz ;
	
	LCD_WriteData(0x22);
	LCD_WriteData(0x03);
	LCD_WriteData(0x04);
	
	
		
	LCD_WriteCommand(CMD_SET_PCLK); //SET PCLK freq=9MHz ; pixel clock frequency

	LCD_WriteData(0x00);
	LCD_WriteData(0xe7);
	LCD_WriteData(0x4f);
  
	
	
	LCD_WriteCommand(CMD_SET_HOR_PERIOD); //SET HBP
	
	
	
	LCD_WriteData(0x01); //SET HSYNC Total = 440
	LCD_WriteData(0xb8);
	LCD_WriteData(0x00); //SET HBP = 68
	LCD_WriteData(0x44);
	LCD_WriteData(0x0f); //SET VBP 16 = 15 + 1
	LCD_WriteData(0x00); //SET Hsync pulse start position
	LCD_WriteData(0x00);
	LCD_WriteData(0x00); //SET Hsync pulse subpixel start position
	
	LCD_WriteCommand(CMD_SET_VER_PERIOD); //SET VBP
		
	LCD_WriteData(0x01); //SET Vsync total 265 = 264 + 1
	LCD_WriteData(0x08);
	LCD_WriteData(0x00); //SET VBP = 19
	LCD_WriteData(0x13);
	LCD_WriteData(0x07); //SET Vsync pulse 8 = 7 + 1
	LCD_WriteData(0x00); //SET Vsync pulse start position
	LCD_WriteData(0x00);


  LCD_WriteCommand(CMD_SET_COLUMN);//SET column address
	LCD_WriteData(0x00); //SET start column address=0
	LCD_WriteData(0x00);
	LCD_WriteData(0x01); //SET end column address=320
	LCD_WriteData(0x3f);
	
	LCD_WriteCommand(CMD_SET_PAGE);//SET page address
	LCD_WriteData(0x00); //SET start page address=0
	LCD_WriteData(0x00);
	LCD_WriteData(0x00); //SET end page address=240
	LCD_WriteData(0xef);
	
	LCD_WriteCommand(CMD_ON_DISPLAY); //SET display on
	LCD_WriteCommand(CMD_WR_MEMSTART);
	
}
/*==================================================================*/
void	WindowSet(unsigned int s_x,unsigned int e_x,unsigned int s_y,unsigned int e_y)
{
e_x=e_x-1;
e_y=e_y-1;	
LCD_WriteCommand(CMD_SET_COLUMN); //SET page address
	
LCD_WriteData((s_x)>>8); //SET start page address=0
LCD_WriteData(s_x);
LCD_WriteData((e_x)>>8); //SET end page address=320
LCD_WriteData(e_x);


LCD_WriteCommand(CMD_SET_PAGE); //SET column address
	

LCD_WriteData((s_y)>>8); //SET start column address=0
LCD_WriteData(s_y);
LCD_WriteData((e_y)>>8); //SET end column address=240
LCD_WriteData(e_y);
}
/*==================================================================*/
void	Set_X	(unsigned int s_x,unsigned int e_x)
{
e_x=e_x-1;
LCD_WriteCommand(CMD_SET_COLUMN); //SET page address
LCD_WriteData((s_x)>>8); //SET start page address=0
LCD_WriteData(s_x);
LCD_WriteData((e_x)>>8); //SET end page address=320
LCD_WriteData(e_x);
}
/*==================================================================*/
void	Set_Y	(unsigned int s_y,unsigned int e_y)
{
e_y=e_y-1;
LCD_WriteCommand(CMD_SET_PAGE); //SET column address
LCD_WriteData((s_y)>>8); //SET start column address=0
LCD_WriteData(s_y);
LCD_WriteData((e_y)>>8); //SET end column address=240
LCD_WriteData(e_y);
}
/*==========================================================================================*/
void	WriteDataBus	(uint32_t color, uint32_t n)
{
	while (n)
				{
					LCD_WriteData(((color>>11)<<3)<<8);
					LCD_WriteData((((color>>5)&0x3f)<<2)<<8);
					LCD_WriteData((((color)&0x1f)<<3)<<8);
					n--;
				}
}
/*==================================================================*/
void FULL_ON(unsigned long dat)
{
unsigned int y;

	WindowSet(0x0000,TFT_WIDTH,0x0000,TFT_HEIGHT);
  LCD_WriteCommand(CMD_WR_MEMSTART);
  for (y= 0;y<TFT_WIDTH*TFT_HEIGHT;y++)
						{				
							LCD_WriteData(((dat>>11)<<3)<<8);
							LCD_WriteData((((dat>>5)&0x3f)<<2)<<8);
							LCD_WriteData(((dat&0x1f)<<3)<<8);
						}		
}
/*==================================================================*/


