#include	"stm32f10x.h"
#include "GPIO.h"
#include "FSMC.h"
#include "SSD1963_CMD.h"
#include "TIM.h"
//TFT definitions
#define   TFT_HEIGHT		240
#define		TFT_WIDTH			320
//Color definitions
#define RGB565CONVERT(red, green, blue) (uint32_t) (((red >> 3) << 11) | ((green >> 2) << 5) | (blue >> 3))

#define BLACK               RGB565CONVERT(0,    0,      0)
#define BRIGHTBLUE          RGB565CONVERT(0,    0,      255)
#define BRIGHTGREEN         RGB565CONVERT(0,    255,    0)
#define BRIGHTCYAN          RGB565CONVERT(0,    255,    255)
#define BRIGHTRED           RGB565CONVERT(255,  0,      0)
#define BRIGHTMAGENTA       RGB565CONVERT(255,  0,      255)
#define BRIGHTYELLOW        RGB565CONVERT(255,  255,    0)
#define BLUE                RGB565CONVERT(0,    0,      128)
#define GREEN               RGB565CONVERT(0,    128,    0)
#define CYAN                RGB565CONVERT(0,    128,    128)
#define RED                 RGB565CONVERT(128,  0,      0)
#define MAGENTA             RGB565CONVERT(128,  0,      128)
#define BROWN               RGB565CONVERT(255,  128,    0)
#define LIGHTGRAY           RGB565CONVERT(128,  128,    128)
#define DARKGRAY            RGB565CONVERT(64,   64,     64)
#define LIGHTBLUE           RGB565CONVERT(128,  128,    255)
#define LIGHTGREEN          RGB565CONVERT(128,  255,    128)
#define LIGHTCYAN           RGB565CONVERT(128,  255,    255)
#define LIGHTRED            RGB565CONVERT(255,  128,    128)
#define LIGHTMAGENTA        RGB565CONVERT(255,  128,    255)
#define YELLOW              RGB565CONVERT(255,  255,    128)
#define WHITE               RGB565CONVERT(255,  255,    255)
                            
#define GRAY0       	      RGB565CONVERT(224,  224,    224)
#define GRAY1         	    RGB565CONVERT(192,  192,    192)   
#define GRAY2               RGB565CONVERT(160,  160,    160)   
#define GRAY3               RGB565CONVERT(128,  128,    128)
#define GRAY4               RGB565CONVERT(96,   96,     96)
#define GRAY5               RGB565CONVERT(64,   64,     64)
#define GRAY6	              RGB565CONVERT(32,   32,     32)

//My colors
#define	SNOW								RGB565CONVERT(255,   250, 	250)
#define	GGHOSTWHITE					RGB565CONVERT(248,   248,   255)
#define LEMON_CHIFFON				RGB565CONVERT(255,   250,   205)	
#define	HONEYDEW						RGB565CONVERT(240,   255,   240)	
#define	DIM_GREY						RGB565CONVERT(105,   105,   105)
#define SLATE_GRAY					RGB565CONVERT(112,   128,   144)
#define MIDNIGHT_BLUE				RGB565CONVERT(25,    25,    112)
#define	NAVY								RGB565CONVERT(0,     0,     128)
#define	SLATE_BLUE					RGB565CONVERT(106,   90,    205)
#define	DEEP_SKY_BLUE				RGB565CONVERT(0,     191,   255)
#define	MEDIUM_AQUAMARINE		RGB565CONVERT(102,   205,   170)
#define	DARK_GREEN					RGB565CONVERT(0,     100,     0)
#define	DARK_OLIVE_GREEN		RGB565CONVERT(85,    107,   047)
#define	SEA_GREEN						RGB565CONVERT(46,    139,    87)
#define	MEDIUM_SEA_GREEN		RGB565CONVERT(60,    179,   113)
#define	LIME_GREEN					RGB565CONVERT(50,    205,    50)
#define	OLIVE_DRAB					RGB565CONVERT(107,   142,    35)
#define	GOLD								RGB565CONVERT(255,   215,     0)
#define	DARK_YELLOW					RGB565CONVERT(0x80,  0x80,  0x00)
#define	WHEAT								RGB565CONVERT(0xF5,  0xDE,  0xB3)
#define	TAN									RGB565CONVERT(0xD2,  0xB4,  0x8C)
#define	RED1								RGB565CONVERT(0xCC,  0x00,  0x00)
#define	RED2								RGB565CONVERT(0xEE,  0x00,  0x00)
#define	FIREBRICK						RGB565CONVERT(0xFF,  0x30,  0x30)
#define	ORANGE1							RGB565CONVERT(255,   165,      0)
#define	ORANGE2							RGB565CONVERT(238,   154,      0)
#define	DARK_ORANGE					RGB565CONVERT(255,   127,      0)
/*========================================================================================*/
/*SSD1963 functions TFT Controller*/
/*========================================================================================*/
void	NOP						(void);
uint16_t LCD_ReadReg(uint8_t LCD_Reg);
//void 	Delay					(uint32_t nCount);
void	InitSSD1963		(void);
void	SendData			(uint32_t color);
void	WindowSet			(unsigned int s_x,unsigned int e_x,unsigned int s_y,unsigned int e_y);
void	Set_X				(unsigned int s_x,unsigned int e_x);
void	Set_Y				(unsigned int s_y,unsigned int e_y);
void 	FULL_ON				(unsigned long dat);	
void	SetPixelXY		        (uint16_t	x,uint16_t	y,uint16_t color);
//void	CircleXY			(uint16_t x,uint16_t y,uint16_t R,uint16_t color);
void    LCD_WriteCommand                (uint8_t cmd); 
void    LCD_WriteData                   (uint8_t data); 
void    LCD_WriteCmd                    (uint8_t cmd, uint8_t data);
