#include "Text.h"
#include "Arial.c"
#include "string.h"
/*==============================================================================================*/
/*Fonts data*/
/*==============================================================================================*/
uint8_t		GL_Font=GL_FONT_BIG;

FONTTYPE ARIAL9pt={
arialNarrow_9ptBitmaps,
Arial9Width,
Arial9Offset,	
13
};

FONTTYPE ARIAL10pt={
arialNarrow_10ptBitmaps,
Arial10Width,
Arial10Offset,
15
};
 
FONTTYPE ARIAL24pt={
arial_24ptBitmaps,
Arial24Width,	
Arial24Offset,
37
};

FONTTYPE	*CurrentFont=&ARIAL10pt;
/*==============================================================================================*/
void TFT_WriteChar(uint16_t Xpos, uint16_t Ypos, const uint8_t *c, uint8_t width,uint8_t height,uint32_t GL_BackGround,uint32_t GL_TextColor)
{
 uint32_t index = 0, counter = 0, ctr=0;

for (index = 0; index < height; index++)
  {
    WindowSet(Xpos,Xpos+width,Ypos+index,Ypos+index+1);
		LCD_WriteCommand(CMD_WR_MEMSTART);
				RDSET;
				RSSET;
				CSCLR;
	  
		for (counter = 0; counter < width; counter++)
    {
      if (ctr==8)
				{
				 *c++;
					ctr=0;	
				}
			if ((GL_Font==GL_FONT_BIG &&(*c&(1<<ctr))==0)||
				 (GL_Font == GL_FONT_SMALL && (*c & (0x80 >> ctr)) == 0x00))
			/* SmallFonts have bytes in reverse order */
     /* if (( GL_Font == GL_FONT_BIG   && (((const uint16_t*)c)[index] & (1 << counter)) == 0x00) ||
          ( GL_Font == GL_FONT_SMALL && (c[index] & (0x80 >> counter)) == 0x00))*/
      {
					WRCLR;
					DATA_BUS=((GL_BackGround>>11)<<3)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((GL_BackGround>>5)&0x3f)<<2)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((GL_BackGround)&0x1f)<<3)<<8;
					WRSET;
      }
      else
      {
        	WRCLR;
					DATA_BUS=((GL_TextColor>>11)<<3)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((GL_TextColor>>5)&0x3f)<<2)<<8;
				  WRSET;
					WRCLR;
					DATA_BUS=(((GL_TextColor)&0x1f)<<3)<<8;
					WRSET;
      }
		ctr++;
		}
		*c++;
		ctr=0;
		WRSET;		
		CSSET;
	}
}
/*==============================================================================================*/
void	TFT_Log	(uint16_t	Xpos, uint16_t Ypos,uint8_t* ptr,uint16_t	BackGround,uint16_t TextColor,FONTTYPE* Font)
{
uint16_t tabledisp;
uint8_t	 width;
	
	while (*ptr)
				{
					if (*ptr>=0xC0)
							tabledisp=(*ptr)-97;
							else 
									tabledisp=(*ptr)-0x20;
					width=Font->Width[tabledisp];
							
					if ((Ypos+Font->Height)<TFT_HEIGHT)
							{
							if ((Xpos+width)<TFT_WIDTH)
								{
									TFT_WriteChar(Xpos,Ypos,&(Font->table[Font->Offset[tabledisp]]),width,Font->Height,BackGround,TextColor);
									Xpos=Xpos+width;
								 *ptr++;	
								}
							else		{Xpos=0; Ypos=Ypos+Font->Height;}	
							}	
					else break;			
					}
}

/*==================================================================================================================*/
uint16_t GetStringLenght	(uint8_t* ptr, FONTTYPE* Font)
{
  uint16_t	width=0;
	
	while(*ptr)
				{
					if (*ptr>=0xC0)
						width+=Font->Width[*ptr-97]	;
						else
								width+=Font->Width[*ptr-0x20];
					*ptr++;
				}
return width;
}
/*==================================================================================================================*/
uint8_t	GetCharWidth(uint8_t ptr,FONTTYPE* Font)
{
	uint8_t 	width;
	uint8_t* 	widthptr;
	
	widthptr=Font->Width;
			
	if (ptr>=0xC0)
			width=widthptr[ptr-97];
			else
					width=widthptr[ptr-0x20];
	
return width;
}
/*===================================================================================================*/
void	HexToASCII	(unsigned char	hex_data, uint8_t* ptr)
{
	uint8_t temp=0;
	uint8_t n=1;
	
	while (n<=3)
				{
					switch(n)
								{
									case 1:	{temp=hex_data/100;n++;}	break;
									case 2: {temp=hex_data/10;n++;} 	break;
									case 3: {temp=hex_data%10; n++;}	break;
								}
				  if (!((temp==0)&&(n<4)))
							{
								temp=temp+0x30;
								*ptr++=temp;
							}
				}
}
/*===================================================================================================*/
uint8_t	GetStringByWidth	(uint8_t* str1,uint16_t width,FONTTYPE* Font)
{
	uint8_t i=0;
	uint16_t n=0, charwidth=0;
	uint8_t ch[1];

while ((n<width)&&(str1[i]))
				{
					ch[0]=GetChar(&str1[i]);
					charwidth=GetStringLenght(&ch[0],Font);
					n=n+charwidth;
					i++;
				}
if	(n>=width)
		i--;
return i;
}
/*===================================================================================================*/
uint8_t	GetChar		(uint8_t* str)
{
return (*str);	
}
/*===================================================================================================*/
 /*===================================================================================================*/