#include "TouchADS7843.h"

/*Touchscreen data*/
TOUCHSCREEN_DATA	Touchscreen;

/*==============================================================================================================*/
void getDisplayCoordinateX(uint16_t x_touch, uint16_t y_touch)
{
  uint16_t Xd;
  float temp;
  temp = (Touchscreen.A2 * x_touch + Touchscreen.B2 * y_touch + Touchscreen.C2) / RESCALE_FACTOR;
  Xd = (uint16_t)(temp);
  if (Xd > 60000)
  {
    /* this to avoid negative value */
    Xd = 0;
  }
  Touchscreen.Ypos=Xd;
}
/*==============================================================================================*/
void getDisplayCoordinateY(uint16_t x_touch, uint16_t y_touch)//X
{
  uint16_t Yd;
  float temp;
  temp = (Touchscreen.D2 * x_touch + Touchscreen.E2 * y_touch + Touchscreen.F2) / RESCALE_FACTOR;
  Yd = (uint16_t)(temp);
  if (Yd > 60000)
  {
    /*  this to avoid negative value */
    Yd = 0;
  }
	
  Touchscreen.Xpos=Yd;
}
/*==============================================================================================*/
void TS_Calibration(void)
{
	//static uint32_t iii=0;
	
  uint32_t coordinate_X1a = 0, coordinate_X2a = 0, coordinate_X3a = 0, coordinate_X4a = 0, coordinate_X5a = 0;
  uint32_t coordinate_Y1a = 0, coordinate_Y2a = 0, coordinate_Y3a = 0, coordinate_Y4a = 0, coordinate_Y5a = 0;
  uint32_t coordinate_X1b = 0, coordinate_X2b = 0, coordinate_X3b = 0, coordinate_X4b = 0, coordinate_X5b = 0;
  uint32_t coordinate_Y1b = 0, coordinate_Y2b = 0, coordinate_Y3b = 0, coordinate_Y4b = 0, coordinate_Y5b = 0;
  uint32_t coordinate_X1 = 0, coordinate_X2 = 0, coordinate_X3 = 0, coordinate_X4 = 0, coordinate_X5 = 0;
  uint32_t coordinate_Y1 = 0, coordinate_Y2 = 0, coordinate_Y3 = 0, coordinate_Y4 = 0, coordinate_Y5 = 0;
  uint16_t Xd1 = (TFT_WIDTH / 2), Xd2 = 1 * (TFT_WIDTH / 5), Xd3 = 4 * (TFT_WIDTH / 5), Xd4 = 4 * (TFT_WIDTH / 5), Xd5 = 1 * (TFT_WIDTH / 5);
  uint16_t Yd1 = (TFT_HEIGHT / 2), Yd2 = 1 * (TFT_HEIGHT / 5), Yd3 = 1 * (TFT_HEIGHT / 5), Yd4 = 4 * (TFT_HEIGHT / 5), Yd5 = 4 * (TFT_HEIGHT / 5);
  double A = 0.0, B = 0.0, C = 0.0, D = 0.0, E = 0.0, F = 0.0;
  double d = 0.0, dx1 = 0.0, dx2 = 0.0, dx3 = 0.0, dy1 = 0.0, dy2 = 0.0, dy3 = 0.0;
  uint32_t X2_1 = 0, X2_2 = 0, X2_3 = 0, X2_4 = 0, X2_5 = 0;
  uint32_t Y2_1 = 0, Y2_2 = 0, Y2_3 = 0, Y2_4 = 0, Y2_5 = 0;
  uint32_t XxY_1 = 0, XxY_2 = 0, XxY_3 = 0, XxY_4 = 0, XxY_5 = 0;
  uint32_t XxXd_1 = 0, XxXd_2 = 0, XxXd_3 = 0, XxXd_4 = 0, XxXd_5 = 0;
  uint32_t YxXd_1 = 0, YxXd_2 = 0, YxXd_3 = 0, YxXd_4 = 0, YxXd_5 = 0;
  uint32_t XxYd_1 = 0, XxYd_2 = 0, XxYd_3 = 0, XxYd_4 = 0, XxYd_5 = 0;
  uint32_t YxYd_1 = 0, YxYd_2 = 0, YxYd_3 = 0, YxYd_4 = 0, YxYd_5 = 0;
  uint32_t alfa = 0, beta = 0, chi = 0, Kx = 0, Ky = 0, Lx = 0, Ly = 0;
  uint16_t epsilon = 0, fi = 0, Mx = 0, My = 0;

  FULL_ON(WHITE);
  TFT_DrawFilledCircleMy ( (TFT_WIDTH / 2), (TFT_HEIGHT / 2),5, BLACK ); /* Absolute Central Point */
  
	while (Touchscreen.TOUCH==0);
	Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X1a = Touchscreen.Xpos;
  coordinate_Y1a = Touchscreen.Ypos;
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  
	TFT_DrawFilledCircleMy(1*(TFT_WIDTH / 5),1*(TFT_HEIGHT / 5),5,  BLACK); /* Nord-East Corner point */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X2a = Touchscreen.Xpos;
  coordinate_Y2a = Touchscreen.Ypos;
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */

  TFT_DrawFilledCircleMy(4*(TFT_WIDTH / 5),1*(TFT_HEIGHT / 5), 5, BLACK); /* Nord-West Corner */
  while (Touchscreen.TOUCH==0);
	Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X3a = Touchscreen.Xpos;
  coordinate_Y3a = Touchscreen.Ypos;
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
 
  TFT_DrawFilledCircleMy(4*(TFT_WIDTH / 5),4*(TFT_HEIGHT / 5), 5, BLACK); /* Sud-West Corner */
  while (Touchscreen.TOUCH==0);
	Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X4a = Touchscreen.Xpos;
  coordinate_Y4a = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  
  TFT_DrawFilledCircleMy( 1*(TFT_WIDTH / 5),4*(TFT_HEIGHT / 5),5, BLACK); /* Sud-East Corner point */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X5a = Touchscreen.Xpos;
  coordinate_Y5a = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  
	FULL_ON(WHITE);
	Delay(TFT_DELAY_TIM);
  TFT_DrawFilledCircleMy( (TFT_WIDTH / 2),(TFT_HEIGHT / 2), 5, BLACK ); /* Absolute Central Point */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X1b = Touchscreen.Xpos;
  coordinate_Y1b = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */ Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
   
	TFT_DrawFilledCircleMy(1*(TFT_WIDTH / 5),1*(TFT_HEIGHT / 5), 5,  BLACK); /* Nord-East Corner point */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X2b = Touchscreen.Xpos;
  coordinate_Y2b = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  
  TFT_DrawFilledCircleMy(4*(TFT_WIDTH / 5),1*(TFT_HEIGHT / 5), 5, BLACK); /* Nord-West Corner */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X3b = Touchscreen.Xpos;
  coordinate_Y3b = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
   
	TFT_DrawFilledCircleMy(4*(TFT_WIDTH / 5),4*(TFT_HEIGHT / 5), 5, BLACK); /* Sud-West Corner */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X4b = Touchscreen.Xpos;
  coordinate_Y4b = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
    
	TFT_DrawFilledCircleMy(1*(TFT_WIDTH / 5),4*(TFT_HEIGHT / 5), 5, BLACK); /* Sud-East Corner point */
  while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	TP_GetAdXY(NO_CALIB);
  coordinate_X5b = Touchscreen.Xpos;
  coordinate_Y5b = Touchscreen.Ypos;
	Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  Delay(TFT_DELAY_TIM); /* This is to catch only one touch event */
  
  /* Average between X and Y coupled Touchscreen values */
  coordinate_X1 = (coordinate_X1a + coordinate_X1b) / 2;
  coordinate_X2 = (coordinate_X2a + coordinate_X2b) / 2;
  coordinate_X3 = (coordinate_X3a + coordinate_X3b) / 2;
  coordinate_X4 = (coordinate_X4a + coordinate_X4b) / 2;
  coordinate_X5 = (coordinate_X5a + coordinate_X5b) / 2;

  coordinate_Y1 = (coordinate_Y1a + coordinate_Y1b) / 2;
  coordinate_Y2 = (coordinate_Y2a + coordinate_Y2b) / 2;
  coordinate_Y3 = (coordinate_Y3a + coordinate_Y3b) / 2;
  coordinate_Y4 = (coordinate_Y4a + coordinate_Y4b) / 2;
  coordinate_Y5 = (coordinate_Y5a + coordinate_Y5b) / 2;

  X2_1 = (coordinate_X1 * coordinate_X1);
  X2_2 = (coordinate_X2 * coordinate_X2);
  X2_3 = (coordinate_X3 * coordinate_X3);
  X2_4 = (coordinate_X4 * coordinate_X4);
  X2_5 = (coordinate_X5 * coordinate_X5);

  Y2_1 = (coordinate_Y1 * coordinate_Y1);
  Y2_2 = (coordinate_Y2 * coordinate_Y2);
  Y2_3 = (coordinate_Y3 * coordinate_Y3);
  Y2_4 = (coordinate_Y4 * coordinate_Y4);
  Y2_5 = (coordinate_Y5 * coordinate_Y5);

  XxY_1 = (coordinate_X1 * coordinate_Y1);
  XxY_2 = (coordinate_X2 * coordinate_Y2);
  XxY_3 = (coordinate_X3 * coordinate_Y3);
  XxY_4 = (coordinate_X4 * coordinate_Y4);
  XxY_5 = (coordinate_X5 * coordinate_Y5);

  XxXd_1 = ( coordinate_X1 * Xd1 );
  XxXd_2 = ( coordinate_X2 * Xd2 );
  XxXd_3 = ( coordinate_X3 * Xd3 );
  XxXd_4 = ( coordinate_X4 * Xd4 );
  XxXd_5 = ( coordinate_X5 * Xd5 );

  YxXd_1 = ( coordinate_Y1 * Xd1 );
  YxXd_2 = ( coordinate_Y2 * Xd2 );
  YxXd_3 = ( coordinate_Y3 * Xd3 );
  YxXd_4 = ( coordinate_Y4 * Xd4 );
  YxXd_5 = ( coordinate_Y5 * Xd5 );

  XxYd_1 = ( coordinate_X1 * Yd1 );
  XxYd_2 = ( coordinate_X2 * Yd2 );
  XxYd_3 = ( coordinate_X3 * Yd3 );
  XxYd_4 = ( coordinate_X4 * Yd4 );
  XxYd_5 = ( coordinate_X5 * Yd5 );

  YxYd_1 = ( coordinate_Y1 * Yd1 );
  YxYd_2 = ( coordinate_Y2 * Yd2 );
  YxYd_3 = ( coordinate_Y3 * Yd3 );
  YxYd_4 = ( coordinate_Y4 * Yd4 );
  YxYd_5 = ( coordinate_Y5 * Yd5 );

  alfa = X2_1 + X2_2 + X2_3 + X2_4 + X2_5;
  beta = Y2_1 + Y2_2 + Y2_3 + Y2_4 + Y2_5;
  chi = XxY_1 + XxY_2 + XxY_3 + XxY_4 + XxY_5;
  epsilon = coordinate_X1 + coordinate_X2 + coordinate_X3 + coordinate_X4 + coordinate_X5;
  fi = coordinate_Y1 + coordinate_Y2 + coordinate_Y3 + coordinate_Y4 + coordinate_Y5;
  Kx = XxXd_1 + XxXd_2 + XxXd_3 + XxXd_4 + XxXd_5;
  Ky = XxYd_1 + XxYd_2 + XxYd_3 + XxYd_4 + XxYd_5;
  Lx = YxXd_1 + YxXd_2 + YxXd_3 + YxXd_4 + YxXd_5;
  Ly = YxYd_1 + YxYd_2 + YxYd_3 + YxYd_4 + YxYd_5;
  Mx = Xd1 + Xd2 + Xd3 + Xd4 + Xd5;
  My = Yd1 + Yd2 + Yd3 + Yd4 + Yd5;

  d = 5 * ( ((double)alfa * beta) - ((double)chi * chi) ) + 2 * ((double)chi * epsilon * fi) - ((double)alfa * fi * fi ) - ( (double)beta * epsilon * epsilon );
  dx1 = 5 * ( ((double)Kx * beta) - ((double)Lx * chi) ) + ((double)fi * ( ((double)Lx * epsilon) - ((double)Kx * fi) )) + ((double)Mx * ( ((double)chi * fi) - ((double)beta * epsilon) ));
  dx2 = 5 * ( ((double)Lx * alfa) - ((double)Kx * chi) ) + ((double)epsilon * ( ((double)Kx * fi) - ((double)Lx * epsilon) )) + ((double)Mx * ( ((double)chi * epsilon) - ((double)alfa * fi) ));
  dx3 = ((double)Kx * ( ((double)chi * fi) - ((double)beta * epsilon) )) + ((double)Lx * ( ((double)chi * epsilon) - ((double)alfa * fi) )) + ((double)Mx * ( ((double)alfa * beta) - ((double)chi * chi) ));
  dy1 = 5 * ( ((double)Ky * beta) - ((double)Ly * chi) ) + ((double)fi * ( ((double)Ly * epsilon) - ((double)Ky * fi) )) + ((double)My * ( ((double)chi * fi) - ((double)beta * epsilon) ));
  dy2 = 5 * ( ((double)Ly * alfa) - ((double)Ky * chi) ) + ((double)epsilon * ( ((double)Ky * fi) - ((double)Ly * epsilon) )) + ((double)My * ( ((double)chi * epsilon) - ((double)alfa * fi) ));
  dy3 = ((double)Ky * ( ((double)chi * fi) - ((double)beta * epsilon) )) + ((double)Ly * ( ((double)chi * epsilon) - ((double)alfa * fi) )) + ((double)My * ( ((double)alfa * beta) - ((double)chi * chi) ));

  A = dx1 / d;
  B = dx2 / d;
  C = dx3 / d;
  D = dy1 / d;
  E = dy2 / d;
  F = dy3 / d;

  /* To avoid computation with "double" variables A, B, C, D, E, F, we use the s32 variables
     A2, B2, C2, D2, E2, F2, multiplied for a Scale Factor equal to 100000 to retain the precision*/
  Touchscreen.A2 = (int32_t)(A * RESCALE_FACTOR);
  Touchscreen.B2 = (int32_t)(B * RESCALE_FACTOR);
  Touchscreen.C2 = (int32_t)(C * RESCALE_FACTOR);
  Touchscreen.D2 = (int32_t)(D * RESCALE_FACTOR);
  Touchscreen.E2 = (int32_t)(E * RESCALE_FACTOR);
  Touchscreen.F2 = (int32_t)(F * RESCALE_FACTOR);
}
/*===========================================================================================================*/
void TS_Calib2point	(void)
{
	uint16_t x1,x2,x3,x4,y1,y2,y3,y4, x1m, x2m, y1m,y2m;
	
if (Touchscreen.CALIB_FLAG==0)
	{		
	FULL_ON(WHITE);
  TFT_DrawFilledCircleMy (6,6, 5, BLACK ); /* Absolute Central Point */
	while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	DelayUS(1000);
	x1=Touchscreen.Xpos;
	y1=Touchscreen.Ypos;
	TFT_DrawFilledCircleMy (6, 272-6, 5, BLACK ); /* Absolute Central Point */
	while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	DelayUS(1000/*0000*/);
	x2=Touchscreen.Xpos;
	y2=Touchscreen.Ypos;
	//**************//
	x1m=(x1+x2)/2;
	//*************//
  TFT_DrawFilledCircleMy (480-6,6, 5, BLACK ); /* Absolute Central Point */
	while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	DelayUS(1000);
	x3=Touchscreen.Xpos;
	y3=Touchscreen.Ypos;
	//**********//
	y1m=(y3+y1)/2;
	//**********//
	TFT_DrawFilledCircleMy (480-6, 272-6, 5, BLACK ); /* Absolute Central Point */
	while (Touchscreen.TOUCH==0);
  Touchscreen.TOUCH=0;
	DelayUS(1000);
	x4=Touchscreen.Xpos;
	y4=Touchscreen.Ypos;
	//*****//
	x2m=(x3+x4)/2;
	y2m=(y2+y4)/2;
	//*****//
	
	Touchscreen.K_X=(x2m-x1m)/(480);
	Touchscreen.B_X=(480*x1m)/(480);
	Touchscreen.K_Y=(y2m-y1m)/272;
	Touchscreen.B_Y=(272*y1m)/272;
	
	Touchscreen.CALIB_FLAG=1;
	}
}
