#include "stm32f10x.h"
#include "SPI.h"
#include "MySSD1963.h"
#include "GraphObjects.h"

//Definitions
#define		NO_CALIB				0
#define		CALIBRATED			1
#define 	RESCALE_FACTOR 	1000000
#define		TS_K_X					-0.08
#define		TS_B_X					301
#define		TS_K_Y					-0.12
#define   TS_B_Y					506
//Global data
typedef struct
{
	float Xpos;
	float Ypos;
	float A2;
	float	B2;
	float C2;
	float D2;
	float E2;
	float	F2;
	
	float 		K_X;
	float			B_X;
	float 		K_Y;
	float			B_Y;
	
	uint8_t TOUCH;
	uint8_t CALIB_FLAG;
}
TOUCHSCREEN_DATA; 
extern TOUCHSCREEN_DATA	Touchscreen;

//Functions
void 			getDisplayCoordinateX	(uint16_t x_touch, uint16_t y_touch);
void 			getDisplayCoordinateY	(uint16_t x_touch, uint16_t y_touch);
void			TS_Calibration		(void);
void 			TS_Calib2point		(void);
void			GetX							(void);
void			GetY							(void);




