#include	"TouchInterface.h"
#include 	"SPI.h"
#include 	"stdlib.h"
#include 	"stdio.h"
#include 	"string.h"
#include	"PanelDefinitions.h"
/*=========================================================================*/
void	KeyPressed			(uint8_t i)
{
	static uint8_t	ind, font;
	uint8_t	num, num1;
		
	ind=strlen(Keyboard.RetVal);
	TFT_Log(10, Keyboard.y-Keyboard.CaptionFont->Height-6+(Keyboard.height-Keyboard.CaptionFont->Height)/2,Keyboard.RetVal,WHITE,BLACK,&ARIAL24pt);
	if (ind<(STRING_LENGHT-1))
			{
				switch	(Keyboard.Type)
					{
						case RUSSIAN:	{num=33; num1=11;}	break;
						case ENGLISH: {num=28; num1=10;} 	break;
						case DIGIT:		{num=28; num1=10;}	break;
						default:							break;
					}
	
				if ((i<num)||(i==num+2))
					{
						if (i==num+2)
								Keyboard.RetVal[ind++]=(uint8_t)" ";
								else
										Keyboard.RetVal[ind++]=Keyboard.CaptionString[i];
						TFT_Log(10, Keyboard.y-Keyboard.CaptionFont->Height-6+(Keyboard.height-Keyboard.CaptionFont->Height)/2,Keyboard.RetVal,WHITE,BLACK,&ARIAL24pt);
					}
						else
									if (i==num)
											{
												if (font==FONT_BIG)
														font=FONT_SMALL;
														else
																font=FONT_BIG;
											}	
									else if (i==num+1)	
													{
														Keyboard.Type=DIGIT;
														ShowKeyboard();
													}	
									else if (i==num+3)
													{
														if (Keyboard.Type==ENGLISH)
																Keyboard.Type=RUSSIAN;
																else
																		Keyboard.Type=ENGLISH;
														ShowKeyboard();
													} 
									else if (i==num+4)	
													{
														if (ind)
															{
																Keyboard.RetVal[--ind]=0;
																TFT_DrawRoundRectFilled	(Keyboard.x+3, (num1)*Keyboard.width-8,Keyboard.y-Keyboard.CaptionFont->Height-6+3, Keyboard.height-8, 0,WHITE);
																TFT_Log(10, Keyboard.y-Keyboard.CaptionFont->Height-6+(Keyboard.height-Keyboard.CaptionFont->Height)/2,Keyboard.RetVal,WHITE,BLACK,&ARIAL24pt);
															}
													}
									else if(i==num+5)
												{
													Keyboard.State=NOT_PROCESSING;
												} 
				}
}
/*=========================================================================*/
void	KeyBoardProcess	(void)
{
	uint8_t 	i, num,num1,num2,num3;
	uint16_t	x1=Keyboard.x,y1=Keyboard.y, width;
	
	while	(Keyboard.State==PROCESSING)
				{
					switch	(Keyboard.Type){
												case RUSSIAN:{
																			num=33;
																			num1=10;
																			num2=21;
																			num3=32;
																		 }	break;
												case	ENGLISH:
																			{
																				num=28;
																				num1=9;
																				num2=19;
																				num3=27;
																			}	break;
												case	DIGIT:
																			{
			 																	num=28;
																				num1=9;
																				num2=19;
																				num3=27;
																			} break;
																			default: break;
													}
					
					x1=Keyboard.x;
					y1=Keyboard.y;
					if (Touchscreen.TOUCH)
							{
								Touchscreen.TOUCH=0;		
								for (i=0; i<num;i++)
										{
											if (IfPressed(x1,x1+Keyboard.width,y1,y1+Keyboard.height))
													{
														KeyPressed(i);
														break;
													}
											
											if ((i==num1)||(i==num2)||(i==num3))
													{
														x1=Keyboard.x;
														y1=y1+Keyboard.height;
													}
													else
															x1=x1+Keyboard.width;
										}
								x1=x1=Keyboard.x;
								y1=Keyboard.y+3*Keyboard.height;		
								if(Keyboard.Type==RUSSIAN)
											{
												for (i=0;i<6;i++)
														{
															if ((i==0)||(i==1)||(i==3)||(i==4))
																	width=Keyboard.width;
																	else if (i==2)
																					width=5*Keyboard.width;
																					else if (i==5)
																										width=2*Keyboard.width;
										
															if (IfPressed(x1,x1+width, y1,y1+Keyboard.height))
																	KeyPressed(num+i);
															x1=x1+width;
														}
											}		
											else
													{
														for (i=0;i<6;i++)
																{
																	if ((i==0)||(i==1)||(i==3)||(i==4))
																			width=Keyboard.width;
																	else if (i==2)
																					width=6*Keyboard.width;
																					else if (i==5)
																									{
																										x1=Keyboard.x+8*Keyboard.width;
																										y1=Keyboard.y+2*Keyboard.height;
																										width=2*Keyboard.width;
																									}
																if (IfPressed(x1,x1+width, y1,y1+Keyboard.height))
																		KeyPressed(num+i);
																if (i<6)
																		x1=x1+width;
																}
													}
								}
			}
}
/*=========================================================================*/
uint8_t	PageControlProcess		(void)
{
	if (Touchscreen.Ypos<=PageControl.y+PageControl.height)
		{
			if (Touchscreen.Xpos<PageControl.ControlPages[1].x)
				PageControl.ActivePage=CONTROL_PAGE;
				else if (Touchscreen.Xpos<PageControl.ControlPages[2].x)
						PageControl.ActivePage=CONFIG_PAGE;
						else if (Touchscreen.Xpos<PageControl.ControlPages[3].x)
								PageControl.ActivePage=CALIBRATE_PAGE1;
								else if	(Touchscreen.Xpos<PageControl.ControlPages[4].x)
										PageControl.ActivePage=SETTINGS_PAGE;
										else PageControl.ActivePage=ADDITIONAL_PAGE; 
			ShowPage();
		}
		else return 0;
return 1;
}
/*=========================================================================*/
void	TouchInterface	(void)
{
	Touchscreen.TOUCH=0;
	if (!PageControlProcess())
			switch(PageControl.ActivePage)
				{
					case	CONTROL_PAGE:			ControlPageProcessing();				break;
					case	CONFIG_PAGE: 			ConfigPageProcessing();					break;
					case	CALIBRATE_PAGE1:  CalibrationPageProcessing(1);		break;
					case	CALIBRATE_PAGE2:	CalibrationPageProcessing(2);		break;
					case	CALIBRATE_PAGE3:	CalibrationPageProcessing(3);		break;
					case	CALIBRATE_PAGE4:	CalibrationPageProcessing(4);		break;	
					case	ADDITIONAL_PAGE:	AdditionalPageProcessing();			break;
				}
}			
/*=========================================================================*/	
char	IfPressed	(uint16_t x1, uint16_t x2, uint16_t y1, uint16_t y2)
{
	if ((Touchscreen.Xpos>=x1)&&(Touchscreen.Xpos<=x2)&&(Touchscreen.Ypos>=y1)&&(Touchscreen.Ypos<=y2))
			return PRESSED;
			else 
					return NO_PRESSED;
}
/*=========================================================================*/
void	ButtonPressed	(BUTTON*	Button)
{
	uint16_t	clr=Button->Color;
	Button->Color=BLUE;
	TFT_DrawButton(Button);
	DelayUS(100000);
	Button->Color=clr;
	TFT_DrawButton(Button);
}
/*=========================================================================*/
void	ButtonImagePressed	(BUTTON* Btn)
{
	uint16_t	clr=Btn->Color;
	Btn->Color=BLUE;
	TFT_DrawBmpImg(Btn->x,Btn->width,Btn->y,Btn->height,Btn->CaptionColor,Btn->Color,Btn->Image);
	DelayUS(100000);
	Btn->Color=clr;
	TFT_DrawBmpImg(Btn->x,Btn->width,Btn->y,Btn->height,Btn->CaptionColor,Btn->Color,Btn->Image);
}
/*=========================================================================*/
void	TumblerPressed	(TUMBLER*	Tumbler)
{
	if (Tumbler->State==OFF)
			{
				Tumbler->State=ON;
				Tumbler->img=TumblerImgOn;										
			}
			else
					{
							Tumbler->State=OFF;
							Tumbler->img=TumblerImgOff;										
					}
ShowTumbler(Tumbler,ControlPage.BackColor);
}
/*=========================================================================*/
void	RadioBtnPressed	(RADIO_BUTTON*	RBtn,uint8_t index)
{
	uint8_t i;
	
	RBtn[index].State=ON;
	for (i=0;i<5;i++)
			{
				if (i!=index)
						RBtn[i].State=OFF;
			}
	ShowRadioBtn(RBtn,ControlPage.BackColor);
}
/*=========================================================================*/
void	InjectLedsPressed(CIRCLE*	Leds, uint8_t index)
{
	if (Leds[index].color==RED1)
			Leds[index].color=0xC600;
			else
					Leds[index].color=RED1;
	ShowLed(&Leds[index]);
	TFT_Log(Leds[index].x-(Leds[index].CaptionWdth/2),Leds[index].y-Leds[index].R+2,Leds[index].Caption,Leds[index].color,Leds[index].CaptionColor,&ARIAL9pt);
}
/*=========================================================================*/
void	ControlPageProcessing	(void)
{
uint8_t i;
	
	if (IfPressed(ControlPage.ModeButton.x-10,ControlPage.ModeButton.x+ControlPage.ModeButton.width+5,ControlPage.ModeButton.y-10,ControlPage.ModeButton.y+ControlPage.ModeButton.height+10))
			{
				if (Controls.TCMode==AUTO_MODE)
					{
						Controls.TCMode=HAND_MODE;
						ControlPage.ModeButton.Caption="HAND";
					}
					else
							{
								Controls.TCMode=AUTO_MODE;
								ControlPage.ModeButton.Caption="AUTO";
							}
			   ButtonPressed(&ControlPage.ModeButton);
			}
  else if (IfPressed(ControlPage.HeatingTmb.x-10,ControlPage.HeatingTmb.x+ControlPage.HeatingTmb.width+5,ControlPage.HeatingTmb.y-10,ControlPage.HeatingTmb.y+ControlPage.HeatingTmb.height+2))
					{
						TumblerPressed(&ControlPage.HeatingTmb);
						Controls.HeatingManual=ControlPage.HeatingTmb.State;
					}
	else if (IfPressed(ControlPage.BackBitumTmb.x-10,ControlPage.BackBitumTmb.x+ControlPage.BackBitumTmb.width+5,ControlPage.BackBitumTmb.y-10,ControlPage.BackBitumTmb.y+ControlPage.BackBitumTmb.height+2))
					{
						TumblerPressed(&ControlPage.BackBitumTmb);
						Controls.BitumenBackValve=ControlPage.BackBitumTmb.State;
					}
	else if(IfPressed(0,ControlPage.InjectTmb[4].x+5*ControlPage.InjectTmb[4].R,ControlPage.InjectTmb[0].y-ControlPage.InjectTmb[0].R-16,ControlPage.InjectTmb[4].y+ControlPage.InjectTmb[4].R+5))
					{		
						for (i=0;i<5;i++)
							{	
								if (IfPressed(ControlPage.InjectTmb[i].x-ControlPage.InjectTmb[i].R-5,ControlPage.InjectTmb[i].x+5*ControlPage.InjectTmb[i].R,ControlPage.InjectTmb[i].y-ControlPage.InjectTmb[i].R-16,ControlPage.InjectTmb[i].y+ControlPage.InjectTmb[i].R+5))
										{
											RadioBtnPressed(ControlPage.InjectTmb,i);
											InjectSwitch(i,ControlPage.InjectLeds,&Controls.Injects);
											ShowInjectLeds(ControlPage.InjectLeds);
											break;
										}
							}
					}
	else if	(IfPressed(ControlPage.InjectLeds[0].x-ControlPage.InjectLeds[0].R-1,ControlPage.InjectLeds[27].x+ControlPage.InjectLeds[27].R+1,ControlPage.InjectLeds[0].y-ControlPage.InjectLeds[0].R-6,ControlPage.InjectLeds[27].y+ControlPage.InjectLeds[27].R+6))
					{		
						for (i=0;i<28;i++)
							{	
								if (IfPressed(ControlPage.InjectLeds[i].x-ControlPage.InjectLeds[i].R-1,ControlPage.InjectLeds[i].x+ControlPage.InjectLeds[i].R+1,ControlPage.InjectLeds[i].y-ControlPage.InjectLeds[i].R-6,ControlPage.InjectLeds[i].y+ControlPage.InjectLeds[i].R+6))
									{
										InjectLedsPressed(ControlPage.InjectLeds,i);
										if (ControlPage.InjectLeds[i].color==RED1)
													Controls.Injects|=1<<i;
													else
														Controls.Injects&=~(1<<i);
									}
							}
					}
	else if (IfPressed(ControlPage.PumpSpeedControl.x+ControlPage.PumpSpeedControl.width-10,ControlPage.PumpSpeedControl.x+ControlPage.PumpSpeedControl.width+20,ControlPage.PumpSpeedControl.y-10,ControlPage.PumpSpeedControl.y+ControlPage.PumpSpeedControl.height/2))
					{
						if (ControlPage.PumpSpeedControl.Value<ControlPage.PumpSpeedControl.MaxValue)
							{
								ControlPage.PumpSpeedControl.Value++;
								Controls.PumpSpeedManual=ControlPage.PumpSpeedControl.Value;
								ShowIncDecEditBox(&ControlPage.PumpSpeedControl);
							}
					}
	else if (IfPressed(ControlPage.PumpSpeedControl.x+ControlPage.PumpSpeedControl.width-10,ControlPage.PumpSpeedControl.x+ControlPage.PumpSpeedControl.width+20,ControlPage.PumpSpeedControl.y+ControlPage.PumpSpeedControl.height/2,ControlPage.PumpSpeedControl.y+ControlPage.PumpSpeedControl.height+10))
						{	
						 if (ControlPage.PumpSpeedControl.Value>ControlPage.PumpSpeedControl.MinValue)
							{
								ControlPage.PumpSpeedControl.Value--;
								Controls.PumpSpeedManual=ControlPage.PumpSpeedControl.Value;
								ShowIncDecEditBox(&ControlPage.PumpSpeedControl);
							}
						}
}
/*=========================================================================*/
void	InjectSwitch	(uint8_t i,CIRCLE* Inject,uint32_t* InjectCng)
{
	switch (i){
							case	ALL_INJECTS:		{
																			*InjectCng=0xfffffff;
																			for(i=0;i<NUM_INJECTS;i++)
																					Inject[i].color=RED1;
																		}	break;
							case	LEFT_GROUP:			{
																			*InjectCng=0xff80000;
																			for (i=0;i<NUM_INJECTS;i++)
																					if (i>18)
																					Inject[i].color=RED1;
																					else
																							Inject[i].color=0xC600;
																		} break;
							case	CENTRAL_GROUP:	{
																			*InjectCng=0x7fe00;
																			for (i=0;i<NUM_INJECTS;i++)
																					if ((i>8) &&(i<19))
																					Inject[i].color=RED1;
																					else
																						Inject[i].color=0xC600;
																		} break;
						  case	RIGHT_GROUP:		{
																			*InjectCng=0x1ff;
																			for(i=0;i<NUM_INJECTS;i++)
																					if (i<9)
																					Inject[i].color=RED1;
																					else
																							Inject[i].color=0xC600;
																		}		break;
						}
}
/*=========================================================================*/
void	WriteTCParamtoSystemBoard	(uint8_t i, float value)
{
	switch(i){
						case	MIN_TEMP:				SystemBoardConfig.MinBitumTemp=value;				break;
						case	MAX_TEMP:				SystemBoardConfig.MaxBitumTemp=value;				break;
						case	MIN_BURN_TEMP:	SystemBoardConfig.MinBurnTemperature=value;	break;
						case	MAX_BURN_TEMP: 	SystemBoardConfig.MaxBurnTemperature=value;	break;
						case	MIN_LEVEL:			SystemBoardConfig.MinBitumLevel=value;			break;
						case	MAX_LEVEL:			SystemBoardConfig.MaxBitumLevel=value;			break;
						case	MIN_AUTO_SPEED:	SystemBoardConfig.MinAutoSpeed=value;				break;
						case	MAX_AUTO_SPEED:	SystemBoardConfig.MaxAutoSpeed=value;				break;
						case	INJ_WIDTH:			Actuators.Injects.InjectWidth=value/100.0;  break;
						case	VOLUME_RATE:		SystemBoardConfig.VolumeRate=value;					break;
						case	G_FREQ_RATE:		Actuators.Pump.PumpSpeedRate=value;					break;
						case	PROD_RATE:			Actuators.Pump.PumpProdRate=value;					break;
						default:	break;
						}
}
/*=========================================================================*/
void			WriteReceiptParams		(void)
{
SystemBoardConfig.Receipt.nReceipt=ConfigPage.ReceiptBox.ItemIndex;
SystemBoardConfig.Receipt.nFillingRate=TCReceipts.FRate[ConfigPage.ReceiptBox.ItemIndex];
SystemBoardConfig.Receipt.Material=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]>>4;
SystemBoardConfig.Receipt.Unit=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]&0x0f;
SystemBoardConfig.Receipt.InjectConfig=TCReceipts.RecInjectConfig[ConfigPage.ReceiptBox.ItemIndex];
}
/*=========================================================================*/
void			ConfigPageProcessing	(void)
{
	uint8_t  i,flag=0;
	uint16_t width;
	uint8_t N;
	float	FWidth,InjWidth;
	uint8_t		str[STRING_LENGHT];
	
	
	if (IfPressed(ConfigPage.TCParams[MIN_TEMP].x-5,ConfigPage.TCParams[PROD_RATE].x+ConfigPage.TCParams[PROD_RATE].width,ConfigPage.TCParams[MIN_TEMP].y-10,ConfigPage.TCParams[PROD_RATE].y+ConfigPage.TCParams[PROD_RATE].height+5))
		{
				for (i=0; i<12;i++)
						{
							if (IfPressed(ConfigPage.TCParams[i].x-5,ConfigPage.TCParams[i].x+ConfigPage.TCParams[i].width+10,ConfigPage.TCParams[i].y-ConfigPage.TCParams[i].CaptionFont->Height,ConfigPage.TCParams[i].y+ConfigPage.TCParams[i].height))
									{
										Keyboard.Type=DIGIT;
										memset(Keyboard.RetVal,0,STRING_LENGHT);
										ShowKeyboard();
										KeyBoardProcess();
										if (ConfigPage.TCParams[i].Value)
											{
												memset(ConfigPage.TCParams[i].Value,0,6);
												strncpy(ConfigPage.TCParams[i].Value,Keyboard.RetVal,5);
											}
										//WriteTCParamtoSystemBoard(i,atof(ConfigPage.TCParams[i].Value));	
										if ((i==INJ_WIDTH)&&(ConfigPage.TCParams[INJ_WIDTH].Value))
											{
												InjWidth=atof(ConfigPage.TCParams[INJ_WIDTH].Value);
												N=NumInjects(ConfigPage.ReceiptBox.RInjectConfig);
												FWidth=InjWidth*N;
												memset(str,0,STRING_LENGHT);
												sprintf(str,"%.3f",FWidth);
												memset(ConfigPage.ReceiptBox.FWidth.Value,0,5);
												strncpy(ConfigPage.ReceiptBox.FWidth.Value,str,4);
											}
										ShowConfigPage();
										break;
									}
						}
			flag=1;
		}
	else {
				if (IfPressed(ConfigPage.ReceiptBox.RName.x-5,ConfigPage.SetRecButton.x,ConfigPage.RecLabel.y,ConfigPage.ReceiptBox.RName.y+ConfigPage.ReceiptBox.RName.height+5))
						{
							ShowAddListWnd(ConfigPage.ReceiptBox.RName.x,ConfigPage.ReceiptBox.RName.y+ConfigPage.ReceiptBox.RName.height-(TCReceipts.NReceipts+1)*(ConfigPage.ReceiptBox.RName.height),ConfigPage.ReceiptBox.RName.height,TCReceipts.ReceiptName,ConfigPage.ReceiptBox.RName.Value,&TCReceipts.NReceipts,&ConfigPage.ReceiptBox.ItemIndex,MAX_RECEIPT);
							ShowConfigPage();
							flag=1;
						}
					 else if (IfPressed(ConfigPage.ReceiptBox.Material.x,ConfigPage.ReceiptBox.Unit.x-1,ConfigPage.RecLabel.y,ConfigPage.ReceiptBox.Material.y+ConfigPage.ReceiptBox.Material.height+5))
								{
									i=ShowListWnd(ConfigPage.ReceiptBox.Material.x,ConfigPage.ReceiptBox.Material.y-ConfigPage.ReceiptBox.Material.height,100,2*ConfigPage.ReceiptBox.Material.height,BLACK, 0xC600, MaterialTypes, 2, ConfigPage.ReceiptBox.Material.Value,8,&ConfigPage.ReceiptBox.Material.ItemIndex,6);
									TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]&0x0f;
									if (i)
												TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]|(1<<4);
								ShowConfigPage();
								flag=1;
								}
					 else if (IfPressed(ConfigPage.ReceiptBox.Unit.x,ConfigPage.ReceiptBox.FRate.x-1,ConfigPage.RecLabel.y,ConfigPage.ReceiptBox.Unit.y+ConfigPage.ReceiptBox.Unit.height+5))
									{
									i=ShowListWnd(ConfigPage.ReceiptBox.Unit.x,ConfigPage.ReceiptBox.Unit.y-ConfigPage.ReceiptBox.Unit.height, 100, 2*ConfigPage.ReceiptBox.Unit.height,BLACK, 0xC600, UnitTypes, 2, ConfigPage.ReceiptBox.Unit.Value, 6,&ConfigPage.ReceiptBox.Unit.ItemIndex,6);
									TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]&0xf0;
									if (i)
											TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]=TCReceipts.MatUnit[ConfigPage.ReceiptBox.ItemIndex]|1;
									ShowConfigPage();
									flag=1;
									}
					 else if (IfPressed(ConfigPage.ReceiptBox.FRate.x,ConfigPage.ReceiptBox.FWidth.x-1,ConfigPage.RecLabel.y,ConfigPage.ReceiptBox.FRate.y+ConfigPage.ReceiptBox.FRate.height+5))
														{
															Keyboard.Type=DIGIT;
															ShowKeyboard();	
															KeyBoardProcess();
															TCReceipts.FRate[ConfigPage.ReceiptBox.ItemIndex]=atof(Keyboard.RetVal);
															if	(ConfigPage.ReceiptBox.FRate.Value)
																	strncpy(ConfigPage.ReceiptBox.FRate.Value,Keyboard.RetVal,6);
															ShowConfigPage();
															flag=1;
														}
				}
	if (!flag){
	if (IfPressed(ConfigPage.SaveRecButton.x-5, ConfigPage.SaveRecButton.x+ConfigPage.SaveRecButton.width+5,ConfigPage.SaveRecButton.y-10,ConfigPage.SaveRecButton.y+ConfigPage.SaveRecButton.height))
					{
						ButtonImagePressed(&ConfigPage.SaveRecButton);
						WriteReceiptParams();
						CommandCode=SAVE_RECEIPT;
					}
	else if (IfPressed(ConfigPage.DelRecButton.x, ConfigPage.DelRecButton.x+ConfigPage.DelRecButton.width+5,ConfigPage.DelRecButton.y-10,ConfigPage.DelRecButton.y+ConfigPage.DelRecButton.height))
					{
						ButtonImagePressed(&ConfigPage.DelRecButton);
						SystemBoardConfig.Receipt.nReceipt=ConfigPage.ReceiptBox.ItemIndex;
						CommandCode=DELETE_RECEIPT;
					}
	else if (IfPressed(ConfigPage.SetRecButton.x, ConfigPage.SetRecButton.x+ConfigPage.SetRecButton.width+15,ConfigPage.SetRecButton.y-10,ConfigPage.SetRecButton.y+ConfigPage.SetRecButton.height))
					{
						ButtonImagePressed(&ConfigPage.SetRecButton);
						WriteReceiptParams();
						CommandCode=SET_RECEIPT;
					}
	else if (IfPressed(ConfigPage.DelAllRecButton.x, ConfigPage.DelAllRecButton.x+ConfigPage.DelAllRecButton.width+5,ConfigPage.DelAllRecButton.y-10,ConfigPage.DelAllRecButton.y+ConfigPage.DelAllRecButton.height))
					{
						ButtonImagePressed(&ConfigPage.DelAllRecButton);
						WriteReceiptParams();
						CommandCode=DELETE_ALL_RECEIPTS;
					}
	else if (IfPressed(ConfigPage.SaveTCButton.x-5,ConfigPage.SaveTCButton.x+ConfigPage.SaveTCButton.width+5,ConfigPage.SaveTCButton.y-5,ConfigPage.SaveTCButton.y+5))
					{
						ButtonPressed(&ConfigPage.SaveTCButton);
						WriteTCParamtoSystemBoard(i,atof(ConfigPage.TCParams[i].Value));
						CommandCode=UPDATE_TC_SETTINGS;
					}
	else if (IfPressed(ConfigPage.RInjectTmb[0].x-ConfigPage.RInjectTmb[0].R-20,ConfigPage.RInjectTmb[1].x+ConfigPage.RInjectTmb[1].R+20,ConfigPage.RInjectTmb[0].y-ConfigPage.RInjectTmb[0].R-10,ConfigPage.RInjectTmb[4].y+ConfigPage.RInjectTmb[4].R+10))
					{
						for (i=0; i<5;i++)
								{
									if (IfPressed(ConfigPage.RInjectTmb[i].x-ConfigPage.RInjectTmb[i].R-10,ConfigPage.RInjectTmb[i].x+ConfigPage.RInjectTmb[i].R+10,ConfigPage.RInjectTmb[i].y-ConfigPage.RInjectTmb[i].R-ConfigPage.RInjectTmb[i].CaptionFont->Height-5,ConfigPage.RInjectTmb[i].y+ConfigPage.RInjectTmb[i].R+5))
										{
											RadioBtnPressed(ConfigPage.RInjectTmb,i);
											InjectSwitch(i,ConfigPage.ReceiptBox.RInjectLeds,&ConfigPage.ReceiptBox.RInjectConfig);
											if (ConfigPage.ReceiptBox.FWidth.Value)
												{
													InjWidth=atof(ConfigPage.TCParams[INJ_WIDTH].Value);
													N=NumInjects(ConfigPage.ReceiptBox.RInjectConfig);
													FWidth=InjWidth*N;
													memset(str,0,STRING_LENGHT);
													sprintf(str,"%.3f",FWidth);
													memset(ConfigPage.ReceiptBox.FWidth.Value,0,5);
													strncpy(ConfigPage.ReceiptBox.FWidth.Value,str,4);
												}
											ShowEditBox(&ConfigPage.ReceiptBox.FWidth);
											ShowInjectLeds(ConfigPage.ReceiptBox.RInjectLeds);
											SystemBoardConfig.Receipt.InjectConfig=TCReceipts.RecInjectConfig[ConfigPage.ReceiptBox.ItemIndex];;
										}
								}
					}
	else if	(IfPressed(ConfigPage.ReceiptBox.RInjectLeds[0].x-ConfigPage.ReceiptBox.RInjectLeds[0].R-1,ConfigPage.ReceiptBox.RInjectLeds[27].x+ConfigPage.ReceiptBox.RInjectLeds[27].R+1,ConfigPage.ReceiptBox.RInjectLeds[0].y-ConfigPage.ReceiptBox.RInjectLeds[0].R-6,ConfigPage.ReceiptBox.RInjectLeds[27].y+ConfigPage.ReceiptBox.RInjectLeds[27].R+6))
					{		
						for (i=0;i<NUM_INJECTS;i++)
							{	
								if (IfPressed(ConfigPage.ReceiptBox.RInjectLeds[i].x-ConfigPage.ReceiptBox.RInjectLeds[i].R-1,ConfigPage.ReceiptBox.RInjectLeds[i].x+ConfigPage.ReceiptBox.RInjectLeds[i].R+1,ConfigPage.ReceiptBox.RInjectLeds[i].y-ConfigPage.ReceiptBox.RInjectLeds[i].R-6,ConfigPage.ReceiptBox.RInjectLeds[i].y+ConfigPage.ReceiptBox.RInjectLeds[i].R+6))
										{
											InjectLedsPressed(ConfigPage.ReceiptBox.RInjectLeds,i);
											if (ConfigPage.ReceiptBox.RInjectLeds[i].color==RED1)
													ConfigPage.ReceiptBox.RInjectConfig|=1<<i;
													else
														ConfigPage.ReceiptBox.RInjectConfig&=~(1<<i);
											if (ConfigPage.ReceiptBox.FWidth.Value)
												{
													InjWidth=atof(ConfigPage.TCParams[INJ_WIDTH].Value);
													N=NumInjects(ConfigPage.ReceiptBox.RInjectConfig);
													FWidth=InjWidth*N;
													memset(str,0,STRING_LENGHT);
													sprintf(str,"%.3f",FWidth);
													memset(ConfigPage.ReceiptBox.FWidth.Value,0,5);
													strncpy(ConfigPage.ReceiptBox.FWidth.Value,str,4);
												}
											ShowEditBox(&ConfigPage.ReceiptBox.FWidth);
											ShowInjectLeds(ConfigPage.ReceiptBox.RInjectLeds);
											SystemBoardConfig.Receipt.InjectConfig=TCReceipts.RecInjectConfig[ConfigPage.ReceiptBox.ItemIndex];;
											break;
										}
							}
					}
	}
}
/*=========================================================================*/
void	WriteCalibParams	(uint8_t index, float value)
{
	switch	(index)
					{
						case	ADC_CODE1_BOX:	dADC1.ADCCalib.BaseValuePt[0]=value; break;
						case	ADC_CODE2_BOX:	dADC1.ADCCalib.BaseValuePt[1]=value; break;
						case	ADC_VALUE1_BOX:	dADC1.ADCCalib.ConvValuePt[0]=value; break;
						case	ADC_VALUE2_BOX:	dADC1.ADCCalib.ConvValuePt[1]=value; break;
						case	DAC1_CODE1_BOX:	dDAC1.DACCalib.BaseValuePt[0]=value; break;
						case	DAC1_CODE2_BOX:	dDAC1.DACCalib.BaseValuePt[1]=value; break;
						case	DAC1_VALUE1_BOX:dDAC1.DACCalib.ConvValuePt[0]=value; break;
						case	DAC1_VALUE2_BOX:dDAC1.DACCalib.ConvValuePt[1]=value; break;		
						case	DAC2_CODE1_BOX:	dDAC2.DACCalib.BaseValuePt[0]=value; break;	
						case	DAC2_CODE2_BOX:	dDAC2.DACCalib.BaseValuePt[1]=value; break;
						case	DAC2_VALUE1_BOX:dDAC2.DACCalib.ConvValuePt[0]=value; break;	
						case	DAC2_VALUE2_BOX:dDAC2.DACCalib.ConvValuePt[1]=value; break;
						case	SS_FREQ1_BOX:		Sensors.AutoSpeedSensor.Calib.BaseValuePt[0]=value; break;
						case	SS_FREQ2_BOX:		Sensors.AutoSpeedSensor.Calib.BaseValuePt[1]=value; break;
						case	SS_SPEED1_BOX:	Sensors.AutoSpeedSensor.Calib.ConvValuePt[0]=value; break;
						case	SS_SPEED2_BOX:	Sensors.AutoSpeedSensor.Calib.ConvValuePt[1]=value; break;
						case	TS_CUR1_BOX:		Sensors.TempSensor.Calib.BaseValuePt[0]=value;	break;	
						case	TS_CUR2_BOX:		Sensors.TempSensor.Calib.BaseValuePt[1]=value;	break;
						case	TS_TEMP1_BOX:		Sensors.TempSensor.Calib.ConvValuePt[0]=value;	break;
						case	TS_TEMP2_BOX:		Sensors.TempSensor.Calib.ConvValuePt[1]=value;	break;
						case	PS_CUR1_BOX:		Sensors.PumpSpeedSensor.Calib.BaseValuePt[0]=value;	break;
						case	PS_CUR2_BOX:		Sensors.PumpSpeedSensor.Calib.BaseValuePt[1]=value;	break;
						case	PS_SPEED1_BOX:	Sensors.PumpSpeedSensor.Calib.ConvValuePt[0]=value;	break;
						case	PS_SPEED2_BOX:	Sensors.PumpSpeedSensor.Calib.ConvValuePt[1]=value;	break;	
						case	PP_CUR1_BOX:		Sensors.PressureSensor.Calib.BaseValuePt[0]=value;	break;
						case	PP_CUR2_BOX:		Sensors.PressureSensor.Calib.BaseValuePt[1]=value;	break;
						case	PP_PRES1_BOX:		Sensors.PressureSensor.Calib.ConvValuePt[0]=value;	break;
						case	PP_PRES2_BOX:		Sensors.PressureSensor.Calib.ConvValuePt[1]=value;	break;
						case	LS3_CUR1_BOX:		Sensors.LevelSensor3.Calib.BaseValuePt[0]=value;		break;
						case	LS3_CUR2_BOX:		Sensors.LevelSensor3.Calib.BaseValuePt[1]=value;		break;
						case	LS3_LEVEL1_BOX:	Sensors.LevelSensor3.Calib.ConvValuePt[0]=value;		break;
						case	LS3_LEVEL2_BOX:	Sensors.LevelSensor3.Calib.ConvValuePt[1]=value;		break;
						case	LS1_CUR1_BOX:		Sensors.LevelSensor1.Calib.BaseValuePt[0]=value;		break;
						case	LS1_CUR2_BOX:		Sensors.LevelSensor1.Calib.BaseValuePt[1]=value;		break;
						case	LS1_PRES1_BOX:	Sensors.LevelSensor1.Calib.BaseValuePt[2]=value;		break;
						case	LS1_PRES2_BOX:	Sensors.LevelSensor1.Calib.BaseValuePt[3]=value;		break;
						case	LS1_LEVEL1_BOX:	Sensors.LevelSensor1.Calib.ConvValuePt[0]=value;		break;	
						case	LS1_LEVEL2_BOX:	Sensors.LevelSensor1.Calib.ConvValuePt[1]=value;		break;
						case	LS2_CUR1_BOX:		Sensors.LevelSensor2.Calib.BaseValuePt[0]=value;		break;
						case	LS2_CUR2_BOX:		Sensors.LevelSensor2.Calib.BaseValuePt[1]=value;		break;
						case	LS2_PRES1_BOX:	Sensors.LevelSensor2.Calib.BaseValuePt[2]=value;		break;
						case	LS2_PRES2_BOX:	Sensors.LevelSensor2.Calib.BaseValuePt[3]=value;		break;
						case	LS2_LEVEL1_BOX:	Sensors.LevelSensor2.Calib.ConvValuePt[0]=value;		break;
						case	LS2_LEVEL2_BOX:	Sensors.LevelSensor2.Calib.ConvValuePt[1]=value;		break;
						case	PC_VOL1_BOX:		Actuators.Pump.Calib.BaseValuePt[0]=value;		break;
						case	PC_VOL2_BOX:		Actuators.Pump.Calib.BaseValuePt[1]=value;		break;
						case	PC_VOL3_BOX:		Actuators.Pump.Calib.BaseValuePt[2]=value;		break;
						case	PC_VOL4_BOX:		Actuators.Pump.Calib.BaseValuePt[3]=value;		break;
						case	PC_VOL5_BOX:		Actuators.Pump.Calib.BaseValuePt[4]=value;		break;
						case	PC_FREQ1_BOX:		Actuators.Pump.Calib.ConvValuePt[0]=value;		break;
						case	PC_FREQ2_BOX:		Actuators.Pump.Calib.ConvValuePt[1]=value;		break;	
						case	PC_FREQ3_BOX:		Actuators.Pump.Calib.ConvValuePt[2]=value;		break;
						case	PC_FREQ4_BOX:		Actuators.Pump.Calib.ConvValuePt[3]=value;		break;
						case	PC_FREQ5_BOX:		Actuators.Pump.Calib.ConvValuePt[4]=value;		break;
						case	PC_PROD1_BOX:		Actuators.Pump.Calib1.ConvValuePt[0]=value;		break;
						case	PC_PROD2_BOX:		Actuators.Pump.Calib1.ConvValuePt[1]=value;		break;
						case	PC_PROD3_BOX:		Actuators.Pump.Calib1.ConvValuePt[2]=value;		break;
						case	PC_PROD4_BOX:		Actuators.Pump.Calib1.ConvValuePt[3]=value;		break;
						case	PC_PROD5_BOX:		Actuators.Pump.Calib1.ConvValuePt[4]=value;		break;
						default:	break;
					}
}
/*=========================================================================*/		
void			CalibrationPageProcessing			(uint8_t	page)
{
	uint16_t x1, x2, y1, Xstart,Xend, i, flag=0;
	
	switch	(page)
					{
						case	1:	{
													if (IfPressed(CalibrationPage1.NextButton.x-5,CalibrationPage1.NextButton.x+CalibrationPage1.NextButton.width+5,CalibrationPage1.NextButton.y-10,CalibrationPage1.NextButton.y+CalibrationPage1.NextButton.height+10))
															{
																ButtonPressed(&CalibrationPage1.NextButton);
																PageControl.ActivePage=CALIBRATE_PAGE2;
																ShowCalibrationPage2();
																flag=1;
																break;
															}
															
															else if (IfPressed(CalibrationPage1.CalibrateButton.x-5,CalibrationPage1.CalibrateButton.x+CalibrationPage1.CalibrateButton.width+5,CalibrationPage1.CalibrateButton.y-3,CalibrationPage1.CalibrateButton.y+CalibrationPage1.CalibrateButton.height))
																			{
																				ButtonPressed(&CalibrationPage1.CalibrateButton);
																				flag=1;
																				CommandCode=UPDATE_ALL_CALIB;
																				break;
																			}
																			else{
																						flag=0;
																						x1=ADC_CODE1_BOX;
																						x2=DAC1_VALUE1_BOX;
																						y1=DAC2_VALUE2_BOX;
																						Xstart=ADC_CODE1_BOX;
																						Xend=DAC2_VALUE2_BOX;
																					}
											}	break;	
						case	2:	{
													if (IfPressed(CalibrationPage2.NextButton.x-5,CalibrationPage2.NextButton.x+CalibrationPage2.NextButton.width+5,CalibrationPage2.NextButton.y-10,CalibrationPage2.NextButton.y+CalibrationPage2.NextButton.height+10))
															{
																ButtonPressed(&CalibrationPage2.NextButton);
																PageControl.ActivePage=CALIBRATE_PAGE3;
																ShowCalibrationPage3();
																flag=1;
																break;
															}
															else if(IfPressed(CalibrationPage2.PrevButton.x-5,CalibrationPage2.PrevButton.x+CalibrationPage2.PrevButton.width,CalibrationPage2.PrevButton.y-10,CalibrationPage2.PrevButton.y+CalibrationPage2.PrevButton.height+10))
																		{
																			ButtonPressed(&CalibrationPage2.PrevButton);
																			PageControl.ActivePage=CALIBRATE_PAGE1;
																			ShowCalibrationPage1();
																			flag=1;
																			break;
																		}
															else if (IfPressed(CalibrationPage2.CalibrateButton->x-5,CalibrationPage2.CalibrateButton->x+CalibrationPage2.CalibrateButton->width+5,CalibrationPage2.CalibrateButton->y-3,CalibrationPage2.CalibrateButton->y+CalibrationPage2.CalibrateButton->height))
																			{
																				ButtonPressed(CalibrationPage2.CalibrateButton);
																				flag=1;
																				CommandCode=UPDATE_ALL_CALIB;
																				break;
																			}
																			else{
																						flag=0;
																						x1=PS_CUR1_BOX;
																						x2=PP_PRES1_BOX;
																						y1=LS3_LEVEL2_BOX;
																						Xstart=PS_CUR1_BOX;
																						Xend=LS3_LEVEL2_BOX;
																					}
											}	break;
						case	3:	{
													
													if (IfPressed(CalibrationPage3.NextButton.x-5,CalibrationPage3.NextButton.x+CalibrationPage3.NextButton.width+5,CalibrationPage3.NextButton.y-10,CalibrationPage3.NextButton.y+CalibrationPage3.NextButton.height+10))
															{
																ButtonPressed(&CalibrationPage3.NextButton);
																PageControl.ActivePage=CALIBRATE_PAGE4;
																ShowCalibrationPage4();
																flag=1;
																break;
															}
															else if(IfPressed(CalibrationPage3.PrevButton.x-5,CalibrationPage3.PrevButton.x+CalibrationPage3.PrevButton.width,CalibrationPage3.PrevButton.y-10,CalibrationPage3.PrevButton.y+CalibrationPage3.PrevButton.height+10))
																		{
																			ButtonPressed(&CalibrationPage3.PrevButton);
																			PageControl.ActivePage=CALIBRATE_PAGE2;
																			ShowCalibrationPage2();
																			flag=1;
																			break;
																		}
															else if (IfPressed(CalibrationPage3.CalibrateButton->x-5,CalibrationPage3.CalibrateButton->x+CalibrationPage3.CalibrateButton->width+5,CalibrationPage3.CalibrateButton->y-3,CalibrationPage3.CalibrateButton->y+CalibrationPage3.CalibrateButton->height))
																			{
																				ButtonPressed(CalibrationPage3.CalibrateButton);
																				flag=1;
																				CommandCode=UPDATE_ALL_CALIB;
																				break;
																			}
																			else{
																						flag=0;
																						x1=LS1_CUR1_BOX;
																						x2=LS1_LEVEL1_BOX;
																						y1=LS2_LEVEL2_BOX;
																						Xstart=LS1_CUR1_BOX;
																						Xend=LS2_LEVEL2_BOX;
																					}
											}	break;
						case	4:	{
													if(IfPressed(CalibrationPage4.PrevButton.x-5,CalibrationPage4.PrevButton.x+CalibrationPage4.PrevButton.width,CalibrationPage4.PrevButton.y-10,CalibrationPage4.PrevButton.y+CalibrationPage4.PrevButton.height+10))
																		{
																			ButtonPressed(&CalibrationPage4.PrevButton);
																			PageControl.ActivePage=CALIBRATE_PAGE3;
																			ShowCalibrationPage3();
																			flag=1;
																			break;
																		}
															else if (IfPressed(CalibrationPage4.CalibrateButton->x-5,CalibrationPage4.CalibrateButton->x+CalibrationPage4.CalibrateButton->width+5,CalibrationPage4.CalibrateButton->y-3,CalibrationPage4.CalibrateButton->y+CalibrationPage4.CalibrateButton->height))
																			{
																				ButtonPressed(CalibrationPage4.CalibrateButton);
																				flag=1;
																				CommandCode=UPDATE_ALL_CALIB;
																				break;
																			}
																			else	{
																							flag=0;
																							x1=PC_VOL1_BOX;
																							x2=PC_VOL5_BOX;
																							y1=PC_PROD5_BOX;
																							Xstart=PC_VOL1_BOX;
																							Xend=PC_PROD5_BOX;
																						}
											}	break;
					}
	if (!flag)				
			{
				if (IfPressed(CalibrationPage1.CalibSensors[x1].x-5,CalibrationPage1.CalibSensors[x2].x+CalibrationPage1.CalibSensors[x2].width,CalibrationPage1.CalibSensors[x1].y-10,CalibrationPage1.CalibSensors[y1].y+CalibrationPage1.CalibSensors[y1].height+5))
						{
							for (i=Xstart; i<=Xend;i++)
									{
											if (IfPressed(CalibrationPage1.CalibSensors[i].x-5,CalibrationPage1.CalibSensors[i].x+CalibrationPage1.CalibSensors[i].width+10,CalibrationPage1.CalibSensors[i].y-CalibrationPage1.CalibSensors[i].CaptionFont->Height,CalibrationPage1.CalibSensors[i].y+CalibrationPage1.CalibSensors[i].height))
													{
														Keyboard.Type=DIGIT;
														memset(Keyboard.RetVal,0,STRING_LENGHT);
														ShowKeyboard();
														KeyBoardProcess();
														if (CalibrationPage1.CalibSensors[i].Value)
																{
																	memset(CalibrationPage1.CalibSensors[i].Value,0,6);
																	strncpy(CalibrationPage1.CalibSensors[i].Value,Keyboard.RetVal,5);
																}
														WriteCalibParams(i,atof(CalibrationPage1.CalibSensors[i].Value));
													}
									}
						switch	(page)
										{
												case	1:	{	PageControl.ActivePage=CALIBRATE_PAGE1;	ShowCalibrationPage1();} 	break;
												case	2:	{	PageControl.ActivePage=CALIBRATE_PAGE1;	ShowCalibrationPage2();} 	break;
												case	3:	{	PageControl.ActivePage=CALIBRATE_PAGE1; ShowCalibrationPage3();} 	break;
												case	4:	{	PageControl.ActivePage=CALIBRATE_PAGE1;	ShowCalibrationPage4();} 	break;
										}
						}
			}
}
/*=========================================================================*/
void	ShowSetWnd		(uint8_t i,uint8_t iteration)
{
	uint8_t j;
	uint16_t y,z;
	
	switch(i){
						
						case  0:	{
												j=ShowListWnd(AdditionalPage.SettingsBoxes[i].x,AdditionalPage.SettingsBoxes[i].y,AdditionalPage.SettingsBoxes[i].width+15,2*AdditionalPage.SettingsBoxes[i].height,BLACK, 0xC600, ADCModes, 2, AdditionalPage.SettingsBoxes[i].Value,13,&AdditionalPage.SettingsBoxes[i].ItemIndex,6);
											} break;						 
						case	1:	{
												j=ShowListWnd(AdditionalPage.SettingsBoxes[i].x,AdditionalPage.SettingsBoxes[i].y,AdditionalPage.SettingsBoxes[i].width,4*AdditionalPage.SettingsBoxes[i].height,BLACK, 0xC600, ADCCng, 4, AdditionalPage.SettingsBoxes[i].Value,13,&AdditionalPage.SettingsBoxes[i].ItemIndex,6);
											}	break;
						case	4:	{
												j=ShowListWnd(AdditionalPage.SettingsBoxes[i].x,AdditionalPage.SettingsBoxes[i].y-AdditionalPage.SettingsBoxes[i].height,2*(AdditionalPage.SettingsBoxes[i].width+30),4*AdditionalPage.SettingsBoxes[i].height,BLACK, 0xC600, SSTypes, 5, AdditionalPage.SettingsBoxes[i].Value,13,&AdditionalPage.SettingsBoxes[i].ItemIndex,6);
											}	break;
						default:	{
												if	((i==2)||(i==3))
														j=ShowListWnd(AdditionalPage.SettingsBoxes[i].x,AdditionalPage.SettingsBoxes[i].y,2*(AdditionalPage.SettingsBoxes[i].width+20),4*AdditionalPage.SettingsBoxes[i].height,BLACK, 0xC600, DACCng, 7, AdditionalPage.SettingsBoxes[i].Value,13,&AdditionalPage.SettingsBoxes[i].ItemIndex,6);
											} break;
						}
}
/*=========================================================================*/	
void			AdditionalPageProcessing				(void)
{
	uint8_t i;
	
	for (i=0;i<5;i++)
				{
						if (IfPressed(AdditionalPage.SettingsBoxes[i].x,AdditionalPage.SettingsBoxes[i].x+AdditionalPage.SettingsBoxes[i].width,AdditionalPage.SettingsBoxes[i].y-16,AdditionalPage.SettingsBoxes[i].y+AdditionalPage.SettingsBoxes[i].height+10))
								{
									ShowSetWnd(i,0);
									DelayUS(100000);
									ShowAdditionalPage();
									break;
								}
				}
	if (IfPressed(AdditionalPage.SaveSetButton.x-10,AdditionalPage.SaveSetButton.x+AdditionalPage.SaveSetButton.width+10,AdditionalPage.SaveSetButton.y-15,AdditionalPage.SaveSetButton.y+AdditionalPage.SaveSetButton.height+15))
		{
			ButtonPressed(&AdditionalPage.SaveSetButton);
		}
}	
/*=========================================================================*/
uint8_t	NumInjects	(uint32_t Injects)
{
	uint8_t i;
	uint8_t n=0;
	
	for (i=0; i<=NUM_INJECTS;i++)	
			if (Injects&(1<<i))
					n++;
	return n;
}
/*=========================================================================*/
void	ShowAddListWnd	(uint16_t x, uint16_t y,uint16_t height,uint8_t** Names,uint8_t* CurrentName, uint8_t* quantity, uint8_t* ItemIndex,uint8_t MAX_N)
{
uint8_t i;

uint16_t y1;
uint16_t width;
uint16_t height1;	
uint8_t  n;


if (*quantity)
		{
			if (*quantity<4)
					{
						width=100;
						height1=(*quantity+1)*height;
						y1=y;	
					}
					else {
									if (*quantity<8)
											width=210;
											else if (*quantity<12)
															width=320;
											else if (*quantity<16)
																width=430;
									height1=4*height;
									y1=y+(*quantity+1)*height-4*height;	
							}	
			y1=y;
			TFT_DrawRect(x,y,width,height,3,BLACK);
			TFT_DrawRoundRectFilled(x+3,width-6,y+3,height1-6,0,0xC600);
			for (i=0;i<*quantity;i++)
					{
						TFT_Log(x+5,y+5,Names[i],0xC600, BLACK,&ARIAL10pt);
						if ((i==3)||(i==7)||(i==11))
								{	x=x+width-110; 
									y=y+(*quantity+1)*height-4*height;	
								}
								else
										y=y+height;
					}
		if (*quantity<MAX_N)
				TFT_Log(x+5,y+5,"...",0xC600, BLACK,&ARIAL10pt);
		if (*quantity<4)
				AddListSelectProcessing(x,width-5,y1,height1/(*quantity+1), quantity,MAX_N,ItemIndex,Names,CurrentName);
				else
						AddListSelectProcessing(x,width-110,y1, height1/4, quantity,MAX_N,ItemIndex,Names,CurrentName);
		}
		else
				{
					Keyboard.Type=RUSSIAN;
					memset(Keyboard.RetVal,0,STRING_LENGHT);
					ShowKeyboard();	
					KeyBoardProcess();
					if (strcmp(Keyboard.RetVal,""))
							{
								if (Names[*ItemIndex])
									{
										memset(Names[*ItemIndex],0,STRING_LENGHT);
										strncpy(Names[*ItemIndex],Keyboard.RetVal,STRING_LENGHT-1);
									}
								if	(CurrentName)
										{
											memset(CurrentName,0,STRING_LENGHT);
											strncpy(CurrentName,Keyboard.RetVal,STRING_LENGHT-1);
										}
							*quantity=*quantity+1;
							*ItemIndex=0;
							}
				 }
}
/*=========================================================================*/
void	AddListSelectProcessing	(uint16_t xstr, uint16_t width, uint16_t ystr, uint16_t height, uint8_t* N,uint8_t N_MAX,uint8_t* ItemIndex, uint8_t** Names,uint8_t* CurrentName)
{
uint8_t i,PROCESS=1;
uint16_t y=ystr;
uint16_t x=xstr;
uint8_t index;	
while	(PROCESS)	
		{
			if (Touchscreen.TOUCH)
				{
					xstr=x;
					ystr=y;
 					Touchscreen.TOUCH=0;
					for	(i=0;i<=*N;i++)
							{
								if (IfPressed(xstr,xstr+width, ystr,ystr+height))
										{
											*ItemIndex=i;
											PROCESS=0;
											break;
										}
								if ((i==3)||(i==7)||(i==11))
									{xstr=xstr+width;ystr=y;}	
									else
											ystr=ystr+height;
							}
					}
			}
index=*ItemIndex;

if 	(*N<=N_MAX)
	{
		if (*ItemIndex==*N)
			{
					Keyboard.Type=RUSSIAN;
					memset(Keyboard.RetVal,0,STRING_LENGHT);
					ShowKeyboard();	
					KeyBoardProcess();
					if (strcmp(Keyboard.RetVal,""))
						{
							if (Names[index])
									{
										memset(Names[index],0,STRING_LENGHT);
										strncpy(Names[index],Keyboard.RetVal,STRING_LENGHT-1);
									}
							if	(CurrentName)
									{
										memset(CurrentName,0,STRING_LENGHT);
										strncpy(CurrentName,Keyboard.RetVal,STRING_LENGHT-1);
									}
							*ItemIndex=*N;
							*N=*N+1;
						}
			}
			else
					{
						if(CurrentName)
							{
								memset(CurrentName,0,STRING_LENGHT);
								strncpy(CurrentName,Names[index],STRING_LENGHT-1);
							}
					}
	}
}
/*=========================================================================*/
void	ShowList	(uint16_t x,uint16_t width,uint16_t y,uint8_t **TextBuffer, uint16_t color, uint8_t R, uint8_t *ItemIndex, uint8_t N,uint16_t height)
{
	uint8_t 	i;
	uint16_t 	x1,y1;
	
	x1=x;
	y1=y;	


for (i=0;i<N; i++)
		{
			TFT_Log(x1+20,y1+3,TextBuffer[i],color,BLACK,&ARIAL10pt);
			if (*ItemIndex==i)
					TFT_DrawFilledCircleMy (x1+10, y1+R+5, R, BLACK);
					else 
						{
							TFT_DrawFilledCircleMy (x1+10, y1+R+5, R, color);
							TFT_DrawCircleMy(x1+10, y1+R+5, R, BLACK);
						}
			if ((i==3)||(i==7)||(i==11)||(i==15))
					{
						if (N<8)
								x1=x1+width;
						y1=y;
					}
					else
						{
							if (N<=4)
								y1=y1+height/N;
								else
										y1=y1+height/4;
						}
		}
}
/*=========================================================================*/
uint8_t	ShowListWnd	(uint16_t x, uint16_t y,uint16_t width, uint16_t height,uint16_t bordercolor, uint16_t color, uint8_t **TextBuffer,uint8_t N, uint8_t* CurrentName, uint8_t lenght,uint8_t* ItemIndex,uint8_t R)
{
uint8_t i=0,PROCESS=1;
uint16_t x1,y1,width1;
uint8_t len;
	
TFT_DrawRect(x,y,width,height,3,bordercolor);
TFT_DrawRoundRectFilled(x+3,width-6,y+3,height-6,0,color);	

if (N<=4)
		width1=width;
		else if (N<=8)
						width1=width/2;
		else if (N<=12)
						width1=width/3;
		else if (N<=16)
						width1=width/4;
ShowList(x,width1,y,TextBuffer,color, R, ItemIndex,N,height);			
while	(PROCESS)
			{
				x1=x;
				y1=y;
				if (Touchscreen.TOUCH)
						{
							Touchscreen.TOUCH=0;
							for(i=0;i<N;i++)
									{
										if ((i==4)||(i==8)||(i==12)||(i==16))
											{
												x1=x1+width1;
												y1=y;
											}
										if (IfPressed(x1,x1+width1,y1-10,y1+height/N-1))
												{
													PROCESS=0;
													break;
												}
												else
														y1=y1+height/N;
									}
						}
			}
*ItemIndex=i;
len=strlen(TextBuffer[i]);
ShowList(x,width1,y,TextBuffer,color, R, ItemIndex,N,height);
if (CurrentName)
		{
		  memset(CurrentName,0,lenght);
			if (len<=lenght)
					lenght=len;
			strncpy(CurrentName,TextBuffer[i],lenght);
		}
return i;
}
/*=========================================================================*/

						