#include	"GraphInterface.h"
#include	"TouchADS7843.h"
#include 	"SPI.h"
#include  "PanelGlobalVars.h"
/*=========================================================================*/
/*Touch Definitions*/
#define	NO_PRESSED	0
#define	PRESSED			1

#define	FONT_BIG		1
#define	FONT_SMALL	0
	
#define	AUTO_MODE_BUTTON	1
#define	HAND_MODE_BUTTON	2


#define	ALL_INJECTS				0
#define	LEFT_GROUP				1
#define	CENTRAL_GROUP			2
#define	RIGHT_GROUP				3

//Command Codes
#define	UPDATE_MODBUS_SETTINGS	1 
#define	UPDATE_ADC_SETTINGS			2 
#define	UPDATE_DAC1_SETTINGS		3
#define	UPDATE_DAC2_SETTINGS		4
#define	UPDATE_SS_SETTINGS			5
#define	UPDATE_PS_SETTINGS			6
#define	UPDATE_P_SETTINGS				0x0D
#define	UPDATE_LS_SETTINGS			7
#define	UPDATE_TS_SETTINGS			8
#define	UPDATE_PC_SETTINGS			9
#define	UPDATE_TC_SETTINGS			10
#define	SET_TC_SETTINGS					11
#define	UPDATE_ALL_CALIB				12
#define	SAVE_RECEIPT						0x14
#define	DELETE_RECEIPT					0x15
#define	SET_RECEIPT							0x16
#define	DELETE_ALL_RECEIPTS			0x17
#define	SAVE_ALL								0xff

/*=========================================================================*/
void			KeyPressed											(uint8_t i);
void			KeyBoardProcess									(void);
uint8_t		PageControlProcess							(void);
void			TouchInterface									(void);
char			IfPressed												(uint16_t x1, uint16_t x2, uint16_t y1, uint16_t y2);
void			ButtonPressed										(BUTTON*	Button);
void			ButtonImagePressed							(BUTTON* Btn);
void			TumblerPressed									(TUMBLER*	Tumbler);
void			RadioBtnPressed									(RADIO_BUTTON*	RBtn, uint8_t index);
void			InjectLedsPressed								(CIRCLE*	Leds,uint8_t	index);
uint8_t		NumInjects											(uint32_t Injects);
void			ShowAddListWnd									(uint16_t x, uint16_t y,uint16_t height,uint8_t**Names,uint8_t* CurrentName, uint8_t* quantity, uint8_t* ItemIndex,uint8_t MAX_N);
void			AddListSelectProcessing					(uint16_t xstr, uint16_t width, uint16_t ystr, uint16_t height, uint8_t* N,uint8_t N_MAX,uint8_t* ItemIndex, uint8_t** Names,uint8_t* CurrentName);
void			ShowList												(uint16_t x,uint16_t width, uint16_t y,uint8_t **TextBuffer, uint16_t color, uint8_t R, uint8_t *ItemIndex, uint8_t N,uint16_t height);
uint8_t		ShowListWnd											(uint16_t x, uint16_t y,uint16_t idth, uint16_t height,uint16_t bordercolor, uint16_t color, uint8_t **TextBuffer,uint8_t N, uint8_t* CurrentName, uint8_t lenght,uint8_t* ItemIndex,uint8_t R);
void			InjectSwitch										(uint8_t i,CIRCLE* Inject,uint32_t* InjectCng);
void			WriteTCParamtoSystemBoard				(uint8_t i, float value);
void			WriteReceiptParams							(void);
void			WriteCalibParamtoSystemBoard		(uint8_t index, float value);	
void			ControlPageProcessing						(void);				
void			ConfigPageProcessing						(void);					
void			CalibrationPageProcessing				(uint8_t	page);
void			ShowSetWnd											(uint8_t i, uint8_t iteration);
void			AdditionalPageProcessing				(void);		

